clear all
close all

global ep mu et th bt ga Ga1 Ga2 L N adjust_w adjust_la imax toler

ep=1.01;
mu=.34;
th=4;
et=0.48;

bt=.5;

adjust_w=.25; % update of the tatonnement process
adjust_la=.1; % update of the tatonnement process

Ga1=gamma(1+(1-ep)/th);

% gdp_type = 1; % output side
gdp_type = 0; % expenditure side

% load trade.txt
% load pwt.txt
% trade=load('trade_small.txt');
% pwt=load('pwt_small.txt');
trade=load('trade_small_RandD_2.txt');
pwt=load('pwt_small_RandD_2.txt');
temp=load('deflator.txt');
deflator=temp(:,2);
load RandD0.txt
load RandDT.txt

tt=(1962:2000)';
T=length(tt);
N=length(trade(:,1))^.5;

ii=trade(1:N,2);
iUS=find(trade(1:N,2)==87);
iKorea=find(trade(1:N,2)==47);
iChina=find(trade(1:N,2)==15);
iTaiwan=find(trade(1:N,2)==77);
iThailand=find(trade(1:N,2)==79);

pop=reshape(pwt(:,2),T,N)';
emp=reshape(pwt(:,3),T,N)';
hc=reshape(pwt(:,4),T,N)';
gdpr=reshape(pwt(:,6),T,N)'*1000;
% output-side
if gdp_type == 1
    gdpn=reshape(pwt(:,8).*pwt(:,13),T,N)'*1000;
    gdpr0=reshape(pwt(:,8),T,N)'*1000;
% expenditure-side 
else
    gdpn=reshape(pwt(:,14).*pwt(:,15),T,N)'*1000;
    gdpr0=reshape(pwt(:,14),T,N)'*1000;
end
k=reshape(pwt(:,7),T,N)'*1000;
gdpr0=reshape(pwt(:,8),T,N)'*1000;
k0=reshape(pwt(:,9),T,N)'*1000;
gdpr=gdpr.*(gdpr0(:,1)*ones(1,T))./(gdpr(:,1)*ones(1,T));
k=k.*(k0(:,1)*ones(1,T))./(k(:,1)*ones(1,T));

% L=k.^(1/3).*(pop.*hc).^(2/3);
L=k.^(1/3).*(emp.*hc).^(2/3);
L=L/L(iUS,1);
y=(gdpr/gdpr(iUS,1))./L;
% y=(gdpr)./L;
m_gdp=reshape(pwt(:,10),T,N)';
% p_data=reshape(pwt(:,13),T,N)';
p_data=gdpn./gdpr;

gUS=log(y(iUS,end)/y(iUS,1))/(T-1);

imp=reshape(trade(:,3),N,N)';
imp=imp./(sum(imp')'*ones(1,N));

% [b_TFP_RandD b_TFP_RandD_int temp temp stats]=regress(log(y(:,1)),[ones(40,1) RandD0]);
% y0=exp([ones(40,1) RandD0]*b_TFP_RandD);
% [b_TFP_RandD b_TFP_RandD_int temp temp stats]=regress(log(y(:,1)),[ones(40,1) RandD0 log(hc(:,1)) log(imp*y(:,1))]);
% y0=exp([ones(40,1) RandD0 log(hc(:,1)) log(imp*y(:,1)) ]*b_TFP_RandD);
% [b_TFP_RandD b_TFP_RandD_int temp temp stats]=regress(log(y(:,1)),[ones(40,1) log(hc(:,1)) log(imp*y(:,1))]);
% y0=exp([ones(40,1) log(hc(:,1)) log(imp*y(:,1)) ]*b_TFP_RandD);
%
% res0=y(:,1)./y0;
% L=L.*(res0*ones(1,T));
%
% L=L/L(iUS,1);
% ypred=(gdpr/gdpr(iUS,1))./L;
% ypred=y;

for t=1:T
    temp=reshape(trade(:,t+2),N,N)';
    % temp=tril(temp)+tril(temp)';
    for i=1:N
        
        for j=1:N
            
            if j==i
                
                PI_data(i,j)=(gdpn(i,t)/(1-et)-sum(temp(:,i)))...
                    /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));
                
            else
                
                PI_data(i,j)=temp(i,j)...
                    /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));
                
            end
            
        end
        
    end
    
    PI_t(:,t)=reshape(PI_data,N*N,1);
    
    for i=1:N
        im(i,t)=sum(temp(i,:));
        ex(i,t)=sum(temp(:,i));
        %         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z',0,1,[],imp(i,t)/gdpn(i,t));
        % m_E_data(i,t)=im(i,t)*deflator(t)/((im(i,t)-ex(i,t))*deflator(t)+gdpr(i,t)/(1-et));
        % m_E_data(i,t)=im(i,t)/((im(i,t)-ex(i,t))+gdpn(i,t)/(1-et));
        %         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_T',0,1,[],m_E_data(i,t));
        %         pi_ii_data(i,t)=((1-mu+mu*Z(i,t).^(1-(ep-1)/th))./(1-mu+mu*Z(i,t).^(-(ep-1)/th)));
        [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_pi',0,1,[],PI_data(i,i));
        pi_ii_data(i,t)=PI_data(i,i);
        %         Tb(i,t)=(im(i,t)-ex(i,t))*deflator(t)/gdpr(i,t);
        %        Tb(i,t)=0;
        %         T(i,t)=(im(i,t)-ex(i,t))*deflator(t)/sum(gdpr(:,t));
        %         Tr(i,t)=(im(i,t)-ex(i,t))/sum(gdpn(:,t));
        %         Trdollars(i,t)=(im(i,t)-ex(i,t));
    end
    
    PI_NT_t(:,t)=(1-mu)./(1-mu+mu*Z(:,t).^(-(ep-1)/th));
    
    
    PI_T=PI_data-diag(PI_NT_t(:,t));
    PI_T_t(:,t)=reshape(PI_T,N*N,1);
    
    Trdollars2(:,t)=inv(PI_data')*(gdpn(:,t)/(1-et)-PI_data'*gdpn(:,t)/(1-et));
    
    Trb(:,t)=Trdollars2(:,t)./gdpn(:,t);
    Tr(:,t)=Trdollars2(:,t)/sum(gdpn(:,t));
    
    K0=zeros(N,N);
    
    %  for i=1:N-1
    %
    %      for j=i+1:N
    %
    %          m(i,j)=temp(i,j)/im(i,t);
    %          m(j,i)=temp(j,i)/im(j,t);
    %
    %          K0(i,j)=(m(i,j)*m(j,i)...
    %              *((1-Z(i,t))/Z(i,t))*((1-Z(j,t))/Z(j,t)))^(-1/(2*th));
    %
    %      end
    %
    %  end
    %
    %
    % K=K0+K0'+eye(N);
    
    for i=1:N
        
        for j=1:i-1
            
            %          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
            %              *p_data(i,t)/p_data(j,t)...
            %              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));
            K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
                *p_data(i,t)/p_data(j,t)...
                *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));
            
        end
        
        for j=i+1:N
            
            %          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
            %              *p_data(i,t)/p_data(j,t)...
            %              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));
            K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
                *p_data(i,t)/p_data(j,t)...
                *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));
            
        end
        
    end
    
    K=K0+eye(N);
    
    KK(:,t)=reshape(K,N*N,1);
    
    % if t==1
    % [b_TFP_RandD b_TFP_RandD_int dummy dummy stats]=regress(log(y(:,t)),[ones(40,1) log(hc(:,t)) log(pi_ii_data(:,t)) log((temp./(sum(temp')'*ones(1,N)))*y(:,t))]);
    % y0=exp([ones(40,1) log(hc(:,t)) log(pi_ii_data(:,t)) log((temp./(sum(temp')'*ones(1,N)))*y(:,t)) ]*b_TFP_RandD);
    % log_y0_t(:,t)=[ones(40,1) log(hc(:,t)) log(pi_ii_data(:,t)) log((temp./(sum(temp')'*ones(1,N)))*y(:,t)) ]*b_TFP_RandD;
    %
    % R2(t)=stats(1);
    % b_0(:,t)=b_TFP_RandD;
    % b_low_0(:,t)=b_TFP_RandD_int(:,1);
    % b_high_0(:,t)=b_TFP_RandD_int(:,2);
    %
    % res0=y(:,t)./y0;
    % Lpred(:,t)=L(:,t).*res0;
    %
    % Lpred(:,t)=Lpred(:,t)/Lpred(iUS,1);
    % ypred(:,t)=(gdpr(:,t)/gdpr(iUS,1))./Lpred(:,t);
    %
    % elseif t>1 & t<T
    %
    % [b_TFP_RandD b_TFP_RandD_int dummy dummy stats]=regress(log(y(:,t+1)-log(y(:,t))),[ones(40,1) log(y(:,t)) log(hc(:,t)) log(pi_ii_data(:,t)) log((temp./(sum(temp')'*ones(1,N)))*y(:,t))]);
    % y0=exp([ones(40,1) log(y(:,t-1)) log(hc(:,t)) log(pi_ii_data(:,t)) log((temp./(sum(temp')'*ones(1,N)))*y(:,t)) ]*b_TFP_RandD);
    % log_y0_t(:,t)=[ones(40,1) log(y(:,t-1)) log(hc(:,t)) log(pi_ii_data(:,t)) log((temp./(sum(temp')'*ones(1,N)))*y(:,t)) ]*b_TFP_RandD;
    %
    % R2(t)=stats(1);
    % b_t(:,t)=b_TFP_RandD;
    % b_low_t(:,t)=b_TFP_RandD_int(:,1);
    % b_high_t(:,t)=b_TFP_RandD_int(:,2);
    %
    % res0=y(:,t)./y0;
    % Lpred(:,t)=L(:,t).*res0;
    %
    % Lpred(:,t)=Lpred(:,t)/Lpred(iUS,1);
    % ypred(:,t)=(gdpr(:,t)/gdpr(iUS,1))./Lpred(:,t);
    %
    % end
    
    if t==1
        
        [b_TFP_RandD b_TFP_RandD_int dummy dummy stats]=regress(log(y(:,1)),[ones(40,1) RandD0 log(hc(:,1)) log(pi_ii_data(:,t)) log((temp./(sum(temp')'*ones(1,N)))*y(:,t))]);
        y0=exp([ones(40,1) RandD0 log(hc(:,1)) log(pi_ii_data(:,t)) log((temp./(sum(temp')'*ones(1,N)))*y(:,t))]*b_TFP_RandD);
        
        res0=y(:,1)./y0;
        L=L.*(res0*ones(1,T));
        
        L=L/L(iUS,1);
        ypred=(gdpr/gdpr(iUS,1))./L;
        
        
        la0=ypred(:,1).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,1).^(-(ep-1)/th)).^(th/(ep-1)));
        
        la=la0;
        
    end
    
    lat_cal(:,t)=(ypred(:,t)/exp(gUS*(t-1))).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,t).^(-(ep-1)/th)).^(th/(ep-1)));
    
end


% figure(1)
% subplot(2,1,1),hist(log_y0_t(:,end)-log_y0_t(:,1)),axis([-.5 1 0 10])
% subplot(2,1,2),hist(log(y(:,end)./y(:,1))),axis([-.5 1 0 10])
% figure(2)
% plot(log(y(:,end)./y(:,1)),log_y0_t(:,end)-log_y0_t(:,1),'.')
%
% break

% dummy simulation

PI=reshape(PI_t(:,1),N,N);

bt=.5;

ga=gUS*(1-bt)*th;

Ga2=gamma(1-bt+(1-ep)/th);

al0=ga/(1-bt)*Ga1/Ga2*la...
    ./((1-mu)./(1-mu+mu*Z(:,1).^(-(ep-1)/th)).*la.^bt...
    +mu*Z(:,1).^(-(ep-1)/th)./(1-mu+mu*Z(:,1).^(-(ep-1)/th))...
    .*(Z(:,1).^(1-bt).*la.^bt+(1-Z(:,1)).^(1-bt)...
    .*(((PI-diag(diag(PI)))./(1-diag(PI)*ones(1,N))).^(1-bt)*la.^bt)));

al=al0;

la0t(:,1)=lat_cal(:,1);

for t=1:T
    L0=L(:,1);
    t
    % la=lat_cal(:,t);
    % K=reshape(KK(:,t),N,N);
    la=lat_cal(:,1);
    K=reshape(KK(:,1),N,N);
    
    pini=Ga1^(1/(1-ep)/(1-et))*(ones(N,1).^(-(1-et)*th)'*la)^(1/(1-et))*ones(N,1);
    
    if t==1
        toler=.0000001;
        imax=500;
        %     wini=gdpn(:,t)./L(:,t)/sum(gdpn(:,t));
        wini=ones(N,1);
        % [w_0(:,t) W,distdw,distZZ,ZZ]=wage_Tb(wini,K,la,L(:,t),Tb(i,t));
        [w_0(:,t) W,distdw,distZZ,ZZ]=wage_T(wini,K,la,L0,Tr(:,t));
        % toler=.000000001;
        % imax=300;
        % [w_s(:,t) W]=wage_NR(ones(N,1),K,la,L(:,1));
        p_0(:,t)=price(w_0(:,t),pini,K,la);
    else
        toler=.0001;
        imax=100;
        % w_0(:,t)=wage_Tb(w_0(:,t-1),K,la,L(:,t),Trb(:,t));
        w_0(:,t)=wage_T(w_0(:,t-1),K,la,L0,Tr(:,t));
        p_0(:,t)=price(w_0(:,t),p_0(:,t-1),K,la);
    end
    
    
    den0=(1-mu)*((p_0(:,t).^et.*w_0(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th)...
        +mu*(K.^-th*((p_0(:,t).^et.*w_0(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th);
    den=den0*ones(1,N);
    
    numT=mu*(((ones(N,1)*(p_0(:,t).^et.*w_0(:,t).^(1-et).*la.^(-1/th))').*K).^(-th))...
        .*((K.^-th*((p_0(:,t).^et.*w_0(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th-1)*ones(1,N));
    
    numNT=(1-mu)*((p_0(:,t).^et.*w_0(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th);
    
    piT=numT./den;
    
    piNT=numNT./den0;
    pi_ii_0(:,t)=piNT+diag(piT);
    
    al2=(lat_cal(:,1)-(1-ga/(1-bt))*lat_cal(:,1))*Ga1/Ga2...
        ./(piNT.*lat_cal(:,1).^bt+(piT*ones(N,1)).^bt.*(piT.^(1-bt)*lat_cal(:,1).^bt));
    
    la0t(:,t+1)=Ga2/Ga1*al.*(piNT.*la0t(:,t).^bt...
        +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*la0t(:,t).^bt))+(1-ga/(1-bt))*la0t(:,t);
    
end

% break

% "dynamics" of the static model

la=lat_cal(:,1);

for t=1:T
    
    %     la=la0*exp(ga/(1-bt)*(t-1));
    
    t
    K=reshape(KK(:,t),N,N);
    
    pini=Ga1^(1/(1-ep)/(1-et))*(ones(N,1).^(-(1-et)*th)'*la)^(1/(1-et))*ones(N,1);
    
    if t==1
        toler=.00001;
        imax=300;
        % w_s(:,t)=wage(ones(N,1),K,la,L(:,t));
        w_s(:,t)=wage_T(ones(N,1),K,la,L(:,t),Tr(:,t));
        % toler=.000000001;
        % imax=300;
        % [w_s(:,t) W]=wage_NR(ones(N,1),K,la,L(:,1));
        p_s(:,t)=price(w_s(:,t),pini,K,la);
    else
        toler=.0001;
        imax=100;
        % w_s(:,t)=wage(w_s(:,t-1),K,la,L(:,t));
        w_s(:,t)=wage_T(w_s(:,t-1),K,la,L(:,t),Tr(:,t));
        p_s(:,t)=price(w_s(:,t),p_s(:,t-1),K,la);
    end
    
    
    den0=(1-mu)*((p_s(:,t).^et.*w_s(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th)...
        +mu*(K.^-th*((p_s(:,t).^et.*w_s(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th);
    den=den0*ones(1,N);
    
    numT=mu*(((ones(N,1)*(p_s(:,t).^et.*w_s(:,t).^(1-et).*la.^(-1/th))').*K).^(-th))...
        .*((K.^-th*((p_s(:,t).^et.*w_s(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th-1)*ones(1,N));
    
    numNT=(1-mu)*((p_s(:,t).^et.*w_s(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th);
    
    piT=numT./den;
    
    piNT=numNT./den0;
    pi_ii=piNT+diag(piT);
    
    imp_s(:,t)=(1-pi_ii).*w_s(:,t).*L(:,t)/(1-et);
    
    y_s(:,t)=w_s(:,t).*L(:,t)./pop(:,t)./p_s(:,t);
    % y_s(:,t)=w_s(:,t)./p_d(:,t);
    
    pi_ii_s(:,t)=pi_ii;
    
end

TFP_Korea_s=w_s(iKorea,:)./p_s(iKorea,:);
% TFP_China_s=w_s(iChina,:)./p_s(iChina,:);
TFP_Taiwan_s=w_s(iTaiwan,:)./p_s(iTaiwan,:);
TFP_Thailand_s=w_s(iThailand,:)./p_s(iThailand,:);
TFP_US_s=w_s(iUS,:)./p_s(iUS,:);

TFP_Korea_true_s=(Ga1^(th/(ep-1))*la(iKorea)*(1-mu+mu*Z(iKorea,:).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
% TFP_China_true_s=(Ga1^(th/(ep-1))*la(iChina)*(1-mu+mu*Z(iChina,:).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
TFP_Taiwan_true_s=(Ga1^(th/(ep-1))*la(iTaiwan)*(1-mu+mu*Z(iTaiwan,:).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
TFP_Thailand_true_s=(Ga1^(th/(ep-1))*la(iThailand)*(1-mu+mu*Z(iThailand,:).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));

dpi_s=log(pi_ii_s(:,end)./pi_ii_s(:,1));
dTFP_s=log((w_s(:,end)./p_s(:,end))./(w_s(:,1)./p_s(:,1)));
% MSE_s=mean((log(y(:,39)./y(:,1)/exp(gUS*38))-dTFP_s).^2)^.5
MSE_s=mean((log(ypred(:,end)./ypred(:,1)/exp(gUS*(T-1)))-mean(log(ypred(:,end)./ypred(:,1)/exp(gUS*(T-1))))...
    -(dTFP_s-mean(dTFP_s))).^2)^.5

% break

gridbt=[0 .1 .25 .4 .5 .6 .75 .9];
% gridbt=[.5];

Lt=L(:,1);

for ibt=1:length(gridbt)
    
    PI=reshape(PI_t(:,1),N,N);
    
    bt=gridbt(ibt);
    
    ga=gUS*(1-bt)*th;
    
    Ga2=gamma(1-bt+(1-ep)/th);
    
    al0=ga/(1-bt)*Ga1/Ga2*la0...
        ./((1-mu)./(1-mu+mu*Z(:,1).^(-(ep-1)/th)).*la0.^bt...
        +mu*Z(:,1).^(-(ep-1)/th)./(1-mu+mu*Z(:,1).^(-(ep-1)/th))...
        .*(Z(:,1).^(1-bt).*la0.^bt+(1-Z(:,1)).^(1-bt)...
        .*(((PI-diag(diag(PI)))./(1-diag(PI)*ones(1,N))).^(1-bt)*la0.^bt)));
    
    % [balRandD]=regress(al0,[ones(40,1) RandD0]);
    [balRandD balRandD_int]=regress(al0,[ones(40,1) RandD0 log(hc(:,1))]);
%     [balRandD]=regress(al0,[ones(40,1) log(hc(:,1))]);
    
    al=al0;
    
    lat(:,1)=la0;
    lat_true(:,1)=la0;
    lat_lafixed(:,1)=la0;
    lat_pifixed(:,1)=la0;
    
    for t=1:T
        t
        if t==1
            al=al0;
        else
                    RandDt=RandD0*(T-t)/(T-1)+RandDT*(t-1)/(T-1);
                    al=[ones(40,1) RandDt log(hc(:,t))]*balRandD;
%             al=[ones(40,1) log(hc(:,t))]*balRandD;
        end
        
        PI_T=reshape(PI_T_t(:,t),N,N);
        
        la=lat(:,t);
        % la=lat_true(:,t);
        
        K=reshape(KK(:,t),N,N);
        
        pini=Ga1^(1/(1-ep)/(1-et))*(ones(N,1).^(-(1-et)*th)'*la)^(1/(1-et))*ones(N,1);
        
        toler=.0001;
        imax=100;
        if t==1
            % w_d1(:,t)=wage(w_s(:,t),K,la,L(:,t));
            w_d1(:,t)=wage_T(w_s(:,t),K,la,Lt(:,t),Tr(:,t));
            p_d1(:,t)=price(w_d1(:,t),pini,K,la);
        else
            % w_d1(:,t)=wage(w_d1(:,t-1),K,la,L(:,t));
            w_d1(:,t)=wage_T(w_d1(:,t-1),K,la,Lt(:,t),Tr(:,t));
            p_d1(:,t)=price(w_d1(:,t),p_d1(:,t-1),K,la);
        end
        
        den0=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th)...
            +mu*(K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th);
        den=den0*ones(1,N);
        
        numT=mu*(((ones(N,1)*(p_d1(:,t).^et.*w_d1(:,t).^(1-et).*la.^(-1/th))').*K).^(-th))...
            .*((K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th-1)*ones(1,N));
        
        numNT=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th);
        
        piT=numT./den;
        
        piNT=numNT./den0;
        pi_ii=piNT+diag(piT);
        
        if t==1
            temp=piNT.*la.^bt...
                +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*la.^bt);
            OmNT=piNT.*la.^bt./temp;
            OmT=((piT*ones(N,1)).^bt*(la.^bt)').*piT.^(1-bt)./(temp*ones(1,N));
            A=(1/((1-et)*th))*(1./(1-bt*(OmNT+diag(OmT))));
            piT_1=piT;
            piNT_1=piNT;
            pi_ii_1=pi_ii;
            la_1=la;
        end
        
        if t==T
            piT_T=piT;
            piNT_T=piNT;
            pi_ii_T=pi_ii;
            la_T=la;
        end
        
        % learning from sellers
        
        lat(:,t+1)=Ga2/Ga1*al.*(piNT.*lat(:,t).^bt...
            +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*lat(:,t).^bt))+(1-ga/(1-bt))*lat(:,t);
        
        if t<T
            TFP_la(:,t+1)=(Ga1^(th/(ep-1))*lat(:,t+1).*(1-mu+mu*Z(:,t+1).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
            
            Lt(:,t+1)=y(:,t+1)./TFP_la(:,t+1).*L(:,t+1);
        end
                
    end
    
    for i=1:N
        [Z_1(i,1)]=fminbnd('eq_Z',0,1,[],(1-pi_ii_1(i))/(1-et));
        [Z_T(i,1)]=fminbnd('eq_Z',0,1,[],(1-pi_ii_T(i))/(1-et));
    end
    
    TFP0_all(:,ibt)=(w_d1(:,1)./p_d1(:,1));
    TFPT_all(:,ibt)=(w_d1(:,end)./p_d1(:,end));
    
    dTFP_all(:,ibt)=log((w_d1(:,end)./p_d1(:,end))./(w_d1(:,1)./p_d1(:,1)));

    MSE(ibt)=mean((log(ypred(:,T)./ypred(:,1)/exp(gUS*(T-1)))-mean(log(ypred(:,T)./ypred(:,1)/exp(gUS*(T-1))))...
        -(dTFP_all(:,ibt)-mean(dTFP_all(:,ibt)))).^2)^.5;
        
end


% Lt=L(:,1);

for ibt=1:length(gridbt)
    
    PI=reshape(PI_t(:,1),N,N);
    
    bt=gridbt(ibt);
    
    ga=gUS*(1-bt)*th;
    
    Ga2=gamma(1-bt+(1-ep)/th);
    
    al0=ga/(1-bt)*Ga1/Ga2*la0...
        ./((1-mu)./(1-mu+mu*Z(:,1).^(-(ep-1)/th)).*la0.^bt...
        +mu*Z(:,1).^(-(ep-1)/th)./(1-mu+mu*Z(:,1).^(-(ep-1)/th))...
        .*(Z(:,1).^(1-bt).*la0.^bt+(1-Z(:,1)).^(1-bt)...
        .*(((PI-diag(diag(PI)))./(1-diag(PI)*ones(1,N))).^(1-bt)*la0.^bt)));
    
    % [balRandD]=regress(al0,[ones(40,1) RandD0]);
    [balRandD]=regress(al0,[ones(40,1) RandD0 log(hc(:,1))]);
%     [balRandD]=regress(al0,[ones(40,1) log(hc(:,1))]);
    
    al=al0;
    
    lat(:,1)=la0;
    
    for t=1:T
        t
        if t==1
            al=al0;
        else
                    RandDt=RandD0*(T-t)/(T-1)+RandDT*(t-1)/(T-1);
                    al=[ones(40,1) RandDt log(hc(:,t))]*balRandD;
%             al=[ones(40,1) log(hc(:,t))]*balRandD;
        end
        
        PI_T=reshape(PI_T_t(:,t),N,N);
        
        la=lat(:,t);
        % la=lat_true(:,t);
        
        K=reshape(KK(:,1),N,N);
        
        pini=Ga1^(1/(1-ep)/(1-et))*(ones(N,1).^(-(1-et)*th)'*la)^(1/(1-et))*ones(N,1);
        
        toler=.0001;
        imax=100;
        if t==1
            % w_d1(:,t)=wage(w_s(:,t),K,la,L(:,t));
            w_d1(:,t)=wage_T(w_s(:,t),K,la,Lt(:,t),Tr(:,t));
            p_d1(:,t)=price(w_d1(:,t),pini,K,la);
        else
            % w_d1(:,t)=wage(w_d1(:,t-1),K,la,L(:,t));
            w_d1(:,t)=wage_T(w_d1(:,t-1),K,la,Lt(:,t),Tr(:,t));
            p_d1(:,t)=price(w_d1(:,t),p_d1(:,t-1),K,la);
        end
        
        den0=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th)...
            +mu*(K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th);
        den=den0*ones(1,N);
        
        numT=mu*(((ones(N,1)*(p_d1(:,t).^et.*w_d1(:,t).^(1-et).*la.^(-1/th))').*K).^(-th))...
            .*((K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th-1)*ones(1,N));
        
        numNT=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th);
        
        piT=numT./den;
        
        piNT=numNT./den0;
        pi_ii=piNT+diag(piT);
        
        if t==1
            temp=piNT.*la.^bt...
                +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*la.^bt);
            OmNT=piNT.*la.^bt./temp;
            OmT=((piT*ones(N,1)).^bt*(la.^bt)').*piT.^(1-bt)./(temp*ones(1,N));
            A=(1/((1-et)*th))*(1./(1-bt*(OmNT+diag(OmT))));
            piT_1=piT;
            piNT_1=piNT;
            pi_ii_1=pi_ii;
            la_1=la;
        end
        
        if t==T
            piT_T=piT;
            piNT_T=piNT;
            pi_ii_T=pi_ii;
            la_T=la;
        end
        
        % learning from sellers
        
        lat(:,t+1)=Ga2/Ga1*al.*(piNT.*lat(:,t).^bt...
            +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*lat(:,t).^bt))+(1-ga/(1-bt))*lat(:,t);
        
        %     if t<T
        % TFP_la(:,t+1)=(Ga1^(th/(ep-1))*lat(:,t+1).*(1-mu+mu*Z(:,t+1).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
        %
        % Lt(:,t+1)=y(:,t+1)./TFP_la(:,t+1).*L(:,t+1);
    end
    
    

dTFP_d1(:,ibt)=log((w_d1(:,end)./p_d1(:,end))./(w_d1(:,1)./p_d1(:,1)));

    TFP0_k0(:,ibt)=(w_d1(:,1)./p_d1(:,1));
    TFPT_k0(:,ibt)=(w_d1(:,end)./p_d1(:,end));

MSE_fixed_K(ibt)=mean((log(ypred(:,T)./ypred(:,1)/exp(gUS*(T-1)))-mean(log(ypred(:,T)./ypred(:,1)/exp(gUS*(T-1))))...
    -(dTFP_d1(:,ibt)-mean(dTFP_d1(:,ibt)))).^2)^.5;

MSE_fixed_K2(ibt)=mean((dTFP_all(:,ibt)-mean(dTFP_all(:,ibt))...
    -(dTFP_d1(:,ibt)-mean(dTFP_d1(:,ibt)))).^2)^.5;

end

for ibt=1:length(gridbt)
    
    PI=reshape(PI_t(:,1),N,N);
    
    bt=gridbt(ibt);
    
    ga=gUS*(1-bt)*th;
    
    Ga2=gamma(1-bt+(1-ep)/th);
    
    al0=ga/(1-bt)*Ga1/Ga2*la0...
        ./((1-mu)./(1-mu+mu*Z(:,1).^(-(ep-1)/th)).*la0.^bt...
        +mu*Z(:,1).^(-(ep-1)/th)./(1-mu+mu*Z(:,1).^(-(ep-1)/th))...
        .*(Z(:,1).^(1-bt).*la0.^bt+(1-Z(:,1)).^(1-bt)...
        .*(((PI-diag(diag(PI)))./(1-diag(PI)*ones(1,N))).^(1-bt)*la0.^bt)));
    
    % [balRandD]=regress(al0,[ones(40,1) RandD0]);
    [balRandD]=regress(al0,[ones(40,1) RandD0 log(hc(:,1))]);
%     [balRandD]=regress(al0,[ones(40,1) log(hc(:,1))]);
    
    al=al0;
    
    lat(:,1)=la0;
    
    for t=1:T
        t
        if t==1
            al=al0;
        else
                    RandDt=RandD0*(T-t)/(T-1)+RandDT*(t-1)/(T-1);
                    al=[ones(40,1) RandDt log(hc(:,t))]*balRandD;
%             al=[ones(40,1) log(hc(:,t))]*balRandD;
        end
        
        PI_T=reshape(PI_T_t(:,t),N,N);
        
        la=lat(:,t);
        % la=lat_true(:,t);
        
        K=reshape(KK(:,t),N,N);
        
        pini=Ga1^(1/(1-ep)/(1-et))*(ones(N,1).^(-(1-et)*th)'*la)^(1/(1-et))*ones(N,1);
        
        toler=.0001;
        imax=100;
        if t==1
            % w_d1(:,t)=wage(w_s(:,t),K,la,L(:,t));
            w_d1(:,t)=wage_T(w_s(:,t),K,la,Lt(:,t),Tr(:,t));
            p_d1(:,t)=price(w_d1(:,t),pini,K,la);
        else
            % w_d1(:,t)=wage(w_d1(:,t-1),K,la,L(:,t));
            w_d1(:,t)=wage_T(w_d1(:,t-1),K,la,Lt(:,t),Tr(:,t));
            p_d1(:,t)=price(w_d1(:,t),p_d1(:,t-1),K,la);
        end
        
        den0=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th)...
            +mu*(K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th);
        den=den0*ones(1,N);
        
        numT=mu*(((ones(N,1)*(p_d1(:,t).^et.*w_d1(:,t).^(1-et).*la.^(-1/th))').*K).^(-th))...
            .*((K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th-1)*ones(1,N));
        
        numNT=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th);
        
        piT=numT./den;
        
        piNT=numNT./den0;
        pi_ii=piNT+diag(piT);
        
        if t==1
            temp=piNT.*la.^bt...
                +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*la.^bt);
            OmNT=piNT.*la.^bt./temp;
            OmT=((piT*ones(N,1)).^bt*(la.^bt)').*piT.^(1-bt)./(temp*ones(1,N));
            A=(1/((1-et)*th))*(1./(1-bt*(OmNT+diag(OmT))));
            piT_1=piT;
            piNT_1=piNT;
            pi_ii_1=pi_ii;
            la_1=la;
        end
        
        if t==T
            piT_T=piT;
            piNT_T=piNT;
            pi_ii_T=pi_ii;
            la_T=la;
        end
        
        % learning from sellers
        
        lat(:,t+1)=Ga2/Ga1*al0.*(piNT.*lat(:,t).^bt...
            +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*lat(:,t).^bt))+(1-ga/(1-bt))*lat(:,t);
        
        %     if t<T
        % TFP_la(:,t+1)=(Ga1^(th/(ep-1))*lat(:,t+1).*(1-mu+mu*Z(:,t+1).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
        %
        % Lt(:,t+1)=y(:,t+1)./TFP_la(:,t+1).*L(:,t+1);
    end
    
    

dTFP_d1(:,ibt)=log((w_d1(:,end)./p_d1(:,end))./(w_d1(:,1)./p_d1(:,1)));

TFP0_al0(:,ibt)=(w_d1(:,1)./p_d1(:,1));
TFPT_al0(:,ibt)=(w_d1(:,end)./p_d1(:,end));

MSE_fixed_al(ibt)=mean((log(ypred(:,T)./ypred(:,1)/exp(gUS*(T-1)))-mean(log(ypred(:,T)./ypred(:,1)/exp(gUS*(T-1))))...
    -(dTFP_d1(:,ibt)-mean(dTFP_d1(:,ibt)))).^2)^.5;

MSE_fixed_al2(ibt)=mean((dTFP_all(:,ibt)-mean(dTFP_all(:,ibt))...
    -(dTFP_d1(:,ibt)-mean(dTFP_d1(:,ibt)))).^2)^.5;

end

% save trans_beta_s MSE_s dpi_s dTFP_s MSE dpi_d1 dTFP_d1
% save trans_beta_s2 MSE_s dpi_s dTFP_s MSE MSE_true dpi_d1 dTFP_d1 ...
%     TFP_Korea_s TFP_China_s TFP_Taiwan_s TFP_Thailand_s TFP_US_s ...
%     TFP_Korea_d TFP_China_d TFP_Taiwan_d TFP_Thailand_d TFP_US_d ...
%     TFP0 TFP_static TFP_fixed_la TFP_fixed_pi
% save trans_beta_s4 MSE_s dpi_s dTFP_s MSE MSE_true dpi_d1 dTFP_d1 ...
%     TFP_Korea_s TFP_China_s TFP_Taiwan_s TFP_Thailand_s TFP_US_s ...
%     TFP_Korea_d TFP_China_d TFP_Taiwan_d TFP_Thailand_d TFP_US_d ...
%     TFP0 TFP_static TFP_fixed_la TFP_fixed_pi

% save trans_beta_s4_th_4 MSE_s dpi_s dTFP_s MSE MSE_true dpi_d1 dTFP_d1 ...
%     TFP_Korea_s TFP_China_s TFP_Taiwan_s TFP_Thailand_s TFP_US_s ...
%     TFP_Korea_d TFP_China_d TFP_Taiwan_d TFP_Thailand_d TFP_US_d ...
%     TFP0 TFP_static TFP_fixed_la TFP_fixed_pi

% std_y=std(log(ypred(:,end)./ypred(:,1)/exp(gUS*(T-1))));
% 
% plot(gridbt,MSE/std_y,0,MSE_s/std_y,'o')
% axis([0 1 .8 1])

V0011=var(log(TFPT_all./TFP0_all));
V0001=var(log(TFPT_al0./TFP0_all));
V0111=var(log(TFPT_all./TFPT_al0));
V0010=var(log(TFPT_k0./TFP0_all));
V1011=var(log(TFPT_all./TFPT_k0));

figure(1)
subplot(1,2,1),plot(gridbt,mean(log(TFPT_all./TFPT_k0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*gUS),'r--', ...
    gridbt,mean(log(TFPT_al0./TFP0_al0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*gUS),'b','LineWidth',2)
axis([0 1 0 .5])
xlabel('$\beta$','Interpreter','LaTex')
title('\textbf{World Growth}','FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
ylabel('Fraction explained by trade')
LEG=legend('$\alpha$ varying','$\alpha$ constant','Location','NorthWest');
legend boxoff
set(LEG,'Interpreter','LaTex')
subplot(1,2,2),plot(gridbt,1-V0010./V0011,'r--' ...
    ,gridbt,1-V0111./V0011,'b-' ...
    , gridbt,V1011./V0011,'r--s' ...
    ,gridbt,V0001./V0011,'b-s','LineWidth',2)
axis([0 1 0 .5])
% title('learning from sellers','FontSize',11)
LEG=legend('$\alpha$ varying, incl. cov.' ...
 ,'$\alpha$ constant, incl. cov.' ...
 ,'$\alpha$ varying, excl. cov.' ...
,'$\alpha$ constant, excl. cov.','Location','SouthEast');
legend boxoff
set(LEG,'Interpreter','LaTex')
xlabel('$\beta$','Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
title('\textbf{Cross-Sectional Variance}','FontSize',14,'Interpreter','LaTex')

set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.
set(gca,'FontSize',12)
