% Anu: perhaps easiest way to change code for nontradables case is to
% change mu to one in relevent sections
% and then deal with non0tradables and tradables seperately?




clear all
close all

global ep mu et th bt ga Ga1 Ga2 L N adjust_w adjust_la imax toler B

ep=1.01;
% case where non-tradables does not learn
mu = 1;
th=4;
% et=0.5;
et=0.48;

bt=.5;

% up=.5;
up=1-.34;

adjust_w=.25; % update of the tatonnement process
adjust_la=.1; % update of the tatonnement process

Ga1=gamma(1+(1-ep)/th);

fun = @(t) t.^(-(ep - 1)./(th)) .* exp(-t);
B_temp = integral(fun, 0, Inf);
fun2 = @(t) t.^(-ep./th) .* exp(-t);
B_temp2 = integral(fun2, 0, Inf);
B = B_temp./B_temp2;

% gdp_type = 1; % output side
gdp_type = 0; % expenditure side


% load trade.txt
% load pwt.txt
% trade=load('trade_small.txt');
% pwt=load('pwt_small.txt');
% trade=load('trade_small_2.txt');
% pwt=load('pwt_small_2.txt');
trade=load('trade_small_3.txt');
pwt=load('pwt_small_3.txt');
temp=load('deflator.txt');
deflator=temp(:,2);

tt=(1962:2000)';
T=length(tt);
N=length(trade(:,1))^.5;

% get indices corresponding to following countries in ii
ii=trade(1:N,2);
iUS=find(trade(1:N,2)==87);
iKorea=find(trade(1:N,2)==47);
iChina=find(trade(1:N,2)==15);
iTaiwan=find(trade(1:N,2)==77);
iThailand=find(trade(1:N,2)==79);

% create [T,N] matrix for each variable in pwt
pop=reshape(pwt(:,2),T,N)';
emp=reshape(pwt(:,3),T,N)';
hc=reshape(pwt(:,4),T,N)';
gdpr=reshape(pwt(:,6),T,N)'*1000;
% output-side
if gdp_type == 1
    gdpn=reshape(pwt(:,8).*pwt(:,13),T,N)'*1000 ;
    gdpr0=reshape(pwt(:,8),T,N)'*1000;
% expenditure-side 
else
    gdpn=reshape(pwt(:,14).*pwt(:,15),T,N)'*1000 ;
    gdpr0=reshape(pwt(:,14),T,N)'*1000;
end
k=reshape(pwt(:,7),T,N)'*1000;
k0=reshape(pwt(:,9),T,N)'*1000;
gdpr=gdpr.*(gdpr0(:,1)*ones(1,T))./(gdpr(:,1)*ones(1,T));
k=k.*(k0(:,1)*ones(1,T))./(k(:,1)*ones(1,T));

% measure of equipped labor normalized by US
% L=k.^(1/3).*(pop.*hc).^(2/3);
% L=k.^(1/3).*(emp.*hc).^(2/3);
ze = 0.36;
L=k.^(ze).*(emp.*hc).^(1 - ze);

L=L/L(iUS,1);

% Real GDP per Capita normalized by US in 1962
y=(gdpr/gdpr(iUS,1))./L;
% y=(gdpr)./L;
w_data = gdpn./L;

% share of merchandixe imports at current PPP
m_gdp=reshape(pwt(:,10),T,N)';

% price level
% p_data=reshape(pwt(:,13),T,N)';
p_data=gdpn./gdpr;

% US real gdp growth
gUS=log(y(iUS,end)/y(iUS,1))/(T-1);

% Price level of imports
p_Ii = reshape(pwt(:,18),T,N)';

y_T=(w_data./p_Ii/(gdpr(iUS,1)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                calculate trade shares and trade costs                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for t=1:T
    temp=reshape(trade(:,t+2),N,N)';
%     temp=reshape(trade(:,t+2),N,N)'*deflator(t);
    % temp=tril(temp)+tril(temp)';
    


       
    % calculate trade shares
    for i=1:N
        
       
        for j=1:N
            
            if j==i
                % [(gdpn of country i - sum exports of country i)/
                % (sum imports of country i + gdpn of country i - sum exports of country i)]
                
                PI_data(i,j)=(gdpn(i,t)/(1-et)-sum(temp(:,i)))...
                    /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));
                
            else
                % [(imports to country i from country j)/
                % (sum imports of country i + gdpn of country i - sum exports of country i)]
                PI_data(i,j)=temp(i,j)...
                    /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));
                
            end
            
        end
        
    end
    
    % reshape and store trade shares for each time period
    PI_t(:,t)=reshape(PI_data,N*N,1);
    
    for i=1:N
        % imports, imports/gdpn, exports of country i
        im(i,t)=sum(temp(i,:));
        im_gdpn(i,t)=sum(temp(i,:))/gdpn(i,t);        
        ex(i,t)=sum(temp(:,i));
                
        
        %         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z',0,1,[],imp(i,t)/gdpn(i,t));
        % m_E_data(i,t)=im(i,t)*deflator(t)/((im(i,t)-ex(i,t))*deflator(t)+gdpr(i,t)/(1-et));
        % m_E_data(i,t)=im(i,t)/((im(i,t)-ex(i,t))+gdpn(i,t)/(1-et));
        %         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_T',0,1,[],m_E_data(i,t));
        %         pi_ii_data(i,t)=((1-mu+mu*Z(i,t).^(1-(ep-1)/th))./(1-mu+mu*Z(i,t).^(-(ep-1)/th)));
        
        % Approximate Z(i,t), tradables own share
        [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_pi',0,1,[],PI_data(i,i));
        
        % own  share from data
        pi_ii_data(i,t)=PI_data(i,i);
        
        
        %         Tb(i,t)=(im(i,t)-ex(i,t))*deflator(t)/gdpr(i,t);
        %        Tb(i,t)=0;
        %         T(i,t)=(im(i,t)-ex(i,t))*deflator(t)/sum(gdpr(:,t));
        %         Tr(i,t)=(im(i,t)-ex(i,t))/sum(gdpn(:,t));
        %         Trdollars(i,t)=(im(i,t)-ex(i,t));
    end
    
    % share of country i's spending on non-tradable goods
    PI_NT_t(:,t)=(1-mu)./(1-mu+mu*Z(:,t).^(-(ep-1)/th));
    
    %share of country i's tradable spending on goods from country j
    PI_T=PI_data-diag(PI_NT_t(:,t));
    PI_T_t(:,t)=reshape(PI_T,N*N,1);
    
    Trdollars2(:,t)=inv(PI_data')*(gdpn(:,t)/(1-et)-PI_data'*gdpn(:,t)/(1-et));
    
    Trb(:,t)=Trdollars2(:,t)./gdpn(:,t);
    Tr(:,t)=Trdollars2(:,t)/sum(gdpn(:,t));
    
    K0=zeros(N,N);
    
    %  for i=1:N-1
    %
    %      for j=i+1:N
    %
    %          m(i,j)=temp(i,j)/im(i,t);
    %          m(j,i)=temp(j,i)/im(j,t);
    %
    %          K0(i,j)=(m(i,j)*m(j,i)...
    %              *((1-Z(i,t))/Z(i,t))*((1-Z(j,t))/Z(j,t)))^(-1/(2*th));
    %
    %      end
    %
    %  end
    %
    %
    % K=K0+K0'+eye(N);
    
    % calculate iceberg trade costs (See Section 4.2)
    for i=1:N
        
%         for j=1:i-1
%             
%             %          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%             %              *p_data(i,t)/p_data(j,t)...
%             %              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1))
%             K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%                 *p_data(i,t)/p_data(j,t)...
%                 *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));
%         end
%         
%         for j=i+1:N
%             
%             %          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%             %              *p_data(i,t)/p_data(j,t)...
%             %              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));
%             K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%                 *p_data(i,t)/p_data(j,t)...
%                 *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));
%             
%         end
        for j = 1:N
            K0(i,j) = (p_Ii(i,t)./p_Ii(j,t)) .* (PI_data(j,j)./PI_data(i,j)).^(1./th); 
        end
    end
    
%     K=K0+eye(N);

    K = K0;
    
    KK(:,t)=reshape(K,N*N,1);
    
    
    if t==1
        
%         la0 = B^(th) .* (w_data(:,1)./(p_Ii(:,1))).^(th * (1 - et)).* (pi_ii_data(:,1));
        la0 = B^(th) .* (y_T(:,1)).^(th * (1 - et)).* (pi_ii_data(:,1));
        %la0=y(:,1).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,1).^(-(ep-1)/th)).^(th/(ep-1)));
        la=la0;
                
    end
        
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               calibration of \alpha_{it} using calibrated              %
%              trade cost matrix and sequence of lambda_{it}             % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% calibrate using various values of beta
gridbt=[0 .1 .25 .4 .5 .6 .7 .75 .9 .95];

for ibt=1:length(gridbt)

bt=gridbt(ibt);

Ga2=gamma(1-bt+(1-ep)/th);

% calculate stock of knowledge
% la_temp(:,1)=(y(:,1)).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,t).^(-(ep-1)/th)).^(th/(ep-1)));
% la_temp(:,1) = B^(th) .* (w_data(:,1)./p_Ii(:,1)).^(th * (1 - et)).* (pi_ii_data(:,1));
la_temp(:,1) = B^(th) .* (y_T(:,1)).^(th * (1 - et)).* (pi_ii_data(:,1));
la_temp2(:,1)=la_temp(:,1);



for t=1:T-1
    
    PI=reshape(PI_t(:,t),N,N);
    PI_T=reshape(PI_T_t(:,t),N,N);
    
    % calculate stock of knowledge and alpha using law of motion for US
    % la_temp(:,t+1)=(y(:,t+1)).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,t+1).^(-(ep-1)/th)).^(th/(ep-1)));
%     la_temp(:,t+1) = B^(th) .* (w_data(:,t+1)./p_Ii(:,t+1)).^(th * (1 - et)).* (pi_ii_data(:,t+1));
    la_temp(:,t+1) = B^(th) .* (y_T(:,t+1)).^(th * (1 - et)).* (pi_ii_data(:,t+1));
    la_temp2(:,t+1)=la_temp(:,t+1);
    
    alUS(t)=max(0,(la_temp(iUS,t+1)-la_temp2(iUS,t)) ...
        /(Ga2/Ga1)./(PI_NT_t(iUS,t).*la_temp2(iUS,t).^bt...
        +(PI_T(iUS,:)*ones(N,1)).^bt.*(PI_T(iUS,:).^(1-bt)*la_temp2(:,t).^bt)));
    
    la_temp2(iUS,t+1)=Ga2/Ga1*alUS(t).*(PI_NT_t(iUS,t).*la_temp2(iUS,t).^bt...
        +(PI_T(iUS,:)*ones(N,1)).^bt.*(PI_T(iUS,:).^(1-bt)*la_temp2(:,t).^bt))+la_temp2(iUS,t);
    
    
end


ga_high=.1;
ga_low=.0;
ga=.5*ga_low+.5*ga_high;

PI=reshape(PI_t(:,1),N,N);
PI_T=reshape(PI_T_t(:,1),N,N);

% approximate growth rate of arrival of ideas
for i=1:15
    

alUS0=(ga/(1-bt)*la_temp(iUS,1)) ...
    /(Ga2/Ga1*(PI_NT_t(iUS,1).*la_temp(iUS,1).^bt...
    +(PI_T(iUS,:)*ones(N,1)).^bt.*(PI_T(iUS,:).^(1-bt)*la_temp(:,1).^bt)));

ganew=log(alUS(end)/alUS0)/(T-1);
diff=abs(ga-ganew);

[i ga ganew diff ga_low ga_high]

if ganew>ga
   ga_low=ga;
ga=.5*ga_low+.5*ga_high;
else
   ga_high=ga;
ga=.5*ga_low+.5*ga_high;    
end


end

ga_bt(ibt)=ga;

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                             simulations                                % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

PI=reshape(PI_t(:,1),N,N);

% gridbt=[0];

Lt=L(:,1);

TFP_la=y(:,1);



% simulate for various values of beta
for ibt=1:length(gridbt)
    
    PI=reshape(PI_t(:,1),N,N);
    
    bt=gridbt(ibt);
    
%     ga=gUS*(1-bt)*th;
    
    % pull gamma from previously calibrated values
    ga=ga_bt(ibt);
    gUS_bt(ibt)=ga/(th*(1-bt));

    Ga2=gamma(1-bt+(1-ep)/th);
    
    % calculate initial alpha
    al0=ga/(1-bt)*Ga1/Ga2*la0...
        ./((1-mu)./(1-mu+mu*Z(:,1).^(-(ep-1)/th)).*la0.^bt...
        +mu*Z(:,1).^(-(ep-1)/th)./(1-mu+mu*Z(:,1).^(-(ep-1)/th))...
        .*(Z(:,1).^(1-bt).*la0.^bt+(1-Z(:,1)).^(1-bt)...
        .*(((PI-diag(diag(PI)))./(1-diag(PI)*ones(1,N))).^(1-bt)*la0.^bt)));
    
    % calculate initial lambda
    lat(:,1)=la0;
    
    % lat_cal(:,1)=(y(:,t)).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,t).^(-(ep-1)/th)).^(th/(ep-1)));
%     lat_cal(:,1) = B^(th) .* (w_data(:,t)./p_Ii(:,t)).^(th * (1 - et)).* (pi_ii_data(:,t));
%     Ani(:,1) = ((w_data(:,t)./ p_data(:,t)).*(p_Ii(:,t)./p_data(:,t)).^((1 - al0)./al0)) ./ (al0.*((1 - al0).^((1-al0)./al0)));    
    lat_cal(:,1) = B^(th) .* (y_T(:,t)).^(th * (1 - et)).* (pi_ii_data(:,t));
    Ani(:,1) = ((y(:,t)).*(p_Ii(:,t)./p_data(:,t)).^((1 - up)./up)) ./ (up.*((1 - up).^((1-up)./up)));    

    
    
    % 
    numsims = 4;

        for s = 1:numsims
        % s = 1: dummy simulation
        % s = 2: holding kappa_{ij,t} = kappa{ij,1}
        % s = 3: holding alpha_{ij,t} = alpha{i0}  
        % s = 4: ?

        if s == 3
            lat(:,1)=la0;
            lat_lafixed(:,1)=la0;
            lat_pifixed(:,1)=la0;
        end

        for t=1:T

            PI_T=reshape(PI_T_t(:,t),N,N);

            la=lat(:,t);
            % la=lat_true(:,t);

            if s == 2 
                % holding kappa_{ij,t} = kappa{ij,1}
                K=reshape(KK(:,1),N,N);
            else
                K=reshape(KK(:,t),N,N);
            end

            % initial price index
            pini=Ga1^(1/(1-ep)/(1-et))*(ones(N,1).^(-(1-et)*th)'*la)^(1/(1-et))*ones(N,1);

            toler=.0001;
            imax=100;

            % approximate wage and price
            if t==1
                % w_d1(:,t)=wage(w_s(:,t),K,la,L(:,t));
                w_d1(:,t)=wage_T(ones(N,1),K,la,Lt(:,t),Tr(:,t));
                p_d1(:,t)=price(w_d1(:,t),pini,K,la);
            else
                % w_d1(:,t)=wage(w_d1(:,t-1),K,la,L(:,t));
                w_d1(:,t)=wage_T(w_d1(:,t-1),K,la,Lt(:,t),Tr(:,t));
                p_d1(:,t)=price(w_d1(:,t),p_d1(:,t-1),K,la);
            end

            % calculate own trade share
            den0=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th)...
                +mu*(K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th);
            den=den0*ones(1,N);

            numT=mu*(((ones(N,1)*(p_d1(:,t).^et.*w_d1(:,t).^(1-et).*la.^(-1/th))').*K).^(-th))...
                .*((K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th-1)*ones(1,N));

            numNT=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th);

            piT=numT./den;

            piNT=numNT./den0;
            pi_ii=piNT+diag(piT);

            if t==1
                temp=piNT.*la.^bt...
                    +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*la.^bt);
                OmNT=piNT.*la.^bt./temp;
                OmT=((piT*ones(N,1)).^bt*(la.^bt)').*piT.^(1-bt)./(temp*ones(1,N));
                A=(1/((1-et)*th))*(1./(1-bt*(OmNT+diag(OmT))));
                % tradables own share
                piT_1=piT;
                % non-tradables share
                piNT_1=piNT;
                % own trade share
                pi_ii_1=pi_ii;
                % lambda_{it}
                la_1=la;
            end

            if t==T
                % tradables own share
                piT_T=piT;
                % non-tradables share
                piNT_T=piNT;
                % own trade share
                pi_ii_T=pi_ii;
                % lambda_{it}
                la_T=la;
            end
            
            
            % learning from sellers
            if t<T
                if s == 1
                    
                    % Why?
                    % if t==0%1
                    if t==1
                        
                        al_t(:,t)=al0;

                    else
                        
                        % lat_cal(:,t+1)=(y(:,t+1)/exp(gUS_bt(ibt)*(t-1))).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,t).^(-(ep-1)/th)).^(th/(ep-1)));
%                         lat_cal(:,t+1) = B^(th) .* (w_data(:,t+1)./(p_Ii(:,t+1))).^(th * (1 - et)).* (pi_ii_data(:,t+1));
                        lat_cal(:,t+1) = B^(th) .* (y_T(:,t+1)).^(th * (1 - et)).* (pi_ii_data(:,t+1));
                                             
                        al_t(:,t)=max(0,(lat_cal(:,t+1)-(1-ga/(1-bt))*lat(:,t)) ...
                            /(Ga2/Ga1)./(piNT.*lat(:,t).^bt...
                            +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*lat(:,t).^bt)));
                     
                    end
                    
                    lat(:,t+1)=Ga2/Ga1*al_t(:,t).*(piNT.*lat(:,t).^bt...
                        +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*lat(:,t).^bt))+(1-ga/(1-bt))*lat(:,t);
                    

                    TFP_la(:,t+1)=(Ga1^(th/(ep-1))*lat(:,t+1).*(1-mu+mu*Z(:,t+1).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));

                    Lt(:,t+1)=y(:,t+1)./TFP_la(:,t+1).*L(:,t+1);
                    
                elseif s == 3
                    
                    lat(:,t+1)=Ga2/Ga1*al0.*(piNT.*lat(:,t).^bt...
                    +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*lat(:,t).^bt))+(1-ga/(1-bt))*lat(:,t);

                    lat_lafixed(:,t+1)=Ga2/Ga1*al0.*(piNT.*lat_lafixed(:,t).^bt...
                    +(piT*ones(N,1)).^bt.*((piT.^(1-bt).*(diag(lat_lafixed(:,t))+ones(N,1)*la_1'-diag(la_1)).^bt)*ones(N,1)))...
                    +(1-ga/(1-bt))*lat_lafixed(:,t);

                    lat_pifixed(:,t+1)=Ga2/Ga1*al0.*(piNT_1.*lat_pifixed(:,t).^bt...
                    +(piT_1*ones(N,1)).^bt.*((piT_1.^(1-bt).*(diag(lat_pifixed(:,t))+ones(N,1)*la'-diag(la)).^bt)*ones(N,1)))...
                    +(1-ga/(1-bt))*lat_pifixed(:,t);
                
                else
                    
                    lat(:,t+1)=Ga2/Ga1*al_t(:,t).*(piNT.*lat(:,t).^bt...
                    +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*lat(:,t).^bt))+(1-ga/(1-bt))*lat(:,t);
                    
                end
                
                Ani(:,t) = ((y(:,t)).*(p_Ii(:,t)./p_data(:,t)).^((1 - up)./up)) ./ (up.*((1 - up).^((1-up)./up))); 
                
%                 if s == 3
% %                     Ani(:,t) = (w_data(:,t).*((p_Ii(:,t)./p_data(:,t)).*(1 - pi_ii_data(:,t)).^(1 /(ep - 1))).^((1 - al0)./al0)) ./ (al0.*(1 - al0).^((1-al0)./al0));
% %                     Ani(:,t) = ((w_data(:,t)./ p_data(:,t)).*(p_Ii(:,t)./p_data(:,t)).^((1 - al0)./al0)) ./ (al0.*((1 - al0).^((1-al0)./al0)));    
% %                     Ani(:,t) = ((y(:,t)).*(p_Ii(:,t)./p_data(:,t)).^((1 - al0)./al0)) ./ (al0.*((1 - al0).^((1-al0)./al0))); 
%                     Ani(:,t) = ((y(:,t)).*(p_Ii(:,t)./p_data(:,t)).^((1 - up)./up)) ./ (up.*((1 - up).^((1-up)./up))); 
%                 else               
% %                     Ani(:,t) = (w_data(:,t).*((p_Ii(:,t)./p_data(:,t)).*(1 - pi_ii_data(:,t)).^(1 /(ep - 1))).^((1 - al_t(:,t))./al_t(:,t))) ./ (al_t(:,t).*(1 - al_t(:,t)).^((1 - al_t(:,t))./al_t(:,t)));    
% %                     Ani(:,t) = ((w_data(:,t)./ p_data(:,t)).*(p_Ii(:,t)./p_data(:,t)).^((1 - al_t(:,t))./al_t(:,t))) ./ (al_t(:,t).*((1 - al_t(:,t)).^((1 - al_t(:,t))./al_t(:,t))));    
% %                     Ani(:,t) = ((y(:,t)).*(p_Ii(:,t)./p_data(:,t)).^((1 - al_t(:,t))./al_t(:,t))) ./ (al_t(:,t).*((1 - al_t(:,t)).^((1 - al_t(:,t))./al_t(:,t))));
%                     Ani(:,t) = ((y(:,t)).*(p_Ii(:,t)./p_data(:,t)).^((1 - up)./up)) ./ (up.*((1 - up).^((1-up)./up))); 
%                 end
            end
                      
            pi_ii_d1(:,t)=pi_ii;

            pi_la(:,t)=(diag(piNT)+piT)*la;
            pi_la0(:,t)=(diag(piNT)+piT)*la0;

        end

        % save unique items depending on simulation
        if s == 1
            for i=1:N
                [Z_0_all(i,ibt)]=fminbnd('eq_Z_pi',0,1,[],pi_ii_1(i));
                [Z_T_all(i,ibt)]=fminbnd('eq_Z_pi',0,1,[],pi_ii_T(i));
            end
            TFP0_all_Z(:,ibt)=(lat(:,1).*(1-mu+mu*Z_0_all(:,ibt).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
            TFPT_all_Z(:,ibt)=(lat(:,T).*(1-mu+mu*Z_T_all(:,ibt).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));

            pi_ii_0_all(:,ibt)=pi_ii_1;
            pi_ii_T_all(:,ibt)=pi_ii_T;

            piT_0_all(:,ibt)=reshape(piT_1,N*N,1);
            piT_T_all(:,ibt)=reshape(piT_T,N*N,1);
            piNT_0_all(:,ibt)=piNT_1;
            piNT_T_all(:,ibt)=piNT_T;

            la0_all(:,ibt)=lat(:,1);
            laT_all(:,ibt)=lat(:,T);

            TFP0_all(:,ibt)=(w_d1(:,1)./p_d1(:,1));
            TFPT_all(:,ibt)=(w_d1(:,end)./p_d1(:,end));
            dTFP_all(:,ibt)=log((w_d1(:,end)./p_d1(:,end))./(w_d1(:,1)./p_d1(:,1)));

            MSE_all(ibt)=mean((log(y(:,T)./y(:,1)/exp(gUS*(T-1)))-mean(log(y(:,T)./y(:,1)/exp(gUS*(T-1))))...
                -(dTFP_all(:,ibt)-mean(dTFP_all(:,ibt)))).^2)^.5;

            TFP_Korea_all(ibt,:)=w_d1(iKorea,:)./p_d1(iKorea,:);
            TFP_China_all(ibt,:)=w_d1(iChina,:)./p_d1(iChina,:);
            TFP_Taiwan_all(ibt,:)=w_d1(iTaiwan,:)./p_d1(iTaiwan,:);
            TFP_Thailand_all(ibt,:)=w_d1(iThailand,:)./p_d1(iThailand,:);
            TFP_US_all(ibt,:)=w_d1(iUS,:)./p_d1(iUS,:);

            lat(:,1)=la0;

        elseif s == 2
            for i=1:N
                [Z_0_k0(i,ibt)]=fminbnd('eq_Z_pi',0,1,[],pi_ii_1(i));
                [Z_T_k0(i,ibt)]=fminbnd('eq_Z_pi',0,1,[],pi_ii_T(i));
            end
            TFP0_k0_Z(:,ibt)=(lat(:,1).*(1-mu+mu*Z_0_k0(:,ibt).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
            TFPT_k0_Z(:,ibt)=(lat(:,T).*(1-mu+mu*Z_T_k0(:,ibt).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));

            pi_ii_0_k0(:,ibt)=pi_ii_1;
            pi_ii_T_k0(:,ibt)=pi_ii_T;
            la0_k0(:,ibt)=lat(:,1);
            laT_k0(:,ibt)=lat(:,T);

            piT_0_ka0(:,ibt)=reshape(piT_1,N*N,1);
            piT_T_ka0(:,ibt)=reshape(piT_T,N*N,1);
            piNT_0_ka0(:,ibt)=piNT_1;
            piNT_T_ka0(:,ibt)=piNT_T;

            TFP0_k0(:,ibt)=(w_d1(:,1)./p_d1(:,1));
            TFPT_k0(:,ibt)=(w_d1(:,end)./p_d1(:,end));
            dTFP_k0(:,ibt)=log((w_d1(:,end)./p_d1(:,end))./(w_d1(:,1)./p_d1(:,1)));

            %     MSE(ibt)=mean((log(y(:,T)./y(:,1)/exp(gUS*(T-1)))-mean(log(y(:,T)./y(:,1)/exp(gUS*(T-1))))...
            %         -(dTFP(:,ibt)-mean(dTFP(:,ibt)))).^2)^.5;

            MSE_k0(ibt)=mean(((dTFP_all(:,ibt)-mean(dTFP_all(:,ibt)))...
                -(dTFP_k0(:,ibt)-mean(dTFP_k0(:,ibt)))).^2)^.5;

            TFP_Korea_k0(ibt,:)=w_d1(iKorea,:)./p_d1(iKorea,:);
            TFP_China_k0(ibt,:)=w_d1(iChina,:)./p_d1(iChina,:);
            TFP_Taiwan_k0(ibt,:)=w_d1(iTaiwan,:)./p_d1(iTaiwan,:);
            TFP_Thailand_k0(ibt,:)=w_d1(iThailand,:)./p_d1(iThailand,:);
            TFP_US_k0(ibt,:)=w_d1(iUS,:)./p_d1(iUS,:);

            [ibt MSE_all(ibt) MSE_k0(ibt)]

        elseif s == 3
                    for i=1:N
                [Z_0_al0(i,ibt)]=fminbnd('eq_Z_pi',0,1,[],pi_ii_1(i));
                [Z_T_al0(i,ibt)]=fminbnd('eq_Z_pi',0,1,[],pi_ii_T(i));
            end

            TFP_fixed_la(:,ibt)=(Ga1^(th/(ep-1))*lat_lafixed(:,t).*(1-mu+mu*Z_0_al0(:,ibt).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
            TFP_fixed_pi(:,ibt)=(Ga1^(th/(ep-1))*lat_pifixed(:,t).*(1-mu+mu*Z_0_al0(:,ibt).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));

            TFP0_al0_Z(:,ibt)=(lat(:,1).*(1-mu+mu*Z_0_al0(:,ibt).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));
            TFPT_al0_Z(:,ibt)=(lat(:,T).*(1-mu+mu*Z_T_al0(:,ibt).^(-(ep-1)/th)).^(th/(ep-1))).^(1/((1-et)*th));

            pi_ii_0_al0(:,ibt)=pi_ii_1;
            pi_ii_T_al0(:,ibt)=pi_ii_T;
            la0_al0(:,ibt)=lat(:,1);
            laT_al0(:,ibt)=lat(:,T);

            piT_0_al0(:,ibt)=reshape(piT_1,N*N,1);
            piT_T_al0(:,ibt)=reshape(piT_T,N*N,1);
            piNT_0_al0(:,ibt)=piNT_1;
            piNT_T_al0(:,ibt)=piNT_T;

            TFP0_al0(:,ibt)=(w_d1(:,1)./p_d1(:,1));
            TFPT_al0(:,ibt)=(w_d1(:,end)./p_d1(:,end));
            dTFP_al0(:,ibt)=log((w_d1(:,end)./p_d1(:,end))./(w_d1(:,1)./p_d1(:,1)));

            %     MSE(ibt)=mean((log(y(:,T)./y(:,1)/exp(gUS*(T-1)))-mean(log(y(:,T)./y(:,1)/exp(gUS*(T-1))))...
            %         -(dTFP(:,ibt)-mean(dTFP(:,ibt)))).^2)^.5;

            MSE_al0(ibt)=mean(((dTFP_all(:,ibt)-mean(dTFP_all(:,ibt)))...
                -(dTFP_al0(:,ibt)-mean(dTFP_al0(:,ibt)))).^2)^.5;

            TFP_Korea_al0(ibt,:)=w_d1(iKorea,:)./p_d1(iKorea,:);
            TFP_China_al0(ibt,:)=w_d1(iChina,:)./p_d1(iChina,:);
            TFP_Taiwan_al0(ibt,:)=w_d1(iTaiwan,:)./p_d1(iTaiwan,:);
            TFP_Thailand_al0(ibt,:)=w_d1(iThailand,:)./p_d1(iThailand,:);
            TFP_US_al0(ibt,:)=w_d1(iUS,:)./p_d1(iUS,:);

            [ibt MSE_all(ibt) MSE_al0(ibt)]

        elseif s == 4

            TFP0_all2(:,ibt)=(w_d1(:,1)./p_d1(:,1));
            TFPT_all2(:,ibt)=(w_d1(:,end)./p_d1(:,end));
            dTFP_all2(:,ibt)=log((w_d1(:,end)./p_d1(:,end))./(w_d1(:,1)./p_d1(:,1)));

            %     MSE(ibt)=mean((log(y(:,T)./y(:,1)/exp(gUS*(T-1)))-mean(log(y(:,T)./y(:,1)/exp(gUS*(T-1))))...
            %         -(dTFP(:,ibt)-mean(dTFP(:,ibt)))).^2)^.5;

            MSE_all2(ibt)=mean(((dTFP_all(:,ibt)-mean(dTFP_all(:,ibt)))...
                -(dTFP_all2(:,ibt)-mean(dTFP_all2(:,ibt)))).^2)^.5;

            alpha0(:,ibt)=al_t(:,1);
            alphaT(:,ibt)=al_t(:,end);

            [ibt MSE_all(ibt) MSE_all2(ibt)]

        end
    end
end

save trans_k0_al0_s_02_non_tradables_3_2_2017 MSE_all TFP0_all TFPT_all dTFP_all TFP_Korea_all TFP_China_all TFP_Taiwan_all TFP_Thailand_all TFP_US_all ...
    MSE_k0 TFP0_k0 TFPT_k0 dTFP_k0 TFP_Korea_k0 TFP_China_k0 TFP_Taiwan_k0 TFP_Thailand_k0 TFP_US_k0 ...
    MSE_al0 TFP0_al0 TFPT_al0 dTFP_al0 TFP_Korea_al0 TFP_China_al0 TFP_Taiwan_al0 TFP_Thailand_al0 TFP_US_al0 alpha0 alphaT ...
    pi_ii_0_all pi_ii_T_all pi_ii_0_k0 pi_ii_T_k0 pi_ii_0_al0 pi_ii_T_al0 ...
    la0_all laT_all la0_k0 laT_k0 la0_al0 laT_al0 Z_0_all Z_T_all Z_0_k0 Z_T_k0 Z_0_al0 Z_T_al0 TFP_fixed_la TFP_fixed_pi ga_bt ...
    piT_0_ka0 piT_T_ka0 piNT_0_ka0 piNT_T_ka0 piT_0_al0 piT_T_al0 piNT_0_al0 piNT_T_al0 ...
    piT_0_all piT_T_all piNT_0_all piNT_T_all

