clear all
close all

global ep mu et th bt ga Ga1 Ga2 L N adjust_w adjust_la imax toler

ep=1.001;
mu=.34;
% mu=.5;
th=4;
et=0.48;
% et=.5;
bt=.5;
nu=.75; % power of the scale effects on alpha

adjust_w=.25; % update of the tatonnement process
adjust_la=.1; % update of the tatonnement process

Ga1=gamma(1+(1-ep)/th);

% gdp_type = 1; % output side
gdp_type = 0; % expenditure side

% load trade.txt
% load pwt.txt
% trade=load('trade_small.txt');
% pwt=load('pwt_small.txt');
% trade=load('trade_small_2.txt');
% pwt=load('pwt_small_2.txt');
trade=load('trade_small_3.txt');
pwt=load('pwt_small_3.txt');
temp=load('deflator.txt');
deflator=temp(:,2);

tt=(1962:2000)';
T=length(tt);
N=length(trade(:,1))^.5;

iUS=find(trade(1:N,2)==87);

% create [T,N] matrix for each variable in pwt
pop=reshape(pwt(:,2),T,N)';
emp=reshape(pwt(:,3),T,N)';
hc=reshape(pwt(:,4),T,N)';
gdpr=reshape(pwt(:,6),T,N)'*1000;
% output-side
if gdp_type == 1
    gdpn=reshape(pwt(:,8).*pwt(:,13),T,N)'*1000;
    gdpr0=reshape(pwt(:,8),T,N)'*1000;
% expenditure-side 
else
    gdpn=reshape(pwt(:,14).*pwt(:,15),T,N)'*1000;
    gdpr0=reshape(pwt(:,14),T,N)'*1000;
end
k=reshape(pwt(:,7),T,N)'*1000;
k0=reshape(pwt(:,9),T,N)'*1000;
gdpr=gdpr.*(gdpr0(:,1)*ones(1,T))./(gdpr(:,1)*ones(1,T));
k=k.*(k0(:,1)*ones(1,T))./(k(:,1)*ones(1,T));

% measure of equipped labor normalized by US
% L=k.^(1/3).*(pop.*hc).^(2/3);
% L=k.^(1/3).*(emp.*hc).^(2/3);
ze = 0.36;
L=k.^(ze).*(emp.*hc).^(1 - ze);


L=L/L(iUS,1);

% Real GDP per Capita normalized by US in 1962
y=(gdpr/gdpr(iUS,1))./L;
% y=(gdpr)./L;

% share of merchandixe imports at current PPP
m_gdp=reshape(pwt(:,10),T,N)';

% price level
% p_data=reshape(pwt(:,13),T,N)';
p_data=gdpn./gdpr;

for t=1:T
    temp=reshape(trade(:,t+2),N,N)';
   for i=1:N
    
        for j=1:N
            
            if j==i
                
        PI_data(i,j)=(gdpn(i,t)/(1-et)-sum(temp(:,i)))...
            /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));     
                
            else
                
        PI_data(i,j)=temp(i,j)...
            /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));                 
        
            end
            
        end
        
   end
 
PI_t(:,t)=reshape(PI_data,N*N,1);
    
for i=1:N
        im(i,t)=sum(temp(i,:));
        ex(i,t)=sum(temp(:,i));
%         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z',0,1,[],imp(i,t)/gdpn(i,t));
% m_E_data(i,t)=im(i,t)*deflator(t)/((im(i,t)-ex(i,t))*deflator(t)+gdpr(i,t)/(1-et));
% m_E_data(i,t)=im(i,t)/((im(i,t)-ex(i,t))+gdpn(i,t)/(1-et));
%         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_T',0,1,[],m_E_data(i,t));
%         pi_ii_data(i,t)=((1-mu+mu*Z(i,t).^(1-(ep-1)/th))./(1-mu+mu*Z(i,t).^(-(ep-1)/th)));
        [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_pi',0,1,[],PI_data(i,i));
        pi_ii_data(i,t)=PI_data(i,i);
%         Tb(i,t)=(im(i,t)-ex(i,t))*deflator(t)/gdpr(i,t);
%        Tb(i,t)=0;
%         T(i,t)=(im(i,t)-ex(i,t))*deflator(t)/sum(gdpr(:,t));
%         Tr(i,t)=(im(i,t)-ex(i,t))/sum(gdpn(:,t));
%         Trdollars(i,t)=(im(i,t)-ex(i,t));
end

    PI_NT_t(:,t)=(1-mu)./(1-mu+mu*Z(:,t).^(-(ep-1)/th));
    
    
    PI_T=PI_data-diag(PI_NT_t(:,t));
    PI_T_t(:,t)=reshape(PI_T,N*N,1);
    
    Trdollars2(:,t)=inv(PI_data')*(gdpn(:,t)/(1-et)-PI_data'*gdpn(:,t)/(1-et));
    
    Trb(:,t)=Trdollars2(:,t)./gdpn(:,t);
    Tr(:,t)=Trdollars2(:,t)/sum(gdpn(:,t));
    
K0=zeros(N,N);

%  for i=1:N-1
%           
%      for j=i+1:N
%          
%          m(i,j)=temp(i,j)/im(i,t);
%          m(j,i)=temp(j,i)/im(j,t);
%          
%          K0(i,j)=(m(i,j)*m(j,i)...
%              *((1-Z(i,t))/Z(i,t))*((1-Z(j,t))/Z(j,t)))^(-1/(2*th));   
%    
%      end
%      
%  end
% 
% 
% K=K0+K0'+eye(N);

 for i=1:N
     
     for j=1:i-1
         
%          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%              *p_data(i,t)/p_data(j,t)...
%              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
         K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
             *p_data(i,t)/p_data(j,t)...
             *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
   
     end
     
     for j=i+1:N
         
%          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%              *p_data(i,t)/p_data(j,t)...
%              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
         K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
             *p_data(i,t)/p_data(j,t)...
             *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
   
     end
     
 end

K=K0+eye(N);

    KK(:,t)=reshape(K,N*N,1);
    
lat_cal(:,t)=y(:,t).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,1).^(-(ep-1)/th)).^(th/(ep-1)));
    
end

piNT=PI_NT_t(:,1);
piT=reshape(PI_T_t(:,1),N,N);
PIothers=diag(piNT)+piT-diag(diag(diag(piNT)+piT));
PIothers=PIothers./(sum(PIothers')'*ones(1,N));

% load stst_p_nu_cal2
% gridbt0=gridbt;
% nu_bt0=nu_bt;
% 
% gridbt=linspace(0,1,1000);
% nu_bt=spline(gridbt0,nu_bt0,gridbt);
% 
% for i=1:length(gridbt)
%     
%     bt=gridbt(i);
%     nu=nu_bt(i);
%     
% %         learning from producers
%         den_la=((gdpn(:,1))'*(diag(piNT)+piT))';
%         temp1=(gdpn(:,1)'*(diag(piNT)+piT).^(1-bt))'./den_la;
%         
% %         den_la=((gdpn(:,1))'*(diag(piNT)+piT))';
% %         temp1=L(:,1).^nu.*(piNT.*(gdpn(:,1))...
% %             +(((piT*ones(N,1)).^bt.*(gdpn(:,1)))'*piT.^(1-bt))')...
% %             ./den_la;
% %         temp1=(piNT.*(gdpn(:,1))...
% %             +(((piT*ones(N,1)).^bt.*(gdpn(:,1)))'*piT.^(1-bt))')...
% %             ./den_la;
% 
%         [b1 b1int]=regress(log(y(:,1)),[ones(N,1) log(temp1)]);
% 
%         b_bt(i)=b1(2);
%         
% temp_s=(piNT.*la_cal.^bt...
%  +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*la_cal.^bt));
% 
% bs=regress(log(y(:,1)),[ones(N,1) log(temp_s)]);    
% bs_bt(i)=bs(2);
% 
% end
% 
% bt=.1;
% den_la=((gdpn(:,1))'*(diag(piNT)+piT))';
% temp010=(gdpn(:,1)'*(diag(piNT)+piT).^(1-bt))'./den_la;

figure(1)
rango=linspace(min(log(pi_ii_data(:,1))),max(log(pi_ii_data(:,1))),2);
X=[ones(N,1) log(pi_ii_data(:,1))];
[b_fig1 b_fig1_int R_fig1 temp stat_fig1]=regress(log(y(:,1)),X);
temp=(R_fig1'*R_fig1)*inv(X'*X)/(N-2);
sb_fig1=diag(temp).^.5;

subplot(1,2,1),plot(log(pi_ii_data(:,1)),log(y(:,1)),'.','MarkerSize',10)
line(rango,[b_fig1(1)+b_fig1(2)*rango],'LineWidth',2,'LineStyle','-','Color','b')
xlabel('log \pi_{ii}','FontSize',12)
ylabel('log TFP','FontSize',12)
line(rango,[b_fig1(1)+b_fig1(2)*rango],'LineWidth',2,'Color','r')
set(gca,'FontSize',12)
axis([-.2 0 -2.5 .5])
% text(-.18,-2,{strcat('slope =',num2str(sprintf('%0.2f',b_fig1(2)))), ...
%     [blanks(13) strcat('(',num2str(sprintf('%0.2f',sb_fig1(2))),')')]},'FontSize',11)
text(-.18,-2,{['slope =' blanks(1)  num2str(sprintf('%0.2f',b_fig1(2)))], ...
    [blanks(13) strcat('(',num2str(sprintf('%0.2f',sb_fig1(2))),')')]},'FontSize',11)

% subplot(1,3,2),plot(log((diag(piNT)+piT)*lat_cal(:,1)),log(y(:,1)),'.')
% xlabel('log(\Pi \Lambda)')
% set(gca,'FontSize',12)
% rango=linspace(min(log((PIothers)*lat_cal(:,1))),max(log((PIothers)*lat_cal(:,1))),100);
% [b_fig3 b_fig3_int]=regress(log(y(:,1)),[ones(N,1) log((PIothers)*lat_cal(:,1))]);    
% subplot(1,2,2),plot(log((PIothers)*lat_cal(:,1)),log(y(:,1)),'.')
rango=linspace(min(log((PIothers)*y(:,1))),max(log((PIothers)*y(:,1))),1000);
X=[ones(N,1) log((PIothers)*y(:,1))];
[b_fig2 b_fig2_int R_fig2]=regress(log(y(:,1)),X);    
temp=(R_fig2'*R_fig2)*inv(X'*X)/(N-2);
sb_fig2=diag(temp).^.5;
subplot(1,2,2),plot(log((PIothers)*y(:,1)),log(y(:,1)),'.','MarkerSize',10)
line(rango,[b_fig2(1)+b_fig2(2)*rango],'LineWidth',2,'Color','r')
xlabel('log(\pi_{i,-i} TFP_{-i}/(1-\pi_{ii}))')
set(gca,'FontSize',12)
axis([-.4 0 -2.5 .5])
% text(-.20,-2,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_fig2(2)))), ...
%     [blanks(14) strcat('(',num2str(sprintf('%0.2f',sb_fig2(2))),')')]},'FontSize',11)
text(-.20,-2,{['slope  =' blanks(1) num2str(sprintf('%0.2f',b_fig2(2)))], ...
    [blanks(13) strcat('(',num2str(sprintf('%0.2f',sb_fig2(2))),')')]},'FontSize',11)
set(gcf, 'PaperPosition', [0 0 6 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6 3]); %Set the paper to have width 5 and height 5.

[b_fig1 sb_fig1]
% redo regression dropping countries with logTFP<=-1.5
temp=find(log(y(:,1))>-1.5);
X=[ones(length(temp),1) log(pi_ii_data(temp,1))];
[b_fig1 b_fig1_int R_fig1 temp stat_fig1]=regress(log(y(temp,1)),X);
temp=(R_fig1'*R_fig1)*inv(X'*X)/(N-2);
sb_fig1=diag(temp).^.5;
% [b_fig1 sb_fig1]

[b_fig2 sb_fig2]
temp=find(log(y(:,1))>-1.5);
X=[ones(length(temp),1) log((PIothers(temp,temp))*y(temp,1))];
[b_fig2 b_fig2_int R_fig2]=regress(log(y(temp,1)),X);    
temp=(R_fig2'*R_fig2)*inv(X'*X)/(N-2);
sb_fig2=diag(temp).^.5;
% [b_fig2 sb_fig2]

% Figure OA.10 in the online appendix

figure(2)
rango=linspace(min(log(pi_ii_data(:,1))),max(log(pi_ii_data(:,1))),2);
X=[ones(N,1) log(pi_ii_data(:,1))];
[b_fig1 b_fig1_int R_fig1 temp stat_fig1]=regress(log(y(:,1)),X);
temp=(R_fig1'*R_fig1)*inv(X'*X)/(N-2);
sb_fig1=diag(temp).^.5;
[b_fig1 sb_fig1]
[stat_fig1(1)]

subplot(1,2,1),plot(log(pi_ii_data(:,1)),log(y(:,1)),'.','MarkerSize',10)
line(rango,[b_fig1(1)+b_fig1(2)*rango],'LineWidth',2,'LineStyle','-','Color','b')
xlabel('$\log \pi_{ii}$','FontSize',12,'Interpreter','LaTex')
ylabel('$\log TFP$','FontSize',12,'Interpreter','LaTex')
title('Openness','FontSize',12)
line(rango,[b_fig1(1)+b_fig1(2)*rango],'LineWidth',2,'Color','r')
set(gca,'FontSize',12)
axis([-.2 0 -2.5 .5])
% text(-.18,-2,{strcat('slope =',num2str(sprintf('%0.2f',b_fig1(2)))), ...
%     [blanks(13) strcat('(',num2str(sprintf('%0.2f',sb_fig1(2))),')')]},'FontSize',11)
text(-.18,-2,{['slope =' blanks(1)  num2str(sprintf('%0.2f',b_fig1(2)))], ...
    [ strcat(' \ \ \ \ \ \ \ \ \ \ (',num2str(sprintf('%0.2f',sb_fig1(2))),')')]},'FontSize',11,'Interpreter','LaTex')
text(-.18,-2.3,{['$R^2$ =' blanks(1)  num2str(sprintf('%0.2f',stat_fig1(1)))]},'FontSize',11,'Interpreter','LaTex')

% subplot(1,3,2),plot(log((diag(piNT)+piT)*lat_cal(:,1)),log(y(:,1)),'.')
% xlabel('log(\Pi \Lambda)')
% set(gca,'FontSize',12)
% rango=linspace(min(log((PIothers)*lat_cal(:,1))),max(log((PIothers)*lat_cal(:,1))),100);
% [b_fig3 b_fig3_int]=regress(log(y(:,1)),[ones(N,1) log((PIothers)*lat_cal(:,1))]);    
% subplot(1,2,2),plot(log((PIothers)*lat_cal(:,1)),log(y(:,1)),'.')
rango=linspace(min(log((PIothers)*y(:,1))),max((PIothers)*log(y(:,1))),1000);
X=[ones(N,1) (PIothers)*log(y(:,1))];
[b_fig2 b_fig2_int R_fig2 temp stat_fig2]=regress(log(y(:,1)),X);    
temp=(R_fig2'*R_fig2)*inv(X'*X)/(N-2);
sb_fig2=diag(temp).^.5;
[b_fig2 sb_fig2]
[stat_fig2(1)]

subplot(1,2,2),plot((PIothers)*log(y(:,1)),log(y(:,1)),'.','MarkerSize',10)
line(rango,[b_fig2(1)+b_fig2(2)*rango],'LineWidth',2,'Color','r')
xlabel('$(\pi_{i,-i}/(1-\pi_{ii})) \log TFP_{-i}$','Interpreter','LaTex')
title('Quality of trade','FontSize',12)
set(gca,'FontSize',12)
axis([-.4 0 -2.5 .5])
% text(-.20,-2,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_fig2(2)))), ...
%     [blanks(14) strcat('(',num2str(sprintf('%0.2f',sb_fig2(2))),')')]},'FontSize',11)
text(-.20,-2,{['slope  =' blanks(1) num2str(sprintf('%0.2f',b_fig2(2)))], ...
    [ strcat('\ \ \ \ \ \ \ \ \ \ (',num2str(sprintf('%0.2f',sb_fig2(2))),')')]},'FontSize',11,'Interpreter','LaTex')

text(-.20,-2.3,{['$R^2$ = '   num2str(sprintf('%0.2f',stat_fig2(1)))]},'FontSize',11,'Interpreter','LaTex')

set(gcf, 'PaperPosition', [0 0 6 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6 3]); %Set the paper to have width 5 and height 5.

[b_fig1 sb_fig1]
% redo regression dropping countries with logTFP<=-1.5
temp=find(log(y(:,1))>-1.5);
X=[ones(length(temp),1) log(pi_ii_data(temp,1))];
[b_fig1 b_fig1_int R_fig1 temp stat_fig1]=regress(log(y(temp,1)),X);
temp=(R_fig1'*R_fig1)*inv(X'*X)/(N-2);
sb_fig1=diag(temp).^.5;
[b_fig1 sb_fig1]
[stat_fig1(1)]

temp=find(log(y(:,1))>-1.5);
X=[ones(length(temp),1) (PIothers(temp,temp))*log(y(temp,1))];
[b_fig2 b_fig2_int R_fig2]=regress(log(y(temp,1)),X);    
temp=(R_fig2'*R_fig2)*inv(X'*X)/(N-2);
sb_fig2=diag(temp).^.5;
[b_fig2 sb_fig2]
[stat_fig2(1)]
