clear all
close all

global ep mu et th bt ga Ga1 Ga2 L N adjust_w adjust_la imax toler

ep=1.001;
mu=.5;
th=4;
et=.5;
bt=.5;
nu=.75; % power of the scale effects on alpha

adjust_w=.25; % update of the tatonnement process
adjust_la=.1; % update of the tatonnement process

Ga1=gamma(1+(1-ep)/th);

% gdp_type = 1; % output side
gdp_type = 0; % expenditure side

% load trade.txt
% load pwt.txt
% trade=load('trade_small.txt');
% pwt=load('pwt_small.txt');
% trade=load('trade_small_2.txt');
% pwt=load('pwt_small_2.txt');
trade=load('trade_small_3.txt');
pwt=load('pwt_small_3.txt');
temp=load('deflator.txt');
deflator=temp(:,2);

tt=(1962:2000)';
T=length(tt);
N=length(trade(:,1))^.5;

iUS=find(trade(1:N,2)==87);

% create [T,N] matrix for each variable in pwt
pop=reshape(pwt(:,2),T,N)';
emp=reshape(pwt(:,3),T,N)';
hc=reshape(pwt(:,4),T,N)';
gdpr=reshape(pwt(:,6),T,N)'*1000;
% output-side
if gdp_type == 1
    gdpn=reshape(pwt(:,8).*pwt(:,13),T,N)'*1000;
    gdpr0=reshape(pwt(:,8),T,N)'*1000;
% expenditure-side 
else
    gdpn=reshape(pwt(:,14).*pwt(:,15),T,N)'*1000;
    gdpr0=reshape(pwt(:,14),T,N)'*1000;
end
k=reshape(pwt(:,7),T,N)'*1000;
k0=reshape(pwt(:,9),T,N)'*1000;
gdpr=gdpr.*(gdpr0(:,1)*ones(1,T))./(gdpr(:,1)*ones(1,T));
k=k.*(k0(:,1)*ones(1,T))./(k(:,1)*ones(1,T));

% measure of equipped labor normalized by US
% L=k.^(1/3).*(pop.*hc).^(2/3);
% L=k.^(1/3).*(emp.*hc).^(2/3);
ze = 0.36;
L=k.^(ze).*(emp.*hc).^(1 - ze);


L=L/L(iUS,1);

% Real GDP per Capita normalized by US in 1962
y=(gdpr/gdpr(iUS,1))./L;
% y=(gdpr)./L;

% share of merchandixe imports at current PPP
m_gdp=reshape(pwt(:,10),T,N)';

% price level
% p_data=reshape(pwt(:,13),T,N)';
p_data=gdpn./gdpr;

for t=1:T
    temp=reshape(trade(:,t+2),N,N)';
   for i=1:N
    
        for j=1:N
            
            if j==i
                
        PI_data(i,j)=(gdpn(i,t)/(1-et)-sum(temp(:,i)))...
            /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));     
                
            else
                
        PI_data(i,j)=temp(i,j)...
            /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));                 
        
            end
            
        end
        
   end
 
PI_t(:,t)=reshape(PI_data,N*N,1);
    
for i=1:N
        im(i,t)=sum(temp(i,:));
        ex(i,t)=sum(temp(:,i));
%         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z',0,1,[],imp(i,t)/gdpn(i,t));
% m_E_data(i,t)=im(i,t)*deflator(t)/((im(i,t)-ex(i,t))*deflator(t)+gdpr(i,t)/(1-et));
% m_E_data(i,t)=im(i,t)/((im(i,t)-ex(i,t))+gdpn(i,t)/(1-et));
%         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_T',0,1,[],m_E_data(i,t));
%         pi_ii_data(i,t)=((1-mu+mu*Z(i,t).^(1-(ep-1)/th))./(1-mu+mu*Z(i,t).^(-(ep-1)/th)));
        [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_pi',0,1,[],PI_data(i,i));
        pi_ii_data(i,t)=PI_data(i,i);
%         Tb(i,t)=(im(i,t)-ex(i,t))*deflator(t)/gdpr(i,t);
%        Tb(i,t)=0;
%         T(i,t)=(im(i,t)-ex(i,t))*deflator(t)/sum(gdpr(:,t));
%         Tr(i,t)=(im(i,t)-ex(i,t))/sum(gdpn(:,t));
%         Trdollars(i,t)=(im(i,t)-ex(i,t));
end

    PI_NT_t(:,t)=(1-mu)./(1-mu+mu*Z(:,t).^(-(ep-1)/th));
    
    
    PI_T=PI_data-diag(PI_NT_t(:,t));
    PI_T_t(:,t)=reshape(PI_T,N*N,1);
    
    Trdollars2(:,t)=inv(PI_data')*(gdpn(:,t)/(1-et)-PI_data'*gdpn(:,t)/(1-et));
    
    Trb(:,t)=Trdollars2(:,t)./gdpn(:,t);
    Tr(:,t)=Trdollars2(:,t)/sum(gdpn(:,t));
    
K0=zeros(N,N);

%  for i=1:N-1
%           
%      for j=i+1:N
%          
%          m(i,j)=temp(i,j)/im(i,t);
%          m(j,i)=temp(j,i)/im(j,t);
%          
%          K0(i,j)=(m(i,j)*m(j,i)...
%              *((1-Z(i,t))/Z(i,t))*((1-Z(j,t))/Z(j,t)))^(-1/(2*th));   
%    
%      end
%      
%  end
% 
% 
% K=K0+K0'+eye(N);

 for i=1:N
     
     for j=1:i-1
         
%          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%              *p_data(i,t)/p_data(j,t)...
%              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
         K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
             *p_data(i,t)/p_data(j,t)...
             *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
   
     end
     
     for j=i+1:N
         
%          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%              *p_data(i,t)/p_data(j,t)...
%              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
         K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
             *p_data(i,t)/p_data(j,t)...
             *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
   
     end
     
 end

K=K0+eye(N);

    KK(:,t)=reshape(K,N*N,1);
    
lat_cal(:,t)=y(:,t).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,1).^(-(ep-1)/th)).^(th/(ep-1)));
    
end

piNT=PI_NT_t(:,1);
piT=reshape(PI_T_t(:,1),N,N);
PIothers=diag(piNT)+piT-diag(diag(diag(piNT)+piT));
PIothers=PIothers./(sum(PIothers')'*ones(1,N));

% load stst_p_nu_cal2
% gridbt0=gridbt;
% nu_bt0=nu_bt;
% 
% gridbt=linspace(0,1,1000);
% nu_bt=spline(gridbt0,nu_bt0,gridbt);
% 
% for i=1:length(gridbt)
%     
%     bt=gridbt(i);
%     nu=nu_bt(i);
%     
% %         learning from producers
%         den_la=((gdpn(:,1))'*(diag(piNT)+piT))';
%         temp1=(gdpn(:,1)'*(diag(piNT)+piT).^(1-bt))'./den_la;
%         
% %         den_la=((gdpn(:,1))'*(diag(piNT)+piT))';
% %         temp1=L(:,1).^nu.*(piNT.*(gdpn(:,1))...
% %             +(((piT*ones(N,1)).^bt.*(gdpn(:,1)))'*piT.^(1-bt))')...
% %             ./den_la;
% %         temp1=(piNT.*(gdpn(:,1))...
% %             +(((piT*ones(N,1)).^bt.*(gdpn(:,1)))'*piT.^(1-bt))')...
% %             ./den_la;
% 
%         [b1 b1int]=regress(log(y(:,1)),[ones(N,1) log(temp1)]);
% 
%         b_bt(i)=b1(2);
%         
% temp_s=(piNT.*la_cal.^bt...
%  +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*la_cal.^bt));
% 
% bs=regress(log(y(:,1)),[ones(N,1) log(temp_s)]);    
% bs_bt(i)=bs(2);
% 
% end
% 
% bt=.1;
% den_la=((gdpn(:,1))'*(diag(piNT)+piT))';
% temp010=(gdpn(:,1)'*(diag(piNT)+piT).^(1-bt))'./den_la;


piNTb=PI_NT_t(:,end);
piTb=reshape(PI_T_t(:,end),N,N);
PIothersb=diag(piNTb)+piTb-diag(diag(diag(piNTb)+piTb));
PIothersb=PIothersb./(sum(PIothersb')'*ones(1,N));

figure(1)
rango=linspace(min(log(pi_ii_data(:,end)./pi_ii_data(:,1))) ...
    ,max(log(pi_ii_data(:,end)./pi_ii_data(:,1))),1000);
X=[ones(N,1) log(pi_ii_data(:,end)./pi_ii_data(:,1))];
[b_fig1b b_fig1b_int R_fig1b]=regress(log(y(:,end)./y(:,1)) ...
    ,X);
temp=(R_fig1b'*R_fig1b)*inv(X'*X)/(N-2);
sb_fig1b=diag(temp).^.5;
subplot(1,3,1),plot(log(pi_ii_data(:,end)./pi_ii_data(:,1)) ...
    ,log(y(:,end)./y(:,1)),'.','MarkerSize',10)
xlabel('\Delta log \pi_{ii}','FontSize',12)
ylabel('\Delta log TFP','FontSize',12)
set(gca,'FontSize',11)
line(rango,[b_fig1b(1)+b_fig1b(2)*rango],'LineWidth',2,'Color','r')
axis([-.3 .1 -1.5 1.5])
% text(-.26,-1.1,{'slope  =  -2.26',[blanks(15) '(0.69)']},'FontSize',10)
text(-.26,-1.1,{['slope =' blanks(1)  num2str(sprintf('%0.2f',b_fig1b(2)))], ...
    [blanks(12) strcat('(',num2str(sprintf('%0.2f',sb_fig1b(2))),')')]},'FontSize',11)

% rango=linspace(min(((diag(piNTb)+piTb)-(diag(piNT)+piT))*lat_cal(:,1)) ...
%     ,max(((diag(piNTb)+piTb)-(diag(piNT)+piT))*lat_cal(:,1)),100);
% [b_fig2b b_fig2b_int]=regress(log(y(:,end)./y(:,1)) ...
%     ,[ones(N,1) ((diag(piNTb)+piTb)-(diag(piNT)+piT))*lat_cal(:,1)]);
% subplot(1,3,2),plot(((diag(piNTb)+piTb)-(diag(piNT)+piT))*lat_cal(:,1),log(y(:,end)./y(:,1)),'.')
rango=linspace(min(((diag(piNTb)+piTb)-(diag(piNT)+piT))*y(:,1)) ...
    ,max(((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(y(:,1))),1000);
X=[ones(N,1) ((diag(piNTb)+piTb)-(diag(piNT)+piT))*y(:,1)];
[b_fig2b b_fig2b_int R_fig2b]=regress(log(y(:,end)./y(:,1)) ...
    ,X);
temp=(R_fig2b'*R_fig2b)*inv(X'*X)/(N-2);
sb_fig2b=diag(temp).^.5;
subplot(1,3,2),plot(((diag(piNTb)+piTb)-(diag(piNT)+piT))*y(:,1),log(y(:,end)./y(:,1)),'.','MarkerSize',10)
xlabel('(\Delta \Pi)  TFP_0','FontSize',12)
set(gca,'FontSize',11)
line(rango,[b_fig2b(1)+b_fig2b(2)*rango],'LineWidth',2,'Color','r')
axis([-.04 .04 -1.5 1.5])
% text(-0.025,-1.1,{'slope  =  11.99',[blanks(15) '(2.87)']},'FontSize',10)
text(-.025,-1.1,{['slope =' blanks(1)  num2str(sprintf('%0.2f',b_fig2b(2)))], ...
    [blanks(13) strcat('(',num2str(sprintf('%0.2f',sb_fig2b(2))),')')]},'FontSize',11)

% rango=linspace(min((PIothers)*(lat_cal(:,end)-lat_cal(:,1))./(PIothers*lat_cal(:,1))) ...
%     ,max((PIothers)*(lat_cal(:,end)-lat_cal(:,1))./(PIothers*lat_cal(:,1))),100);
% [b_fig3b b_fig3b_int]=regress(log(y(:,end)./y(:,1)),[ones(N,1) ...
%     (PIothers)*(lat_cal(:,end)-lat_cal(:,1))./(PIothers*lat_cal(:,1))]);    
% subplot(1,3,3),plot((PIothers)*(lat_cal(:,end)-lat_cal(:,1))./(PIothers*lat_cal(:,1)) ...
%     ,log(y(:,end)./y(:,1)),'.')
rango=linspace(min((PIothers)*(y(:,end)-y(:,1))./(PIothers*y(:,1))) ...
    ,max((PIothers)*(y(:,end)-y(:,1))./(PIothers*y(:,1))),1000);
X=[ones(N,1) ...
    (PIothers)*(y(:,end)-y(:,1))./(PIothers*y(:,1))];
[b_fig3b b_fig3b_int R_fig3b]=regress(log(y(:,end)./y(:,1)),X);    
temp=(R_fig3b'*R_fig3b)*inv(X'*X)/(N-2);
sb_fig3b=diag(temp).^.5;
subplot(1,3,3),plot((PIothers)*(y(:,end)-y(:,1))./(PIothers*y(:,1)) ...
    ,log(y(:,end)./y(:,1)),'.','MarkerSize',10)
line(rango,[b_fig3b(1)+b_fig3b(2)*rango],'LineWidth',2,'Color','r')
xlabel(' \Pi_0 \Delta log TFP','FontSize',12)
set(gca,'FontSize',11)
axis([.2 .6 -1.5 1.5])
% text(.29,-1.1,{'slope  =  0.30',[blanks(13) '(0.67)']},'FontSize',10)
text(.29,-1.1,{['slope =' blanks(1)  num2str(sprintf('%0.2f',b_fig3b(2)))], ...
    [blanks(12) strcat('(',num2str(sprintf('%0.2f',sb_fig3b(2))),')')]},'FontSize',11)

set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.

% Figure OA.12 in the online appendix

figure(2)
rango=linspace(min(log(pi_ii_data(:,end)./pi_ii_data(:,1))) ...
    ,max(log(pi_ii_data(:,end)./pi_ii_data(:,1))),1000);
X=[ones(N,1) log(pi_ii_data(:,end)./pi_ii_data(:,1))];
[b_fig1b b_fig1b_int R_fig1b temp stat_fig1b]=regress(log(y(:,end)./y(:,1)) ...
    ,X);
temp=(R_fig1b'*R_fig1b)*inv(X'*X)/(N-2);
sb_fig1b=diag(temp).^.5;
subplot(1,3,1),plot(log(pi_ii_data(:,end)./pi_ii_data(:,1)) ...
    ,log(y(:,end)./y(:,1)),'.','MarkerSize',10)
xlabel('$\Delta \log \pi_{ii}$','FontSize',12,'Interpreter','LaTex')
ylabel('$\Delta \log TFP$','FontSize',12,'Interpreter','LaTex')
title({'Change in openness',' '},'FontSize',12)
set(gca,'FontSize',11)
line(rango,[b_fig1b(1)+b_fig1b(2)*rango],'LineWidth',2,'Color','r')
axis([-.3 .1 -1.5 1.5])
% text(-.26,-1.1,{'slope  =  -2.26',[blanks(15) '(0.69)']},'FontSize',10)
text(-.26,-1.1,{['slope =' blanks(1)  num2str(sprintf('%0.2f',b_fig1b(2)))], ...
    [ strcat('\ \ \ \ \ \ \ \ \ \ \  (',num2str(sprintf('%0.2f',sb_fig1b(2))),')')]},'FontSize',11,'Interpreter','LaTex')
text(-.26,-1.4,{['$R^2$ =' blanks(1)  num2str(sprintf('%0.2f',stat_fig1b(1)))]},'FontSize',11,'Interpreter','LaTex')

% rango=linspace(min(((diag(piNTb)+piTb)-(diag(piNT)+piT))*lat_cal(:,1)) ...
%     ,max(((diag(piNTb)+piTb)-(diag(piNT)+piT))*lat_cal(:,1)),100);
% [b_fig2b b_fig2b_int]=regress(log(y(:,end)./y(:,1)) ...
%     ,[ones(N,1) ((diag(piNTb)+piTb)-(diag(piNT)+piT))*lat_cal(:,1)]);
% subplot(1,3,2),plot(((diag(piNTb)+piTb)-(diag(piNT)+piT))*lat_cal(:,1),log(y(:,end)./y(:,1)),'.')
rango=linspace(min(((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(y(:,1))) ...
    ,max(((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(y(:,1))),1000);
X=[ones(N,1) ((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(y(:,1))];
[b_fig2b b_fig2b_int R_fig2b temp stat_fig2b]=regress(log(y(:,end)./y(:,1)) ...
    ,X);
temp=(R_fig2b'*R_fig2b)*inv(X'*X)/(N-2);
sb_fig2b=diag(temp).^.5;
subplot(1,3,2),plot(((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(y(:,1)),log(y(:,end)./y(:,1)),'.','MarkerSize',10)
xlabel('$(\Delta \Pi) \log TFP_0$','FontSize',12,'Interpreter','LaTex')
title({'Change in the','quality of trade'},'FontSize',12)
set(gca,'FontSize',11)
line(rango,[b_fig2b(1)+b_fig2b(2)*rango],'LineWidth',2,'Color','r')
axis([-.04 .04 -1.5 1.5])
% text(-0.025,-1.1,{'slope  =  11.99',[blanks(15) '(2.87)']},'FontSize',10)
text(-.025,-1.1,{['slope =' blanks(1)  num2str(sprintf('%0.2f',b_fig2b(2)))], ...
    [  strcat('\ \ \ \ \ \ \ \ \ \ (',num2str(sprintf('%0.2f',sb_fig2b(2))),')')]},'FontSize',11,'Interpreter','LaTex')
text(-.025,-1.4,{['$R^2$ =' blanks(1)  num2str(sprintf('%0.2f',stat_fig2b(1)))]},'FontSize',11,'Interpreter','LaTex')

% rango=linspace(min((PIothers)*(lat_cal(:,end)-lat_cal(:,1))./(PIothers*lat_cal(:,1))) ...
%     ,max((PIothers)*(lat_cal(:,end)-lat_cal(:,1))./(PIothers*lat_cal(:,1))),100);
% [b_fig3b b_fig3b_int]=regress(log(y(:,end)./y(:,1)),[ones(N,1) ...
%     (PIothers)*(lat_cal(:,end)-lat_cal(:,1))./(PIothers*lat_cal(:,1))]);    
% subplot(1,3,3),plot((PIothers)*(lat_cal(:,end)-lat_cal(:,1))./(PIothers*lat_cal(:,1)) ...
%     ,log(y(:,end)./y(:,1)),'.')
% rango=linspace(min((PIothers)*(y(:,end)-y(:,1))./(PIothers*y(:,1))) ...
%     ,max((PIothers)*(y(:,end)-y(:,1))./(PIothers*y(:,1))),1000);
% X=[ones(N,1) ...
%     (PIothers)*(y(:,end)-y(:,1))./(PIothers*y(:,1))];
% [b_fig3b b_fig3b_int R_fig3b temp stat_fig3b]=regress(log(y(:,end)./y(:,1)),X);    
% temp=(R_fig3b'*R_fig3b)*inv(X'*X)/(N-2);
% sb_fig3b=diag(temp).^.5;
% subplot(1,3,3),plot((PIothers)*(y(:,end)-y(:,1))./(PIothers*y(:,1)) ...
%     ,log(y(:,end)./y(:,1)),'.','MarkerSize',10)
rango=linspace(min((PIothers)*(y(:,end)-y(:,1))) ...
    ,max((PIothers)*(y(:,end)-y(:,1))),1000);
X=[ones(N,1) ...
    (PIothers)*(y(:,end)-y(:,1))];
[b_fig3b b_fig3b_int R_fig3b temp stat_fig3b]=regress(log(y(:,end)./y(:,1)),X);    
temp=(R_fig3b'*R_fig3b)*inv(X'*X)/(N-2);
sb_fig3b=diag(temp).^.5;
subplot(1,3,3),plot((PIothers)*(y(:,end)-y(:,1)) ...
    ,log(y(:,end)./y(:,1)),'.','MarkerSize',10)
line(rango,[b_fig3b(1)+b_fig3b(2)*rango],'LineWidth',2,'Color','r')
xlabel(' $\Pi_0 \Delta \log TFP$','FontSize',12,'Interpreter','LaTex')
title({'Change in','partners'' TFP'},'FontSize',12)
set(gca,'FontSize',11)
axis([.2 .4 -1.5 1.5])
% text(.29,-1.1,{'slope  =  0.30',[blanks(13) '(0.67)']},'FontSize',10)
text(.25,-1.1,{['slope =' blanks(1)  num2str(sprintf('%0.2f',b_fig3b(2)))], ...
    [ strcat('\ \ \ \ \ \ \ \ \ \  (',num2str(sprintf('%0.2f',sb_fig3b(2))),')')]},'FontSize',11,'Interpreter','LaTex')
text(.25,-1.4,{['$R^2$ =' blanks(1)  num2str(sprintf('%0.2f',stat_fig3b(1)))]},'FontSize',11,'Interpreter','LaTex')

set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.

X=[ones(N,1) log(pi_ii_data(:,end)./pi_ii_data(:,1))];
[b1 bint1 temp1 temp2 stats1]=regress(log(y(:,end)./y(:,1)),X);
[b1 bint1]
stats1(1)

X=[ones(N,1) log(pi_ii_data(:,end)./pi_ii_data(:,1)) ((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(y(:,1)) ];
[b2 bint2 temp1 temp2 stats2]=regress(log(y(:,end)./y(:,1)),X);
[b2 bint2]
stats2(1)

X=[ones(N,1) log(pi_ii_data(:,end)./pi_ii_data(:,1)) ((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(y(:,1)) log(pi_ii_data(:,1))];
[b3 bint3 temp1 temp2 stats3]=regress(log(y(:,end)./y(:,1)),X);
[b3 bint3]
stats3(1)

% save trans_k0_al0_s_02 MSE_all TFP0_all TFPT_all dTFP_all TFP_Korea_all TFP_China_all TFP_Taiwan_all TFP_Thailand_all TFP_US_all ...
%     MSE_k0 TFP0_k0 TFPT_k0 dTFP_k0 TFP_Korea_k0 TFP_China_k0 TFP_Taiwan_k0 TFP_Thailand_k0 TFP_US_k0 ...
%     MSE_al0 TFP0_al0 TFPT_al0 dTFP_al0 TFP_Korea_al0 TFP_China_al0 TFP_Taiwan_al0 TFP_Thailand_al0 TFP_US_al0 alpha0 alphaT ...
%     pi_ii_0_all pi_ii_T_all pi_ii_0_k0 pi_ii_T_k0 pi_ii_0_al0 pi_ii_T_al0 ...
%     la0_all laT_all la0_k0 laT_k0 la0_al0 laT_al0 Z_0_all Z_T_all Z_0_k0 Z_T_k0 Z_0_al0 Z_T_al0 TFP_fixed_la TFP_fixed_pi ga_bt piT_0_al0 piT_T_al0 piNT_0_al0 piNT_T_al0
  


% break
% 
% load trans_k0_al0_s_02
% 
% ibt=7;
% figure(2)
% rango=linspace(min(log(pi_ii_T_al0(:,ibt)./pi_ii_0_al0(:,ibt))) ...
%     ,max(log(pi_ii_T_al0(:,ibt)./pi_ii_0_al0(:,ibt))),1000);
% X=[ones(N,1) log(pi_ii_T_al0(:,ibt)./pi_ii_0_al0(:,ibt))];
% [b_fig1b b_fig1b_int R_fig1b]=regress(log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)) ...
%     ,X);
% temp=(R_fig1b'*R_fig1b)*inv(X'*X)/(N-2);
% sb_fig1b=diag(temp).^.5;
% subplot(1,3,1),plot(log(pi_ii_T_al0(:,ibt)./pi_ii_0_al0(:,ibt)) ...
%     ,log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),'.','MarkerSize',10)
% xlabel('\Delta log \pi_{ii}','FontSize',12)
% ylabel('\Delta log TFP','FontSize',12)
% set(gca,'FontSize',11)
% line(rango,[b_fig1b(1)+b_fig1b(2)*rango],'LineWidth',2,'Color','r')
% axis([-.3 .1 -1.5 1.5])
% text(-.26,-1.1,{'slope  =  -0.85',[blanks(15) '(0.11)']},'FontSize',10)
% 
% % piT_0_al0 piT_T_al0 piNT_0_al0 piNT_T_al0
% 
% piNT=piNT_0_al0(:,ibt);
% piNTb=piNT_T_al0(:,ibt);
% piT=reshape(piT_0_al0(:,ibt),N,N);
% piTb=reshape(piT_T_al0(:,ibt),N,N);
% 
% rango=linspace(min(((diag(piNTb)+piTb)-(diag(piNT)+piT))*TFP0_al0(:,ibt)) ...
%     ,max(((diag(piNTb)+piTb)-(diag(piNT)+piT))*TFP0_al0(:,ibt)),1000);
% X=[ones(N,1) ((diag(piNTb)+piTb)-(diag(piNT)+piT))*TFP0_al0(:,ibt)];
% [b_fig2b b_fig2b_int R_fig2b]=regress(log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)) ...
%     ,X);
% temp=(R_fig2b'*R_fig2b)*inv(X'*X)/(N-2);
% sb_fig2b=diag(temp).^.5;
% subplot(1,3,2),plot(((diag(piNTb)+piTb)-(diag(piNT)+piT))*TFP0_al0(:,ibt) ...
%     ,log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),'.','MarkerSize',10)
% xlabel('(\Delta \Pi) TFP_0','FontSize',12)
% set(gca,'FontSize',11)
% line(rango,[b_fig2b(1)+b_fig2b(2)*rango],'LineWidth',2,'Color','r')
% axis([-.04 .04 -1.5 1.5])
% text(-0.025,-1.1,{'slope  =   3.55',[blanks(15) '(0.49)']},'FontSize',10)
% 
% PIothers=diag(piNT)+piT-diag(diag(diag(piNT)+piT));
% PIothers=PIothers./(sum(PIothers')'*ones(1,N));
% PIothersb=diag(piNTb)+piTb-diag(diag(diag(piNTb)+piTb));
% PIothersb=PIothersb./(sum(PIothersb')'*ones(1,N));
% 
% 
% xmin=min((PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt))./(PIothers*TFP0_al0(:,ibt)));
% xmax=max((PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt))./(PIothers*TFP0_al0(:,ibt)));
% 
% rango=linspace(xmin,xmax,1000);
% X=[ones(N,1) ...
%     (PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt))./(PIothers*TFP0_al0(:,ibt))];
% [b_fig3b b_fig3b_int R_fig3b]=regress(log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),X);    
% temp=(R_fig3b'*R_fig3b)*inv(X'*X)/(N-2);
% sb_fig3b=diag(temp).^.5;
% subplot(1,3,3),plot((PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt))./(PIothers*TFP0_al0(:,ibt)) ...
%     ,log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),'.','MarkerSize',10)
% line(rango,[b_fig3b(1)+b_fig3b(2)*rango],'LineWidth',2,'Color','r')
% xlabel(' \Pi_0 \Delta log TFP','FontSize',12)
% set(gca,'FontSize',11)
% axis([0.04 .1 -1.5 1.5])
% text(.05,-1.1,{'slope  =  -0.59',[blanks(13) ' (1.19)']},'FontSize',10)
% 
% set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
% set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.
% 
% 
% ibt=7;
% figure(3)
% rango=linspace(min(log(pi_ii_T_all(:,ibt)./pi_ii_T_k0(:,ibt))) ...
%     ,max(log(pi_ii_T_all(:,ibt)./pi_ii_T_k0(:,ibt))),1000);
% X=[ones(N,1) log(pi_ii_T_all(:,ibt)./pi_ii_T_k0(:,ibt))];
% [b_fig1b b_fig1b_int R_fig1b]=regress(log(TFPT_all(:,ibt)./TFPT_k0(:,ibt)) ...
%     ,X);
% temp=(R_fig1b'*R_fig1b)*inv(X'*X)/(N-2);
% sb_fig1b=diag(temp).^.5;
% subplot(1,3,1),plot(log(pi_ii_T_all(:,ibt)./pi_ii_T_k0(:,ibt)) ...
%     ,log(TFPT_all(:,ibt)./TFPT_k0(:,ibt)),'.','MarkerSize',10)
% xlabel('\Delta log \pi_{ii}','FontSize',12)
% ylabel('\Delta log TFP','FontSize',12)
% set(gca,'FontSize',11)
% line(rango,[b_fig1b(1)+b_fig1b(2)*rango],'LineWidth',2,'Color','r')
% axis([-.3 .1 -1.5 1.5])
% text(-.26,-1.1,{'slope  =  -0.85',[blanks(15) '(0.11)']},'FontSize',10)
% 
% % piT_0_al0 piT_T_al0 piNT_0_al0 piNT_T_al0
% 
% piNT=piNT_T_ka0(:,ibt);
% piNTb=piNT_T_all(:,ibt);
% piT=reshape(piT_T_ka0(:,ibt),N,N);
% piTb=reshape(piT_T_all(:,ibt),N,N);
% 
% rango=linspace(min(((diag(piNTb)+piTb)-(diag(piNT)+piT))*TFPT_k0(:,ibt)) ...
%     ,max(((diag(piNTb)+piTb)-(diag(piNT)+piT))*TFPT_k0(:,ibt)),1000);
% X=[ones(N,1) ((diag(piNTb)+piTb)-(diag(piNT)+piT))*TFPT_k0(:,ibt)];
% [b_fig2b b_fig2b_int R_fig2b]=regress(log(TFPT_all(:,ibt)./TFPT_k0(:,ibt)) ...
%     ,X);
% temp=(R_fig2b'*R_fig2b)*inv(X'*X)/(N-2);
% sb_fig2b=diag(temp).^.5;
% subplot(1,3,2),plot(((diag(piNTb)+piTb)-(diag(piNT)+piT))*TFPT_k0(:,ibt) ...
%     ,log(TFPT_all(:,ibt)./TFPT_k0(:,ibt)),'.','MarkerSize',10)
% xlabel('(\Delta \Pi) TFP_0','FontSize',12)
% set(gca,'FontSize',11)
% line(rango,[b_fig2b(1)+b_fig2b(2)*rango],'LineWidth',2,'Color','r')
% axis([-.04 .04 -1.5 1.5])
% text(-0.025,-1.1,{'slope  =   3.55',[blanks(15) '(0.49)']},'FontSize',10)
% 
% PIothers=diag(piNT)+piT-diag(diag(diag(piNT)+piT));
% PIothers=PIothers./(sum(PIothers')'*ones(1,N));
% PIothersb=diag(piNTb)+piTb-diag(diag(diag(piNTb)+piTb));
% PIothersb=PIothersb./(sum(PIothersb')'*ones(1,N));
% 
% 
% xmin=min((PIothers)*(TFPT_all(:,ibt)-TFPT_k0(:,ibt))./(PIothers*TFPT_k0(:,ibt)));
% xmax=max((PIothers)*(TFPT_all(:,ibt)-TFPT_k0(:,ibt))./(PIothers*TFPT_k0(:,ibt)));
% 
% rango=linspace(xmin,xmax,1000);
% X=[ones(N,1) ...
%     (PIothers)*(TFPT_all(:,ibt)-TFPT_k0(:,ibt))./(PIothers*TFPT_k0(:,ibt))];
% [b_fig3b b_fig3b_int R_fig3b]=regress(log(TFPT_all(:,ibt)./TFPT_k0(:,ibt)),X);    
% temp=(R_fig3b'*R_fig3b)*inv(X'*X)/(N-2);
% sb_fig3b=diag(temp).^.5;
% subplot(1,3,3),plot((PIothers)*(TFPT_all(:,ibt)-TFPT_k0(:,ibt))./(PIothers*TFPT_k0(:,ibt)) ...
%     ,log(TFPT_all(:,ibt)./TFPT_k0(:,ibt)),'.','MarkerSize',10)
% line(rango,[b_fig3b(1)+b_fig3b(2)*rango],'LineWidth',2,'Color','r')
% xlabel(' \Pi_0 \Delta log TFP','FontSize',12)
% set(gca,'FontSize',11)
% axis([0.04 .1 -1.5 1.5])
% text(.05,-1.1,{'slope  =  -0.59',[blanks(13) ' (1.19)']},'FontSize',10)
% 
% set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
% set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.
% 
% 
