clear all
close all

global ep mu et th bt ga Ga1 Ga2 L N adjust_w adjust_la imax toler

ep=1.01;
mu=.5;
th=4;
et=0.48;

bt=.6;

adjust_w=.25; % update of the tatonnement process
adjust_la=.1; % update of the tatonnement process

Ga1=gamma(1+(1-ep)/th);

% gdp_type = 1; % output side
gdp_type = 0; % expenditure side

% load trade.txt
% load pwt.txt
% trade=load('trade_small.txt');
% pwt=load('pwt_small.txt');
% trade=load('trade_small_2.txt');
% pwt=load('pwt_small_2.txt');
trade=load('trade_small_3.txt');
pwt=load('pwt_small_3.txt');
temp=load('deflator.txt');
deflator=temp(:,2);

tt=(1962:2000)';
T=length(tt);
N=length(trade(:,1))^.5;

ii=trade(1:N,2);
iUS=find(trade(1:N,2)==87);
iKorea=find(trade(1:N,2)==47);
iChina=find(trade(1:N,2)==15);
iTaiwan=find(trade(1:N,2)==77);
iThailand=find(trade(1:N,2)==79);
iNiger=find(trade(1:N,2)==60);
iZambia=find(trade(1:N,2)==89);
iBelgium=find(trade(1:N,2)==6);
iIndia=find(trade(1:N,2)==37);
iBolivia=find(trade(1:N,2)==8);
iParaguay=find(trade(1:N,2)==64);
iSenegal=find(trade(1:N,2)==69);
iGermany=find(trade(1:N,2)==31);
iFrance=find(trade(1:N,2)==28);
iNetherlands=find(trade(1:N,2)==58);
iAustria=find(trade(1:N,2)==3);
iItaly=find(trade(1:N,2)==42);
iUK=find(trade(1:N,2)==85);
iSwitzerland=find(trade(1:N,2)==75);

% jj=find(trade(1:N,2)==6); % Belgium
% jj_hood=[iNetherlands iGermany iFrance iUK];
jj=find(trade(1:N,2)==75); % Switzerland
jj_hood=[iAustria iFrance iGermany iItaly];

% create [T,N] matrix for each variable in pwt
pop=reshape(pwt(:,2),T,N)';
emp=reshape(pwt(:,3),T,N)';
hc=reshape(pwt(:,4),T,N)';
gdpr=reshape(pwt(:,6),T,N)'*1000;
% output-side
if gdp_type == 1
    gdpn=reshape(pwt(:,8).*pwt(:,13),T,N)'*1000;
    gdpr0=reshape(pwt(:,8),T,N)'*1000;
% expenditure-side 
else
    gdpn=reshape(pwt(:,14).*pwt(:,15),T,N)'*1000;
    gdpr0=reshape(pwt(:,14),T,N)'*1000;
end
k=reshape(pwt(:,7),T,N)'*1000; % rkna, Capital stock at constant 2005 national prices (in mil. 2005US$)
k0=reshape(pwt(:,9),T,N)'*1000; % ck, Capital stock at current PPPs (in mil. 2005US$)
gdpr=gdpr.*(gdpr0(:,1)*ones(1,T))./(gdpr(:,1)*ones(1,T));
k=k.*(k0(:,1)*ones(1,T))./(k(:,1)*ones(1,T));

% measure of equipped labor normalized by US
% L=k.^(1/3).*(pop.*hc).^(2/3);
% L=k.^(1/3).*(emp.*hc).^(2/3);
ze = 0.36;
L=k.^(ze).*(emp.*hc).^(1 - ze);


L=L/L(iUS,1);

% Real GDP per Capita normalized by US in 1962
y=(gdpr/gdpr(iUS,1))./L;
% y=(gdpr)./L;

% share of merchandixe imports at current PPP
m_gdp=reshape(pwt(:,10),T,N)';

% price level
% p_data=reshape(pwt(:,13),T,N)'; % pl_gdpo, Price level of CGDPo (PPP/XR),  price level of USA GDPo in 2005=1
% p_data=reshape(pwt(:,15),T,N)'; % pl_gdpe, Price level of CGDPe (PPP/XR),  price level of USA GDPo in 2005=1
p_data=gdpn./gdpr;

Y_data=gdpn./(ones(N,1)*p_data(iUS,:)); % in dollars of 2005
Y_data=Y_data./Y_data(iUS,1);

w_data=Y_data./L;

% US real gdp growth
gUS=log(y(iUS,end)/y(iUS,1))/(T-1);

for t=T
temp=reshape(trade(:,t+2),N,N)';
% temp=tril(temp)+tril(temp)';
   for i=1:N
    
        for j=1:N
            
            if j==i
                
        PI_data(i,j)=(gdpn(i,t)/(1-et)-sum(temp(:,i)))...
            /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));     
                
            else
                
        PI_data(i,j)=temp(i,j)...
            /(sum(temp(i,:))-sum(temp(:,i))+gdpn(i,t)/(1-et));                 
        
            end
            
        end
        
   end
 
PI_t(:,t)=reshape(PI_data,N*N,1);
    
for i=1:N
        im(i,t)=sum(temp(i,:));
        ex(i,t)=sum(temp(:,i));
%         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z',0,1,[],imp(i,t)/gdpn(i,t));
% m_E_data(i,t)=im(i,t)*deflator(t)/((im(i,t)-ex(i,t))*deflator(t)+gdpr(i,t)/(1-et));
% m_E_data(i,t)=im(i,t)/((im(i,t)-ex(i,t))+gdpn(i,t)/(1-et));
%         [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_T',0,1,[],m_E_data(i,t));
%         pi_ii_data(i,t)=((1-mu+mu*Z(i,t).^(1-(ep-1)/th))./(1-mu+mu*Z(i,t).^(-(ep-1)/th)));
        [Z(i,t) fZ(i,t)]=fminbnd('eq_Z_pi',0,1,[],PI_data(i,i));
        pi_ii_data(i,t)=PI_data(i,i);
%         Tb(i,t)=(im(i,t)-ex(i,t))*deflator(t)/gdpr(i,t);
%        Tb(i,t)=0;
%         T(i,t)=(im(i,t)-ex(i,t))*deflator(t)/sum(gdpr(:,t));
%         Tr(i,t)=(im(i,t)-ex(i,t))/sum(gdpn(:,t));
%         Trdollars(i,t)=(im(i,t)-ex(i,t));
end

    PI_NT_t(:,t)=(1-mu)./(1-mu+mu*Z(:,t).^(-(ep-1)/th));
    
    
    PI_T=PI_data-diag(PI_NT_t(:,t));
    PI_T_t(:,t)=reshape(PI_T,N*N,1);
    
    Trdollars2(:,t)=inv(PI_data')*(gdpn(:,t)/(1-et)-PI_data'*gdpn(:,t)/(1-et));
    
    Trb(:,t)=Trdollars2(:,t)./gdpn(:,t);
    Tr(:,t)=Trdollars2(:,t)/sum(gdpn(:,t));
    
K0=zeros(N,N);

%  for i=1:N-1
%           
%      for j=i+1:N
%          
%          m(i,j)=temp(i,j)/im(i,t);
%          m(j,i)=temp(j,i)/im(j,t);
%          
%          K0(i,j)=(m(i,j)*m(j,i)...
%              *((1-Z(i,t))/Z(i,t))*((1-Z(j,t))/Z(j,t)))^(-1/(2*th));   
%    
%      end
%      
%  end
% 
% 
% K=K0+K0'+eye(N);

 for i=1:N
     
     for j=1:i-1
         
%          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%              *p_data(i,t)/p_data(j,t)...
%              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
         K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
             *p_data(i,t)/p_data(j,t)...
             *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
   
     end
     
     for j=i+1:N
         
%          K0(i,j)=(im(i,t)/temp(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
%              *p_data(i,t)/p_data(j,t)...
%              *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
         K0(i,j)=((1-PI_data(i,i))/PI_data(i,j)*Z(i,t)/(1-Z(i,t)))^(1/th)...
             *p_data(i,t)/p_data(j,t)...
             *((1-mu+mu*Z(i,t)^(-(ep-1)/th))/(1-mu+mu*Z(j,t)^(-(ep-1)/th)))^(1/(ep-1));   
   
     end
     
 end

K=K0+eye(N);

KK(:,t)=reshape(K,N*N,1);

if t==T

la0=y(:,T).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,T).^(-(ep-1)/th)).^(th/(ep-1)));

la=la0;

end

lat_cal(:,t)=(y(:,t)).^((1-et)*th)./(Ga1^(th/(ep-1)).*(1-mu+mu*Z(:,t).^(-(ep-1)/th)).^(th/(ep-1)));

end

% break

% dummy simulation

PI=reshape(PI_t(:,T),N,N);

bt=.6;

ga=gUS*(1-bt)*th;

Ga2=gamma(1-bt+(1-ep)/th);

al0=ga/(1-bt)*Ga1/Ga2*la...
    ./((1-mu)./(1-mu+mu*Z(:,T).^(-(ep-1)/th)).*la.^bt...
    +mu*Z(:,T).^(-(ep-1)/th)./(1-mu+mu*Z(:,T).^(-(ep-1)/th))...
    .*(Z(:,T).^(1-bt).*la.^bt+(1-Z(:,T)).^(1-bt)...
    .*(((PI-diag(diag(PI)))./(1-diag(PI)*ones(1,N))).^(1-bt)*la.^bt)));

al=al0;

la0t(:,1)=lat_cal(:,1);

% "dynamics" of the static model

la=lat_cal(:,T);

% Ghana Bolivia Cote d`Ivoire Senegal Kenya Zambia Tanzania Cameroon
% Uganda Mali Niger Mozambique
id=[32 8 19 69 46 89 78 11 84 50 60 56];

TT=100;

for ic=1:12
    
ii=find(trade(1:N,2)==id(ic));


for t=1:TT
    
%     la=la0*exp(ga/(1-bt)*(t-1));

if t==1
K=reshape(KK(:,T),N,N);
else
K=reshape(KK(:,T),N,N);
K(ii,:)=K(jj,:);
K(:,ii)=K(:,jj);
K(ii,jj)=mean(K(jj_hood,jj));
K(jj,ii)=mean(K(jj,jj_hood));
K(ii,ii)=1;
K(ii,ii)=1;
end

pini=Ga1^(1/(1-ep)/(1-et))*(ones(N,1).^(-(1-et)*th)'*la)^(1/(1-et))*ones(N,1);

if t==1
    toler=.00001;
    imax=300;
% w_s(:,t)=wage(ones(N,1),K,la,L(:,t));
w_s(:,t)=wage_T(ones(N,1),K,la,L(:,T),Tr(:,T));
% toler=.000000001;
% imax=300;
% [w_s(:,t) W]=wage_NR(ones(N,1),K,la,L(:,1));
p_s(:,t)=price(w_s(:,t),pini,K,la);
else
    toler=.0001;
    imax=100;
% w_s(:,t)=wage(w_s(:,t-1),K,la,L(:,t)); 
w_s(:,t)=wage_T(w_s(:,t-1),K,la,L(:,T),Tr(:,T));    
p_s(:,t)=price(w_s(:,t),p_s(:,t-1),K,la);
end


den0=(1-mu)*((p_s(:,t).^et.*w_s(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th)...
    +mu*(K.^-th*((p_s(:,t).^et.*w_s(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th);
den=den0*ones(1,N);

numT=mu*(((ones(N,1)*(p_s(:,t).^et.*w_s(:,t).^(1-et).*la.^(-1/th))').*K).^(-th))...
    .*((K.^-th*((p_s(:,t).^et.*w_s(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th-1)*ones(1,N));

numNT=(1-mu)*((p_s(:,t).^et.*w_s(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th);

piT=numT./den;

piNT=numNT./den0;
pi_ii=piNT+diag(piT);

imp_s(:,t)=(1-pi_ii).*w_s(:,t).*L(:,T)/(1-et);

y_s(:,t)=w_s(:,t).*L(:,T)./pop(:,T)./p_s(:,t);
% y_s(:,t)=w_s(:,t)./p_d(:,t);

pi_ii_s(:,t)=pi_ii;

end

TFP_i_s(ic,:)=w_s(ii,:)./p_s(ii,:)/y(iUS,end);
pi_ii_i_s(ic,:)=pi_ii_s(ii,:);


% gridbt=[.1 .25 .4 .5 .6 .75 .9];
gridbt=[.5];

for ibt=1:length(gridbt)
    
    PI=reshape(PI_t(:,T),N,N);
    
    bt=gridbt(ibt);
    
ga=gUS*(1-bt)*th;

Ga2=gamma(1-bt+(1-ep)/th);

al0=ga/(1-bt)*Ga1/Ga2*la0...
    ./((1-mu)./(1-mu+mu*Z(:,T).^(-(ep-1)/th)).*la0.^bt...
    +mu*Z(:,T).^(-(ep-1)/th)./(1-mu+mu*Z(:,T).^(-(ep-1)/th))...
    .*(Z(:,T).^(1-bt).*la0.^bt+(1-Z(:,T)).^(1-bt)...
    .*(((PI-diag(diag(PI)))./(1-diag(PI)*ones(1,N))).^(1-bt)*la0.^bt)));

al=al0;

lat(:,1)=la0;
lat_true(:,1)=la0;
lat_lafixed(:,1)=la0;
lat_pifixed(:,1)=la0;

for t=1:TT
    
PI_T=reshape(PI_T_t(:,T),N,N);

la=lat(:,t);
% la=lat_true(:,t);
    
if t==1
K=reshape(KK(:,T),N,N);
else
K=reshape(KK(:,T),N,N);
K(ii,:)=K(jj,:);
K(:,ii)=K(:,jj);
K(ii,jj)=mean(K(jj_hood,jj));
K(jj,ii)=mean(K(jj,jj_hood));
K(ii,ii)=1;
K(ii,ii)=1;
end

pini=Ga1^(1/(1-ep)/(1-et))*(ones(N,1).^(-(1-et)*th)'*la)^(1/(1-et))*ones(N,1);

    toler=.0001;
    imax=100;
if t==1
% w_d1(:,t)=wage(w_s(:,t),K,la,L(:,t));
w_d1(:,t)=wage_T(w_s(:,t),K,la,L(:,T),Tr(:,T));
p_d1(:,t)=price(w_d1(:,t),pini,K,la);
else
% w_d1(:,t)=wage(w_d1(:,t-1),K,la,L(:,t));  
w_d1(:,t)=wage_T(w_d1(:,t-1),K,la,L(:,T),Tr(:,T));
p_d1(:,t)=price(w_d1(:,t),p_d1(:,t-1),K,la);
end

den0=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th)...
    +mu*(K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th);
den=den0*ones(1,N);

numT=mu*(((ones(N,1)*(p_d1(:,t).^et.*w_d1(:,t).^(1-et).*la.^(-1/th))').*K).^(-th))...
    .*((K.^-th*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la)).^(-(1-ep)/th-1)*ones(1,N));

numNT=(1-mu)*((p_d1(:,t).^et.*w_d1(:,t).^(1-et)).^(-th).*la).^(-(1-ep)/th);

piT=numT./den;

piNT=numNT./den0;
pi_ii=piNT+diag(piT);

if t==1
    temp=piNT.*la.^bt...
        +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*la.^bt);
OmNT=piNT.*la.^bt./temp;    
OmT=((piT*ones(N,1)).^bt*(la.^bt)').*piT.^(1-bt)./(temp*ones(1,N));
A=(1/((1-et)*th))*(1./(1-bt*(OmNT+diag(OmT))));
piT_1=piT;
piNT_1=piNT;
pi_ii_1=pi_ii;
la_1=la;
end

if t==T
piT_T=piT;
piNT_T=piNT;    
pi_ii_T=pi_ii;
la_T=la;
end

% learning from sellers

lat(:,t+1)=Ga2/Ga1*al.*(piNT.*lat(:,t).^bt...
        +(piT*ones(N,1)).^bt.*(piT.^(1-bt)*lat(:,t).^bt))+(1-ga/(1-bt))*lat(:,t);

% lat_true(:,t+1)=Ga2/Ga1*al.*(PI_NT_t(:,t).*lat_true(:,t).^bt...
%         +(PI_T*ones(N,1)).^bt.*((PI_T.^(1-bt).*(diag(lat_true(:,t))+ones(N,1)*lat_cal(:,t)'-diag(lat_cal(:,t))).^bt)*ones(N,1)))...
%         +(1-ga/(1-bt))*lat_true(:,t);
lat_true(:,t+1)=Ga2/Ga1*al.*(piNT.*lat_true(:,t).^bt...
        +(piT*ones(N,1)).^bt.*((piT.^(1-bt).*(diag(lat_true(:,t))+ones(N,1)*lat_cal(:,T)'-diag(lat_cal(:,T))).^bt)*ones(N,1)))...
        +(1-ga/(1-bt))*lat_true(:,t);

    lat_lafixed(:,t+1)=Ga2/Ga1*al.*(piNT.*lat_lafixed(:,t).^bt...
        +(piT*ones(N,1)).^bt.*((piT.^(1-bt).*(diag(lat_lafixed(:,t))+ones(N,1)*la_1'-diag(la_1)).^bt)*ones(N,1)))...
        +(1-ga/(1-bt))*lat_lafixed(:,t);
    
lat_pifixed(:,t+1)=Ga2/Ga1*al.*(piNT_1.*lat_pifixed(:,t).^bt...
        +(piT_1*ones(N,1)).^bt.*((piT_1.^(1-bt).*(diag(lat_pifixed(:,t))+ones(N,1)*la'-diag(la)).^bt)*ones(N,1)))...
        +(1-ga/(1-bt))*lat_pifixed(:,t);

    imp_d1(:,t)=(1-pi_ii).*w_d1(:,t).*L(:,T)/(1-et);

y_d1(:,t)=w_d1(:,t).*L(:,T)./pop(:,T)./p_d1(:,t);

pi_ii_d1(:,t)=pi_ii;

pi_la(:,t)=(diag(piNT)+piT)*la;
pi_la0(:,t)=(diag(piNT)+piT)*la0;

end

TFP_i_d(ic,:)=w_d1(ii,:)./p_d1(ii,:)/y(iUS,end);
pi_ii_i_d(ic,:)=pi_ii_d1(ii,:);

% TFP_Niger_d(ibt,:)=w_d1(iNiger,:)./p_d1(iNiger,:);

end

end


% save TFP_i_Belgium_bt_060 TFP_i_d pi_ii_i_d TFP_i_s pi_ii_i_s

save TFP_i_Switzerland_bt_060 TFP_i_d pi_ii_i_d TFP_i_s pi_ii_i_s

