% This program calculate examples for a symmetric world
clear all
close all

global th bt ga n L al GA1 GA2 GA3 ps ep rh

nu=.01;
th=4;
bt=.05;
ep=1.01;
ps=0.1;
rh=0.1;

n=50;

gridbt=[0 .1 .5 .9];

N=20;

kk=sort(1./linspace(1/100,1,N))';

for ibt=1:length(gridbt)
 
    bt=gridbt(ibt);
    
    ga=nu*th*(1-bt);
   
    GA1=gamma(1-bt+(1-ep)/th);
    GA2=gamma(1+(1-ep)/th);
    GA3=GA2^(th/(ep-1)*bt+1);

    al=1/(GA1/GA2*(1-bt)/ga*n^bt)

la(:,ibt)=((1-bt)*al/ga*GA1/GA2...
    *(1+(n-1)*kk.^(-th*(1-bt)))./(1+(n-1).*kk.^(-th)).^(1-bt)).^(1/(1-bt));
la_pu(:,ibt)=((1-bt)*al/ga*GA1/GA2...
    *(1+(n-1)*kk.^(-th)).^bt).^(1/(1-bt));

own(:,ibt)=1./(1+(n-1).*kk.^(-th));
y(:,ibt)=GA2^(-1/(1-ep)).*la(:,ibt).^(1/th).*(1+(n-1).*kk.^(-th)).^(1/th);
y_pu(:,ibt)=GA2^(-1/(1-ep)).*la_pu(:,ibt).^(1/th).*(1+(n-1).*kk.^(-th)).^(1/th);
    
end

yEK=GA2^(-1/(1-ep)).*(1+(n-1).*kk.^(-th)).^(1/th);

% Figure 1 in the paper

figure(1)

% subplot(1,2,1),plot(1./kk,ones(length(kk),1),'k:',1./kk,la(:,1).^(1/th),'b-.',1./kk,la(:,2).^(1/th),'r--',1./kk,la(:,3).^(1/th),'g-',...
% 'LineWidth',2)
subplot(2,2,1),plot(0:.1:4,zeros(length(0:.1:4),1),'k:',-log(own(:,2)),log(la(:,2).^(1/th)),'b-.',-log(own(:,3)),log(la(:,3).^(1/th)),'r--',-log(own(:,4)),log(la(:,4).^(1/th)),'g-',...
'LineWidth',2)
axis([0 4 -1 0.01])
% set(gca,'XScale','log');
% set(gca,'XTick',[.01 .1 .5 1])
% set(gca,'XTickLabel',{'0.01','0.1','0.5','1'})
% axis([0.01 1 0 1])
LEG=legend('$\beta = 0$',['$\beta = $' num2str(gridbt(2))]...
    ,['$\beta = $' num2str(gridbt(3))]...
    ,['$\beta = $' num2str(gridbt(4))],'Location','SouthEast');
legend boxoff
set(LEG,'Interpreter','LaTex');

% xlabel('openness, 1/\kappa','FontSize',12)
xlabel('openness, $-\log \pi_{ii}$','FontSize',14,'Interpreter','LaTex')
title({'\ \ \textbf{Lerning from Sellers}','\ \ \ \ stock of knowledge'},'FontSize',12,'Interpreter','LaTex','HorizontalAlignment', 'center')
ylabel('$(1/\theta) \log (\lambda)$','FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',14)
set(gca,'TickLabelInterpreter','latex')

subplot(2,2,2),plot(0:.1:4,zeros(length(0:.1:4),1),'k:',-log(own(:,1)),log(la_pu(:,2).^(1/th)),'b-.',-log(own(:,2)),log(la_pu(:,3).^(1/th)),'r--',-log(own(:,3)),log(la_pu(:,4).^(1/th)),'g-',...
'LineWidth',2)
axis([0 4 -1 0.01])
% set(gca,'XScale','log');
% set(gca,'XTick',[.01 .1 .5 1])
% set(gca,'XTickLabel',{'0.01','0.1','0.5','1'})
% axis([0.01 1 0 1])
% legend('\beta = 0',['\beta = ' num2str(gridbt(2))]...
%     ,['\beta = ' num2str(gridbt(3))]...
%     ,['\beta = ' num2str(gridbt(4))],'Location','SouthEast')
% legend boxoff

xlabel('openness, $-\log \pi_{ii}$','FontSize',14,'Interpreter','LaTex')
title({' \textbf{Learning from Producers}','\ \ \ \ \ \ \ stock of knowledge'},'FontSize',12,'Interpreter','LaTex')
ylabel('$(1/\theta) \log (\lambda)$','FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',14)
set(gca,'TickLabelInterpreter','latex')

% subplot(1,2,2),plot(1./kk,yEK./yEK(1),'k:',1./kk,y(:,1)/y(1,1),'b-.',1./kk,y(:,2)/y(1,2),'r--'...
%     ,1./kk,y(:,3)/y(1,3),'g-','LineWidth',2)
subplot(2,2,3),plot(-log(own(:,1)),log(yEK./yEK(1)),'k:',-log(own(:,1)),log(y(:,2)/y(1,2)),'b-.',-log(own(:,3)),log(y(:,3)/y(1,3)),'r--'...
    ,-log(own(:,3)),log(y(:,4)/y(1,4)),'g-','LineWidth',2)
% subplot(1,2,2),plot(-log(own),log(yEK./yEK(1)),'k:',-log(own),log(y(:,1)/y(1,1)),'b-.',-log(own),log(y(:,2)/y(1,2)),'r--'...
%     ,-log(own),log(y(:,3)/y(1,3)),'g-','LineWidth',2)
axis([0 4 -2 0])
% xlabel('openness, 1/\kappa','FontSize',12)
xlabel('openness, $-\log \pi_{ii}$','FontSize',14,'Interpreter','LaTex')
title('per-capita income','FontSize',14,'Interpreter','LaTex')
ylabel('$\log (y)$','FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',14)
set(gca,'TickLabelInterpreter','latex')

subplot(2,2,4),plot(-log(own(:,1)),log(yEK./yEK(1)),'k:',-log(own(:,1)),log(y_pu(:,2)/y_pu(1,2)),'b-.',-log(own(:,3)),log(y_pu(:,3)/y_pu(1,3)),'r--'...
    ,-log(own(:,3)),log(y_pu(:,4)/y_pu(1,4)),'g-','LineWidth',2)
% subplot(1,2,2),plot(-log(own),log(yEK./yEK(1)),'k:',-log(own),log(y(:,1)/y(1,1)),'b-.',-log(own),log(y(:,2)/y(1,2)),'r--'...
%     ,-log(own),log(y(:,3)/y(1,3)),'g-','LineWidth',2)
axis([0 4 -2 0])
% xlabel('openness, 1/\kappa','FontSize',12)
xlabel('openness, $-\log \pi_{ii}$','FontSize',14,'Interpreter','LaTex')
title('per-capita income','FontSize',14,'Interpreter','LaTex')
ylabel('$\log (y)$','FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',14)
set(gca,'TickLabelInterpreter','latex')

% break

% subplot(1,2,1),plot(1./kk,ones(length(kk),1),'k:',1./kk,la(:,1).^(1/th),'b--',1./kk,la(:,2).^(1/th),'r-',1./kk,100*la(:,3).^(1/th),'g-o',...
% 1./kk,la(:,3).^(1/th),'g-',1./kk(1:100:length(kk)),la(1:100:length(kk),3).^(1/th),'go','LineWidth',2)
% axis([0 1 0 1])
% legend('\beta = 0',['\beta = ' num2str(gridbt(1))]...
%     ,['\beta = ' num2str(gridbt(2))]...
%     ,['\beta = ' num2str(gridbt(3))],'Location','SouthEast')
% legend boxoff
% 
% xlabel('openness, 1/\kappa','FontSize',12)
% title('Stock of Ideas, \lambda^{1/\theta}','FontSize',12)
% set(gca,'FontSize',12)
% 
% subplot(1,2,2),plot(1./kk,yEK./yEK(1),'k:',1./kk,y(:,1)/y(1,1),'b--',1./kk,y(:,2)/y(1,2),'r-'...
%     ,1./kk,y(:,3)/y(1,3),'g-',1./kk(1:100:length(kk)),y((1:100:length(kk)),3)/y(1,3),'go','LineWidth',2)
% axis([0 1 0 1])
% xlabel('openness, 1/\kappa','FontSize',12)
% title('per-capita income','FontSize',12)
% set(gca,'FontSize',12)

set(gcf, 'PaperPosition', [0 0 6.5 6.5]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6.5 6.5]); %Set the paper to have width 5 and height 5.
% saveas(gcf, 'figure_1_02', 'pdf') %Save figure

% Figure OA.14 in the online appendix

figure(2)

% subplot(1,2,1),plot(1./kk,ones(length(kk),1),'k:',1./kk,la(:,1).^(1/th),'b-.',1./kk,la(:,2).^(1/th),'r--',1./kk,la(:,3).^(1/th),'g-',...
% 'LineWidth',2)
subplot(2,2,1),plot(0:.1:1,ones(length(0:.1:1),1),'k:',kk.^(-1),la(:,2).^(1/th),'b-.',kk.^(-1),la(:,3).^(1/th),'r--',kk.^(-1),la(:,4).^(1/th),'g-',...
'LineWidth',2)
axis([0 1 0 1])
% set(gca,'XScale','log');
% set(gca,'XTick',[.01 .1 .5 1])
% set(gca,'XTickLabel',{'0.01','0.1','0.5','1'})
% axis([0.01 1 0 1])
legend('\beta = 0',['\beta = ' num2str(gridbt(2))]...
    ,['\beta = ' num2str(gridbt(3))]...
    ,['\beta = ' num2str(gridbt(4))],'Location','SouthEast')
legend boxoff

xlabel('openness, $1/\kappa$','FontSize',14,'Interpreter','LaTex')
ylabel('$\lambda^{1/\theta }$','FontSize',14,'Interpreter','LaTex')
title({'\textbf{Lerning from Sellers}','\ \ \ \ stock of knowledge'},'FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',14)
set(gca,'TickLabelInterpreter','latex')

subplot(2,2,2),plot(0:.1:1,ones(length(0:.1:1),1),'k:',kk.^(-1),la_pu(:,2).^(1/th),'b-.',kk.^(-1),la_pu(:,3).^(1/th),'r--',kk.^(-1),la_pu(:,4).^(1/th),'g-',...
'LineWidth',2)
axis([0 1 0 1])
% set(gca,'XScale','log');
% set(gca,'XTick',[.01 .1 .5 1])
% set(gca,'XTickLabel',{'0.01','0.1','0.5','1'})
% axis([0.01 1 0 1])
% legend('\beta = 0',['\beta = ' num2str(gridbt(2))]...
%     ,['\beta = ' num2str(gridbt(3))]...
%     ,['\beta = ' num2str(gridbt(4))],'Location','SouthEast')
% legend boxoff

xlabel('openness, $1/\kappa$','FontSize',14,'Interpreter','LaTex')
ylabel('$\lambda^{1/\theta }$','FontSize',14,'Interpreter','LaTex')
title({'\textbf{Learning from Producers}','\ \ \ \ stock of knowledge'},'FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',14)
set(gca,'TickLabelInterpreter','latex')

% subplot(1,2,2),plot(1./kk.^(-1),yEK./yEK(1),'k:',1./kk.^(-1),y(:,1)/y(1,1),'b-.',1./kk.^(-1),y(:,2)/y(1,2),'r--'...
%     ,1./kk.^(-1),y(:,3)/y(1,3),'g-','LineWidth',2)
subplot(2,2,3),plot(kk.^(-1),yEK./yEK(1),'k:',kk.^(-1),y(:,2)/y(1,2),'b-.',kk.^(-1),y(:,3)/y(1,3),'r--'...
    ,kk.^(-1),y(:,4)/y(1,4),'g-','LineWidth',2)
% subplot(1,2,2),plot(-log(own),log(yEK./yEK(1)),'k:',-log(own),log(y(:,1)/y(1,1)),'b-.',-log(own),log(y(:,2)/y(1,2)),'r--'...
%     ,-log(own),log(y(:,3)/y(1,3)),'g-','LineWidth',2)
% axis([0 1 0 1])
% xlabel('openness, 1/\kappa','FontSize',12)
xlabel('openness, $1/\kappa$','FontSize',14,'Interpreter','LaTex')
title('per-capita income','FontSize',14,'Interpreter','LaTex')
ylabel('$y$','FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',14)
set(gca,'TickLabelInterpreter','latex')

subplot(2,2,4),plot(kk.^(-1),yEK./yEK(1),'k:',kk.^(-1),y_pu(:,2)/y_pu(1,2),'b-.',kk.^(-1),y_pu(:,3)/y_pu(1,3),'r--'...
    ,kk.^(-1),y_pu(:,4)/y_pu(1,4),'g-','LineWidth',2)
% subplot(1,2,2),plot(-log(own),log(yEK./yEK(1)),'k:',-log(own),log(y(:,1)/y(1,1)),'b-.',-log(own),log(y(:,2)/y(1,2)),'r--'...
%     ,-log(own),log(y(:,3)/y(1,3)),'g-','LineWidth',2)
% axis([0 1 0 1])
% xlabel('openness, 1/\kappa','FontSize',12)
xlabel('openness, $1/\kappa$','FontSize',14,'Interpreter','LaTex')
ylabel('$y$','FontSize',14,'Interpreter','LaTex')
title('per-capita income','FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',14)
set(gca,'TickLabelInterpreter','latex')

set(gcf, 'PaperPosition', [0 0 6.5 6.5]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6.5 6.5]); %Set the paper to have width 5 and height 5.
% saveas(gcf, 'figure_1_appendix', 'pdf') %Save figure
