clear all
close all

% gdp_type = 1; % output side
gdp_type = 0; % expenditure side

% pwt=load('pwt_small_2.txt');
% ii=load('ii_small_2.txt');
pwt=load('pwt_small_3.txt');
ii=load('ii_small_3.txt');

tt=(1962:2000)';
T=length(tt);
N=length(ii);

iUS=find(ii==87);

% pop=reshape(pwt(:,2),T,N)';
% emp=reshape(pwt(:,3),T,N)';
% hc=reshape(pwt(:,4),T,N)';
% gdpn=reshape(pwt(:,5),T,N)'*1000;
% gdpr=reshape(pwt(:,8),T,N)'*1000;
% k=reshape(pwt(:,9),T,N)'*1000;
% % L=k.^(1/3).*(pop.*hc).^(2/3);
% L=k.^(1/3).*(emp.*hc).^(2/3);

pop=reshape(pwt(:,2),T,N)';
emp=reshape(pwt(:,3),T,N)';
hc=reshape(pwt(:,4),T,N)';
gdpr=reshape(pwt(:,6),T,N)'*1000;
% output-side
if gdp_type == 1
    gdpn=reshape(pwt(:,8).*pwt(:,13),T,N)'*1000;
    gdpr0=reshape(pwt(:,8),T,N)'*1000;
% expenditure-side 
else
    gdpn=reshape(pwt(:,14).*pwt(:,15),T,N)'*1000;
    gdpr0=reshape(pwt(:,14),T,N)'*1000;
end
k=reshape(pwt(:,7),T,N)'*1000;
k0=reshape(pwt(:,9),T,N)'*1000;
gdpr=gdpr.*(gdpr0(:,1)*ones(1,T))./(gdpr(:,1)*ones(1,T));
k=k.*(k0(:,1)*ones(1,T))./(k(:,1)*ones(1,T));
% measure of equipped labor normalized by US
% L=k.^(1/3).*(pop.*hc).^(2/3);
% L=k.^(1/3).*(emp.*hc).^(2/3);
ze = 0.36;
L=k.^(ze).*(emp.*hc).^(1 - ze);

L=L(:,1)/L(iUS,1);
y=(gdpr(:,1)/gdpr(iUS,1))./L;

load stst_s_nu_0_cal4_th_04

y_s=y_ss./(ones(N,1)*y_ss(iUS,:));

TFP_common_al=y_s;

for i=1:length(y_s(1,:))
[b_s4(:,i) temp1 temp2 temp3 temp4]=regress(log(y_s(:,i))-mean(log(y_s(:,i)))...
    ,[ones(N,1) log(y)-mean(log(y))]);
end

% Figure OA.8 in the online appendix

figure(1)
ibt=6;
subplot(1,2,1), plot(log(y)-mean(log(y))...
    ,log(y_s(:,1))-mean(log(y_s(:,1))),'.','MarkerSize',10)
line([-2 1],b_s4(1,1)+b_s4(2,1)*[-2 1],'LineWidth',2,'Color','r')
axis([-1 1 -.5 .5])
% xlabel('log(TFP) net of scale, data','FontSize',12)
ylabel('$\log(TFP)$, model','FontSize',12,'Interpreter','LaTex')
title('\textbf{Static} ($\beta = 0$)','FontSize',14,'Interpreter','LaTex')
line([-2 1],[-2 1],...
        'LineWidth',1,'LIneStyle','--','Color','k')
xlabel('$\log(TFP)$, data','FontSize',12,'Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
text(-.8,.4,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_s4(2,1))))},'Interpreter','LaTex','FontSize',12)

subplot(1,2,2), plot(log(y)-mean(log(y))...
    ,log(y_s(:,ibt))-mean(log(y_s(:,ibt))),'.','MarkerSize',10)
line([-2 1],b_s4(1,5)+b_s4(2,5)*[-2 1],'LineWidth',2,'Color','r')
axis([-1 1 -.5 .5])
% xlabel('log(TFP) net of scale, data','FontSize',12)
% ylabel('log(TFP) net of scale, model','FontSize',12)
title('\textbf{Dynamic} ($\beta = 0.6$)','FontSize',14,'Interpreter','LaTex')
line([-2 1],[-2 1],...
        'LineWidth',1,'LIneStyle','--','Color','k')
xlabel('$\log(TFP)$, data','FontSize',12,'Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
text(-.8,.4,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_s4(2,5))))},'Interpreter','LaTex','FontSize',12)

set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.
% saveas(gcf, 'fig_stst_1_raw', 'pdf') %Save figure


for i=1:length(gridbt)
    
MSE_common_al_s(i)=mean((log(y)-mean(log(y))-(log(y_s(:,i))-mean(log(y_s(:,i))))).^2)^.5;

end

% Figure OA.11 in the online appendix

figure(2)
rango=linspace(min(log(pi_ss(:,6))),max(log(pi_ss(:,6))),2);
X=[ones(N,1) log(pi_ss(:,6))];
[b_fig1 b_fig1_int R_fig1 temp stat_fig1]=regress(log(y_s(:,6)),X);
temp=(R_fig1'*R_fig1)*inv(X'*X)/(N-2);
sb_fig1=diag(temp).^.5;

subplot(1,2,1),plot(log(pi_ss(:,6)),log(y_s(:,6)),'.','MarkerSize',10)
line(rango,[b_fig1(1)+b_fig1(2)*rango],'LineWidth',2,'LineStyle','-','Color','b')
xlabel('$\log \pi_{ii}$','FontSize',12,'Interpreter','LaTex')
ylabel('$\log TFP$','FontSize',12,'Interpreter','LaTex')
title('Openness','FontSize',12)
line(rango,[b_fig1(1)+b_fig1(2)*rango],'LineWidth',2,'Color','r')
set(gca,'FontSize',12)
axis([-.2 0 -.5 .5])
% text(-.18,-2,{strcat('slope =',num2str(sprintf('%0.2f',b_fig1(2)))), ...
%     [blanks(13) strcat('(',num2str(sprintf('%0.2f',sb_fig1(2))),')')]},'FontSize',11)
text(-.18,-.4,{['slope =' blanks(1)  num2str(sprintf('%0.2f',b_fig1(2)))], ...
    [ strcat(' \ \ \ \ \ \ \ \ \ \ (',num2str(sprintf('%0.2f',sb_fig1(2))),')')]},'FontSize',11,'Interpreter','LaTex')

piNT=piNT_ss(:,6);
piT=reshape(piT_ss(:,6),N,N);
PIothers=diag(piNT)+piT-diag(diag(diag(piNT)+piT));
PIothers=PIothers./(sum(PIothers')'*ones(1,N));

rango=linspace(min(log((PIothers)*y_s(:,6))),max(log((PIothers)*y_s(:,6))),1000);
X=[ones(N,1) (PIothers)*log(y_s(:,6))];
[b_fig2 b_fig2_int R_fig2]=regress(log(y_s(:,6)),X);    
temp=(R_fig2'*R_fig2)*inv(X'*X)/(N-2);
sb_fig2=diag(temp).^.5;
subplot(1,2,2),plot((PIothers)*log(y_s(:,6)),log(y_s(:,6)),'.','MarkerSize',10)
line(rango,[b_fig2(1)+b_fig2(2)*rango],'LineWidth',2,'Color','r')
xlabel('$(\pi_{i,-i}/(1-\pi_{ii})) \log TFP_{-i}$','Interpreter','LaTex')
title('Quality of trade','FontSize',12)
set(gca,'FontSize',12)
axis([0 .3 -.5 .5])
% text(-.20,-2,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_fig2(2)))), ...
%     [blanks(14) strcat('(',num2str(sprintf('%0.2f',sb_fig2(2))),')')]},'FontSize',11)
text(.17,-.4,{['slope  =' blanks(1) num2str(sprintf('%0.2f',b_fig2(2)))], ...
    [ strcat('\ \ \ \ \ \ \ \ \ \ (',num2str(sprintf('%0.2f',sb_fig2(2))),')')]},'FontSize',11,'Interpreter','LaTex')
set(gcf, 'PaperPosition', [0 0 6 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6 3]); %Set the paper to have width 5 and height 5.

% load stst_cal_al_s
load stst_cal_al_s_02
% load stst_cal_al_s_02_mu_50
% load stst_cal_al_s_02_mu_50_output

TFP_all=TFP_data;
TFP_common_k=TFP_common_k_s;

V0011=var(log((TFP_all*ones(1,9))./TFP_0));
V0001=var(log(TFP_common_al./TFP_0));
V0111=var(log((TFP_all*ones(1,9))./TFP_common_al));
V0010=var(log(TFP_common_k./TFP_0));
V1011=var(log((TFP_all*ones(1,9))./TFP_common_k));

% Figure OA.9 in the online appendix

figure(3)
subplot(1,2,1),plot(gridbt,1-V0010./V0011,'r--' ...
    ,gridbt,1-V0111./V0011,'b-' ...
    , gridbt,V1011./V0011,'r--s' ...
    ,gridbt,V0001./V0011,'b-s','LineWidth',2)
axis([0 1 0 .6])
temp=1-V0010./V0011;
text(gridbt(7)-.2,temp(7)+.05,'$\alpha$ hetero., w/ cov.','Interpreter','LaTex')
temp=1-V0111./V0011;
text(gridbt(7)-.32,temp(7)+.025,'$\alpha$ common, w/ cov.','Interpreter','LaTex')
temp=V1011./V0011;
text(gridbt(7)-.2,temp(7)+.025,'$\alpha$ hetero., w/o cov.','Interpreter','LaTex')
temp=V0001./V0011;
text(gridbt(7)-.2,temp(7)-.09,'$\alpha$ common, w/o cov.','Interpreter','LaTex')

% title('learning from sellers','FontSize',11)
% legend('\alpha varying, incl. cov.' ...
%  ,'\alpha constant, incl. cov.' ...
%  ,'\alpha varying, excl. cov.' ...
% ,'\alpha constant, excl. cov.','Location','NorthWest')
% legend boxoff
ylabel('Fraction explained by trade','FontSize',12,'Interpreter','LaTex')
xlabel('\beta')
title('\textbf{Cross-Sectional Variance, 1962}','FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
% box off


load stst_s_nu_0_cal4_th_05_2000

y_s=y_ss./(ones(N,1)*y_ss(iUS,:));

TFP_common_al=y_s;

load stst_cal_al_s_02_2000

TFP_all=TFP_data;
TFP_common_k=TFP_common_k_s;

V0011=var(log((TFP_all*ones(1,8))./TFP_0));
V0001=var(log(TFP_common_al./TFP_0));
V0111=var(log((TFP_all*ones(1,8))./TFP_common_al));
V0010=var(log(TFP_common_k./TFP_0));
V1011=var(log((TFP_all*ones(1,8))./TFP_common_k));

subplot(1,2,2),plot(gridbt,1-V0010./V0011,'r--' ...
    ,gridbt,1-V0111./V0011,'b-' ...
    , gridbt,V1011./V0011,'r--s' ...
    ,gridbt,V0001./V0011,'b-s','LineWidth',2)
axis([0 1 0 .6])
% title('learning from sellers','FontSize',11)
% legend('\alpha varying, incl. cov.' ...
%  ,'\alpha constant, incl. cov.' ...
%  ,'\alpha varying, excl. cov.' ...
% ,'\alpha constant, excl. cov.','Location','East')
% legend boxoff
xlabel('$\beta$','Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
title('\textbf{Cross-Sectional Variance, 2000}','FontSize',14,'Interpreter','LaTex')

set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.
set(gca,'FontSize',12)


