clear all
close all

th=4;

% save trans_k0_al0_s_02 MSE_all TFP0_all TFPT_all dTFP_all TFP_Korea_all TFP_China_all TFP_Taiwan_all TFP_Thailand_all TFP_US_all ...
%     MSE_k0 TFP0_k0 TFPT_k0 dTFP_k0 TFP_Korea_k0 TFP_China_k0 TFP_Taiwan_k0 TFP_Thailand_k0 TFP_US_k0 ...
%     MSE_al0 TFP0_al0 TFPT_al0 dTFP_al0 TFP_Korea_al0 TFP_China_al0 TFP_Taiwan_al0 TFP_Thailand_al0 TFP_US_al0 alpha0 alphaT ...
%     pi_ii_0_all pi_ii_T_all pi_ii_0_k0 pi_ii_T_k0 pi_ii_0_al0 pi_ii_T_al0 ...
%     la0_all laT_all la0_k0 laT_k0 la0_al0 laT_al0 Z_0_all Z_T_all Z_0_k0 Z_T_k0 Z_0_al0 Z_T_al0 TFP_fixed_la TFP_fixed_pi ga_bt

% load trans_k0_al0_s_phi
load trans_k0_al0_s_phi_02

N=length(TFP0_all(:,1));
T=length(TFP_China_all(1,:));

TFP_China_all_s=TFP_China_all;
TFP_China_al0_s=TFP_China_al0;
TFP_Korea_all_s=TFP_Korea_all;
TFP_Korea_al0_s=TFP_Korea_al0;
TFP_Taiwan_all_s=TFP_Taiwan_all;
TFP_Taiwan_al0_s=TFP_Taiwan_al0;
TFP_Thailand_all_s=TFP_Thailand_all;
TFP_Thailand_al0_s=TFP_Thailand_al0;

bb=linspace(0,.9,100);
bb2=linspace(0,.9,10);

% gridbt=[0 .1 .25 .4 .5 .6 .7 .75 .9 .95];
gridbt=[0 .1 .25 .4 .5 .6];

V0011=var(log(TFPT_all./TFP0_all));
V0001=var(log(TFPT_al0./TFP0_all));
V0111=var(log(TFPT_all./TFPT_al0));
V0010=var(log(TFPT_k0./TFP0_all));
V1011=var(log(TFPT_all./TFPT_k0));

figure(1)
subplot(1,2,1),plot(gridbt,mean(log(TFPT_all./TFPT_k0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt))),'r--', ...
    gridbt,mean(log(TFPT_al0./TFP0_al0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt))),'b','LineWidth',2)
axis([0 1 0 .5])
xlabel('$\beta$','Interpreter','LaTex')
title('\textbf{World Growth}','FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
ylabel('Fraction explained by trade','Interpreter','LaTex')
LEG=legend('$\alpha$ varying','$\alpha$ constant','Location','NorthWest');
set(LEG,'Interpreter','LaTex')
legend boxoff
subplot(1,2,2),plot(gridbt,1-V0010./V0011,'r--' ...
    ,gridbt,1-V0111./V0011,'b-' ...
    , gridbt,V1011./V0011,'r--s' ...
    ,gridbt,V0001./V0011,'b-s','LineWidth',2)
axis([0 1 0 .5])
% title('learning from sellers','FontSize',11)
LEG=legend('$\alpha$ varying, incl. cov.' ...
 ,'$\alpha$ constant, incl. cov.' ...
 ,'$\alpha$ varying, excl. cov.' ...
,'$\alpha$ constant, excl. cov.','Location','NorthWest');
legend boxoff
set(LEG,'Interpreter','LaTex')
xlabel('$\beta$','Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
title('\textbf{Cross-Sectional Variance}','FontSize',14,'Interpreter','LaTex')

set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.
set(gca,'FontSize',12)

return

[max(spline(gridbt,MSE_k0./std((dTFP_all)),bb)) spline(gridbt,MSE_k0./std((dTFP_all)),.75)]

figure(2)
tt=(1962:2000)';
subplot(1,2,1),plot(tt,TFP_Korea_all(1,:)/TFP_Korea_all(1,1)...
    ,tt,TFP_Korea_al0(1,:)/TFP_Korea_al0(1,1),':' ...
    ,tt,TFP_Korea_al0(5,:)/TFP_Korea_al0(5,1),'--' ...
    ,tt,TFP_Korea_al0(8,:)/TFP_Korea_al0(8,1),'-.' ...
,'LineWidth',2)
title({'Korea'},'FontSize',12)
axis([1960 2000 .8 1.6])
set(gca,'FontSize',12)

subplot(1,2,2),plot(tt,TFP_US_all(1,:)/TFP_US_all(1,1)...
    ,tt,TFP_US_al0(1,:)/TFP_US_al0(1,1),':' ...
    ,tt,TFP_US_al0(5,:)/TFP_US_al0(5,1),'--' ...
    ,tt,TFP_US_al0(8,:)/TFP_US_al0(8,1),'-.','LineWidth',2)
title({'US'},'FontSize',12)
axis([1960 2000 .8 1.6])
set(gca,'FontSize',12)
legend('data','\beta = 0','\beta = 0.5','\beta = 0.9', ...
    'Location','NorthWest')
legend boxoff

set(gcf, 'PaperPosition', [0 0 6.5 3.5]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6.5 3.5]); %Set the paper to have width 5 and height 5.

figure(3)

[b_TFP]=regress(dTFP_al0(:,1),[ones(N,1) dTFP_all(:,1)]);

subplot(1,2,1),plot(dTFP_all(:,1),dTFP_al0(:,1),'.','MarkerSize',10)
axis([-1 1 -.2 .6])
line([-1.1 1.1],[-1.1 1.1],'LineWidth',1,'LineStyle','--','Color','k')
line([-1 2],b_TFP(1)+b_TFP(2)*[-1 2],'LineWidth',2,'LineStyle','-','Color','r')
ylabel('\Delta log TFP | \alpha_t=\alpha_0')
title('\beta = 0','FontSize',11)
set(gca,'FontSize',12)
% text(-.8,.4,'\beta = 0.5')
xlabel('\Delta log TFP, data')

[b_TFP]=regress(dTFP_al0(:,7),[ones(N,1) dTFP_all(:,7)]);

subplot(1,2,2),plot(dTFP_all(:,7),dTFP_al0(:,7),'.','MarkerSize',10)
axis([-1 1 -.2 .6])
line([-1.1 1.1],[-1.1 1.1],'LineWidth',1,'LineStyle','--','Color','k')
line([-1 2],b_TFP(1)+b_TFP(2)*[-1 2],'LineWidth',2,'LineStyle','-','Color','r')
% ylabel('\Delta log TFP | \alpha_t=\alpha_0')
title({['\beta = ' num2str(gridbt(7))]},'FontSize',11)
set(gca,'FontSize',12)
xlabel('\Delta log TFP, data')

set(gcf, 'PaperPosition', [0 0 7 3.5 ]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [ 7 3.5]); %Set the paper to have width 5 and height 5.

ibt=7;
figure(4)
tt=(1962:2000)';
subplot(2,2,1),plot(tt,TFP_China_all_s(ibt,:)/TFP_China_all_s(ibt,1)...
    ,tt,TFP_China_al0_s(1,:)/TFP_China_al0_s(1,1),':' ...
    ,tt,TFP_China_al0_s(ibt,:)/TFP_China_al0_s(ibt,1),'--' ...
    ,tt,1+(TFP_China_all_s(ibt,:)-TFP_China_k0(ibt,:))/TFP_China_all_s(ibt,1),'-.','LineWidth',2)
title({'China'},'FontSize',12)
axis([1960 2000 .9 2.2])
set(gca,'FontSize',12)
legend('Data','\kappa_t, \alpha_0, \beta=0','\kappa_t, \alpha_0, \beta=0.7','data - \kappa_0, \alpha_t, \beta=0.7','Location','NorthWest')
legend boxoff

subplot(2,2,2),plot(tt,TFP_Korea_all_s(ibt,:)/TFP_Korea_all_s(ibt,1)...
    ,tt,TFP_Korea_al0_s(1,:)/TFP_Korea_al0_s(1,1),':' ...
    ,tt,TFP_Korea_al0_s(ibt,:)/TFP_Korea_al0_s(ibt,1),'--' ...
    ,tt,1+TFP_Korea_all_s(ibt,:)/TFP_Korea_all_s(ibt,1)-TFP_Korea_k0(ibt,:)/TFP_Korea_k0(ibt,1),'-.','LineWidth',2)
title({'Korea'},'FontSize',12)
axis([1960 2000 .9 2.2])
set(gca,'FontSize',12)

subplot(2,2,3),plot(tt,TFP_Taiwan_all_s(ibt,:)/TFP_Taiwan_all_s(ibt,1)...
    ,tt,TFP_Taiwan_al0_s(1,:)/TFP_Taiwan_al0_s(1,1),':' ...
    ,tt,TFP_Taiwan_al0_s(ibt,:)/TFP_Taiwan_al0_s(ibt,1),'--' ...
    ,tt,1+TFP_Taiwan_all_s(ibt,:)/TFP_Taiwan_all_s(ibt,1)-TFP_Taiwan_k0(ibt,:)/TFP_Taiwan_k0(ibt,1),'-.','LineWidth',2)
title({'Taiwan'},'FontSize',12)
axis([1960 2000 .9 2.2])
set(gca,'FontSize',12)

subplot(2,2,4),plot(tt,TFP_Thailand_all_s(ibt,:)/TFP_Thailand_all_s(ibt,1)...
    ,tt,TFP_Thailand_al0_s(1,:)/TFP_Thailand_al0_s(1,1),':' ...
    ,tt,TFP_Thailand_al0_s(ibt,:)/TFP_Thailand_al0_s(ibt,1),'--' ... 
    ,tt,1+TFP_Thailand_all_s(ibt,:)/TFP_Thailand_all_s(ibt,1)-TFP_Thailand_k0(ibt,:)/TFP_Thailand_k0(ibt,1),'-.','LineWidth',2)
title({'Thailand'},'FontSize',12)
axis([1960 2000 .9 2.2])
set(gca,'FontSize',12)

set(gcf, 'PaperPosition', [0 0 6.5 6.5]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6.5 6.5]); %Set the paper to have width 5 and height 5.


dTFP_fixed_la=log(TFP_fixed_la./TFP0_all);
dTFP_fixed_pi=log(TFP_fixed_pi./TFP0_all);

ibt=7;
figure(5)
[b_all]=regress(dTFP_al0(:,ibt),[ones(N,1) dTFP_all(:,ibt)]);
subplot(2,2,1),plot(dTFP_all(:,ibt),dTFP_al0(:,ibt),'.','MarkerSize',10)
line([-1 1],b_all(1)+b_all(2)*[-1 1],'LineStyle','-','Color','r','LineWidth',2)
axis([-1 1 -.1 .4])
ylabel('dlog(TFP(\lambda_{it}(\lambda_{-i t},\Pi_t),\pi_{iit}))','FontSize',12)
set(gca,'FontSize',12)


[b_static]=regress(dTFP_al0(:,1),[ones(N,1) dTFP_all(:,ibt)]);
subplot(2,2,2),plot(dTFP_all(:,ibt),dTFP_al0(:,1),'.','MarkerSize',10)
line([-1 1],b_static(1)+b_static(2)*[-1 1],'LineStyle','-','Color','r','LineWidth',2)
axis([-1 1 -.1 .4])
ylabel('dlog(TFP(\lambda_{i0},\pi_{iit}))','FontSize',12)
set(gca,'FontSize',12)


[b_fixed_la]=regress(dTFP_fixed_la(:,ibt),[ones(N,1) dTFP_all(:,ibt)]);
subplot(2,2,3),plot(dTFP_all(:,ibt),dTFP_fixed_la(:,ibt),'.','MarkerSize',10)
line([-1 1],b_fixed_la(1)+b_fixed_la(2)*[-1 1],'LineStyle','-','Color','r','LineWidth',2)
axis([-1 1 -.1 .4])
ylabel('dlog(TFP(\lambda_{it}(\lambda_{-i0},\Pi_t),\pi_{ii0}))','FontSize',12)
set(gca,'FontSize',12)
xlabel('dlog(TFP), data','FontSize',12)


[b_fixed_pi]=regress(dTFP_fixed_pi(:,ibt),[ones(N,1) dTFP_all(:,ibt)]);
subplot(2,2,4),plot(dTFP_all(:,ibt),dTFP_fixed_pi(:,ibt),'.','MarkerSize',10)
line([-1 1],b_fixed_pi(1)+b_fixed_pi(2)*[-1 1],'LineStyle','-','Color','r','LineWidth',2)
axis([-1 1 -.1 .4])
ylabel('dlog(TFP(\lambda_{it}(\lambda_{-it},\Pi_0),\pi_{ii0}))','FontSize',12)
set(gca,'FontSize',12)
xlabel('dlog(TFP), data','FontSize',12)

set(gcf, 'PaperPosition', [0 0 6 6]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6 6]); %Set the paper to have width 5 and height 5.


% % save trans_k0_al0_s MSE_all TFP0_all TFPT_all dTFP_all TFP_Korea_all TFP_China_all TFP_Taiwan_all TFP_Thailand_all TFP_US_all ...
% %     MSE_k0 TFP0_k0 TFPT_k0 dTFP_k0 TFP_Korea_k0 TFP_China_k0 TFP_Taiwan_k0 TFP_Thailand_k0 TFP_US_k0 ...
% %     MSE_al0 TFP0_al0 TFPT_al0 dTFP_al0 TFP_Korea_al0 TFP_China_al0 TFP_Taiwan_al0 TFP_Thailand_al0 TFP_US_al0 alpha0 alphaT ...
% %     pi_ii_0_all pi_ii_T_all pi_ii_0_k0 pi_ii_T_k0 pi_ii_0_al0 pi_ii_T_al0 ...
% %     la0_all laT_all la0_k0 laT_k0 la0_al0 laT_al0
% 
% for ibt=1:length(TFPT_all(1,:))
%     dtemp1=log(TFPT_all(:,ibt)./TFPT_k0(:,ibt));
%     MSE_2(ibt)=mean(((dtemp1-mean(dtemp1))-(dTFP_all(:,ibt)-mean(dTFP_all(:,ibt)))).^2);
% end
% 
% figure(5)
% plot(gridbt,(MSE_k0./std((dTFP_all))).^2,'b' ...
%     ,gridbt,1-(MSE_al0./std(dTFP_all)).^2,'r--','LineWidth',2)
% axis([0 1 0 .5])
% % title('learning from sellers','FontSize',11)
% legend('\kappa_t=\kappa_0,\alpha_t','\kappa_t,\alpha_t=\alpha_0','Location','NorthWest')
% legend boxoff
% xlabel('\beta')
% ylabel('Fraction explained by trade')
% set(gca,'FontSize',12)
% 
% figure(6)
% plot(gridbt,1-(MSE_al0./std(dTFP_all)).^2,'b' ...
%     ,gridbt,1-MSE_2./var(dTFP_all),'r--' ...
%     ,gridbt,var(dTFP_al0)./var(dTFP_all),'g.-' ...
%     ,gridbt,(MSE_k0./std((dTFP_all))).^2,'m:','LineWidth',2)
% axis([0 1 0 .5])
% % title('learning from sellers','FontSize',11)
% legend('measure 1','measure 2','measure 3','measure 4','Location','NorthWest')
% legend boxoff
% xlabel('\beta')
% ylabel('Fraction explained by trade')
% set(gca,'FontSize',12)
