% This file create Figure 2-6 in the main text, and  the figures in the paper
% and in the Online Appendix
clear all
close all

load names

iBEL=4;
iCHN=10;
iKOR=34;
iIND=25;
iIRL=27;
iMOZ=38;
iNLD=39;
iCHE=53;
iTWN=55;
iTHA=57;
iUSA=63;

th=4;

% save trans_k0_al0_s_02 MSE_all TFP0_all TFPT_all dTFP_all TFP_Korea_all TFP_China_all TFP_Taiwan_all TFP_Thailand_all TFP_US_all ...
%     MSE_k0 TFP0_k0 TFPT_k0 dTFP_k0 TFP_Korea_k0 TFP_China_k0 TFP_Taiwan_k0 TFP_Thailand_k0 TFP_US_k0 ...
%     MSE_al0 TFP0_al0 TFPT_al0 dTFP_al0 TFP_Korea_al0 TFP_China_al0 TFP_Taiwan_al0 TFP_Thailand_al0 TFP_US_al0 alpha0 alphaT ...
%     pi_ii_0_all pi_ii_T_all pi_ii_0_k0 pi_ii_T_k0 pi_ii_0_al0 pi_ii_T_al0 ...
%     la0_all laT_all la0_k0 laT_k0 la0_al0 laT_al0 Z_0_all Z_T_all Z_0_k0 Z_T_k0 Z_0_al0 Z_T_al0 TFP_fixed_la TFP_fixed_pi ga_bt

% load trans_k0_al0_s_02_mu_34_exp_reexports_in % version with reexports
% reassigned to original exported
load trans_k0_al0_s_02_mu_34_exp_03 % version for the main body of the paper
% load trans_k0_al0_s_02_mu_34_exp_symK % version with symmetric trade
% costs

N=length(TFP0_all(:,1));
T=length(TFP_China_all(1,:));

TFP_China_all_s=TFP_China_all;
TFP_China_al0_s=TFP_China_al0;
TFP_Korea_all_s=TFP_Korea_all;
TFP_Korea_al0_s=TFP_Korea_al0;
TFP_Taiwan_all_s=TFP_Taiwan_all;
TFP_Taiwan_al0_s=TFP_Taiwan_al0;
TFP_Thailand_all_s=TFP_Thailand_all;
TFP_Thailand_al0_s=TFP_Thailand_al0;

bb=linspace(0,.9,100);
bb2=linspace(0,.9,10);

gridbt=[0 .1 .25 .4 .5 .6 .7 .75 .9 .95];

ibt=6;

% Figure 2 in the paper
figure(1)
tt=(1962:2000)';
subplot(1,2,1),plot(tt,log(TFP_Korea_all(1,:)/TFP_Korea_all(1,1))...
    ,tt,log(TFP_Korea_al0(1,:)/TFP_Korea_al0(1,1)),':' ...
    ,tt,log(TFP_Korea_al0(ibt,:)/TFP_Korea_al0(ibt,1)),'--' ...
    ,tt,log(TFP_Korea_al0(9,:)/TFP_Korea_al0(9,1)),'-.' ...
,'LineWidth',2)
title({'\textbf{Korea}'},'FontSize',20,'Interpreter','LaTex')
axis([1960 2000 -.1 .5])
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
ylabel('$\log(\frac{TFP_t}{TFP_{1962}})$, detrended','Interpreter','LaTex','FontSize',14)
% ylabel('$\log($ detrended $ TFP_t / TFP_{1962})$','Interpreter','LaTex','FontSize',14)
% ylabel('$\log(TFP_t/TFP_{1962})$, detrended','Interpreter','LaTex','FontSize',14)

subplot(1,2,2),plot(tt,log(TFP_US_all(1,:)/TFP_US_all(1,1))...
    ,tt,log(TFP_US_al0(1,:)/TFP_US_al0(1,1)),':' ...
    ,tt,log(TFP_US_al0(ibt,:)/TFP_US_al0(ibt,1)),'--' ...
    ,tt,log(TFP_US_al0(9,:)/TFP_US_al0(9,1)),'-.','LineWidth',2)
title({'\textbf{US}'},'FontSize',20,'Interpreter','LaTex')
axis([1960 2000 -.1 .5])
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
LEG=legend('data','$\beta = 0$','$\beta = 0.6$','$\beta = 0.9$', ...
    'Location','NorthWest');
set(LEG,'Interpreter','LaTex');

legend boxoff

set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.


ibt=6;
% Figure 3 in the paper
figure(2)
tt=(1962:2000)';
subplot(2,2,1),plot(tt,log(TFP_China_all_s(ibt,:)/TFP_China_all_s(ibt,1))...
    ,tt,log(1+(TFP_China_all_s(ibt,:)-TFP_China_k0(ibt,:))/TFP_China_all_s(ibt,1)),'-.' ...
    ,tt,log(TFP_China_al0_s(ibt,:)/TFP_China_al0_s(ibt,1)),'--' ...
    ,tt,log(TFP_China_al0_s(1,:)/TFP_China_al0_s(1,1)),':','LineWidth',2)

title('\textbf{China}','FontSize',20,'Interpreter','LaTex')
axis([1960 2000 -.1 1])
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
% legend('Data','\kappa_t, \alpha_0, \beta=0','\kappa_t, \alpha_0, \beta=0.6','data - \kappa_0, \alpha_t, \beta=0.6','Location','NorthWest')
% ylabel('$\log(\frac{detrended \ TFP_t}{TFP_{1962}})$','Interpreter','LaTex','FontSize',14)
ylabel('$\log(\frac{TFP_t}{TFP_{1962}})$, detrended','Interpreter','LaTex','FontSize',14)
% ylabel('detrended TFP growth','Interpreter','LaTex')

subplot(2,2,2),plot(tt,log(TFP_Korea_all_s(ibt,:)/TFP_Korea_all_s(ibt,1))...
    ,tt,log(1+TFP_Korea_all_s(ibt,:)/TFP_Korea_all_s(ibt,1)-TFP_Korea_k0(ibt,:)/TFP_Korea_k0(ibt,1)),'-.' ...
    ,tt,log(TFP_Korea_al0_s(ibt,:)/TFP_Korea_al0_s(ibt,1)),'--' ...
    ,tt,log(TFP_Korea_al0_s(1,:)/TFP_Korea_al0_s(1,1)),':','LineWidth',2)
title({'\textbf{Korea}'},'FontSize',20,'Interpreter','LaTex')
LEG=legend('Data','Gains from trade 2, $\beta=0.6$','Gains from trade 1, $\beta=0.6$','Gains from trade, $\beta=0$','Location','NorthWest');
legend boxoff
set(LEG,'Interpreter','LaTex');
axis([1960 2000 -.1 1])
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')

subplot(2,2,3),plot(tt,log(TFP_Taiwan_all_s(ibt,:)/TFP_Taiwan_all_s(ibt,1))...
    ,tt,log(1+TFP_Taiwan_all_s(ibt,:)/TFP_Taiwan_all_s(ibt,1)-TFP_Taiwan_k0(ibt,:)/TFP_Taiwan_k0(ibt,1)),'-.' ...
    ,tt,log(TFP_Taiwan_al0_s(ibt,:)/TFP_Taiwan_al0_s(ibt,1)),'--' ...
    ,tt,log(TFP_Taiwan_al0_s(1,:)/TFP_Taiwan_al0_s(1,1)),':','LineWidth',2)
title({'\textbf{Taiwan}'},'FontSize',20,'Interpreter','LaTex')
axis([1960 2000 -.1 1])
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
ylabel('$\log(\frac{TFP_t}{TFP_{1962}})$, detrended','Interpreter','LaTex','FontSize',14)
% ylabel('detrended TFP growth','Interpreter','LaTex')

subplot(2,2,4),plot(tt,log(TFP_Thailand_all_s(ibt,:)/TFP_Thailand_all_s(ibt,1))...
    ,tt,log(1+TFP_Thailand_all_s(ibt,:)/TFP_Thailand_all_s(ibt,1)-TFP_Thailand_k0(ibt,:)/TFP_Thailand_k0(ibt,1)),'-.' ...
    ,tt,log(TFP_Thailand_al0_s(ibt,:)/TFP_Thailand_al0_s(ibt,1)),'--' ... 
    ,tt,log(TFP_Thailand_al0_s(1,:)/TFP_Thailand_al0_s(1,1)),':','LineWidth',2)
title({'\textbf{Thailand}'},'FontSize',20,'Interpreter','LaTex')
axis([1960 2000 -.1 1])
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')

set(gcf, 'PaperPosition', [0 0 6.5 6.5]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [6.5 6.5]); %Set the paper to have width 5 and height 5.

index=(log(TFPT_al0(:,1) ./ TFP0_al0(:,1))>=.0069);

% Figure 4 in the paper
figure(3)
ii=1:N;
X=pi_ii_0_all(:,1);
Y=log(TFPT_al0(:,ibt) ./ TFP0_al0(:,ibt))./log(TFPT_al0(:,1) ./ TFP0_al0(:,1));
% Y=log(TFPT_all(:,ibt) ./ TFPT_k0(:,ibt))./log(TFPT_al0(:,1) ./ TFP0_al0(:,1));
plot(X(index),Y(index),'o')
xlabel('initial own trade share, $\pi_{ii,0}$','Interpreter','LaTex')
% ylabel('dynamic multiplier, $\frac{\Delta \log TFP(\alpha_0,\kappa_t)|\beta=0.6}{\Delta \log TFP(\alpha_0,\kappa_t)|\beta = 0}$','Interpreter','LaTex')
% ylabel('dynamic multiplier, $\frac{\log[TFP(\alpha_0,\kappa_t)/TFP(\alpha_0,\kappa_0)]|\beta=0.6}{\log[TFP(\alpha_0,\kappa_t)/TFP(\alpha_0,\kappa_0)]|\beta = 0}$','Interpreter','LaTex')
ylabel('gains from trade, $\beta=0.6$ / gains from trade, $\beta = 0$','Interpreter','LaTex')
% plot(pi_ii_0_all(index,1),log(TFPT_all(index,ibt) ./ TFPT_k0(index,ibt))./log(TFPT_al0(index,1) ./ TFP0_al0(index,1)),'o')
text(X(iCHN)-.005,Y(iCHN)+.2,'CHN')
text(X(iKOR)-.005,Y(iKOR)+.2,'KOR')
text(X(iTWN)-.005,Y(iTWN)+.2,'TWN')
text(X(iTHA)-.005,Y(iTHA)+.2,'THA')
% text(X(iMOZ)-.005,Y(iMOZ)+.2,'MOZ')
text(X(iIND)-.005,Y(iIND)-.2,'IND')
text(X(iUSA)-.005,Y(iUSA)+.2,'USA')
text(X(iBEL)+.001,Y(iBEL)+.2,'BEL')
text(X(iIRL)-.007,Y(iIRL)+.2,'IRL')
text(X(iNLD)-.005,Y(iNLD)+.2,'NLD')
text(X(iCHE)-.005,Y(iCHE)+.2,'CHE')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')

set(gcf, 'PaperPosition', [0 0 7 7]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 7]); %Set the paper to have width 5 and height 5.

% Figure 5 in the paper
figure(4)
xlow=-2;
xhigh=2.502;
ylow=-1;
yhigh=1.501;


X=[ones(N,1) dTFP_all(:,1)];
[b_TFP_bt_00 b_TFP_int R_TFP]=regress(log(TFPT_all(:,1) ./ TFPT_k0(:,1)),X);
temp=(R_TFP'*R_TFP)*inv(X'*X)/(N-2);
sb_TFP_bt_00=diag(temp).^.5;

subplot(1,2,1),plot(dTFP_all(:,1),log(TFPT_all(:,1) ./ TFPT_k0(:,1)),'.','MarkerSize',10)
axis([-1 1 -.2 .6])
% axis([-1 1 -.2 .6]/(T-1))
line([-1.1 1.1],[-1.1 1.1],'LineWidth',1,'LineStyle','--','Color','k')
line([-1 2],b_TFP_bt_00(1)+b_TFP_bt_00(2)*[-1 2],'LineWidth',2,'LineStyle','-','Color','r')
% ylabel('\Delta log TFP | \alpha_t=\alpha_0')
% ylabel('$\log [TFP(\alpha_0,\kappa_T)/TFP(\alpha_0,\kappa_0)]$','Interpreter','LaTex')
ylabel('$\log \frac{TFP(\alpha_t,\kappa_t)}{TFP(\alpha_t,\kappa_0)}$','Interpreter','LaTex')
% ylabel('$\Delta \log TFP$, model','Interpreter','LaTex')
% title('\beta = 0','FontSize',11)
% title({['$\beta = $ ' num2str(gridbt(1))]},'FontSize',12,'Interpreter','LaTex')
title({['\textbf{Static} ($\beta = $ ' num2str(gridbt(1)) ')']},'FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
% text(-.8,.4,'\beta = 0.5')
% xlabel('\Delta log TFP, data')
xlabel('$\Delta \log TFP$, data, detrended','Interpreter','LaTex')
text(-.9,.5,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_TFP_bt_00(2))))},'Interpreter','LaTex','FontSize',10)

ibt=6; % beta=0.6
% ibt=7; % beta=0.7
X=[ones(N,1) dTFP_all(:,7)];
[b_TFP_bt_70b b_TFP_int R_TFP]=regress(log(TFPT_all(:,ibt) ./ TFPT_k0(:,ibt)),X);
temp=(R_TFP'*R_TFP)*inv(X'*X)/(N-2);
sb_TFP_bt_70=diag(temp).^.5;

subplot(1,2,2),plot(dTFP_all(:,ibt),log(TFPT_all(:,ibt) ./ TFPT_k0(:,ibt)),'.','MarkerSize',10)
axis([-1 1 -.2 .6])
line([-1.1 1.1],[-1.1 1.1],'LineWidth',1,'LineStyle','--','Color','k')
line([-1 2],b_TFP_bt_70b(1)+b_TFP_bt_70b(2)*[-1 2],'LineWidth',2,'LineStyle','-','Color','r')
% ylabel('$\log [TFP(\alpha_T,\kappa_T)/TFP(\alpha_T,\kappa_0)]$','Interpreter','LaTex')
% ylabel('$\log \frac{TFP(\alpha_T,\kappa_T)}{TFP(\alpha_T,\kappa_0)}$','Interpreter','LaTex')
title({['\textbf{Dynamic} ($\beta = $ ' num2str(gridbt(ibt)) ')']},'FontSize',14,'Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
xlabel('$\Delta \log TFP$, data, detrended','Interpreter','LaTex')
text(-.9,.5,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_TFP_bt_70b(2))))},'Interpreter','LaTex','FontSize',10)
% text(-.9,.45,{strcat('$1-\frac{MSE}{var(\Delta \log TFP)}$  =  ',num2str(sprintf('%0.2f',1-V0010(ibt)/V0011(ibt))))},'Interpreter','LaTex','FontSize',10)

set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.



% TFP0_all=TFP0_all([1:34 36:N],:);
% TFP0_al0=TFP0_al0([1:34 36:N],:);
% TFP0_k0=TFP0_k0([1:34 36:N],:);
% TFPT_all=TFPT_all([1:34 36:N],:);
% TFPT_al0=TFPT_al0([1:34 36:N],:);
% TFPT_k0=TFPT_k0([1:34 36:N],:);

V0011=var(log(TFPT_all./TFP0_all));
V0001=var(log(TFPT_al0./TFP0_all));
V0111=var(log(TFPT_all./TFPT_al0));
V0010=var(log(TFPT_k0./TFP0_all));
V1011=var(log(TFPT_all./TFPT_k0));

% Figure 6 in the paper
figure(5)
subplot(1,2,1),plot(gridbt,mean(log(TFPT_all./TFPT_k0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt))),'r--', ...
    gridbt,mean(log(TFPT_al0./TFP0_al0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt))),'b','LineWidth',2)
axis([0 1 0 0.5])
xlabel('$\beta$','Interpreter','LaTex')
title('\textbf{World Growth}','FontSize',12,'Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
ylabel('Fraction explained by trade','Interpreter','LaTex')
temp=mean(log(TFPT_all./TFPT_k0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt)));
text(gridbt(8),temp(8)+.05,'$\alpha$ fixed','Interpreter','LaTex')
temp=mean(log(TFPT_al0./TFP0_al0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt)));
text(gridbt(8),temp(8)-.11,'$\alpha$ varying','Interpreter','LaTex')

% legend('\alpha varying','\alpha constant','Location','NorthWest')
% legend boxoff
subplot(1,2,2),plot(gridbt,1-V0010./V0011,'r--' ...
    ,gridbt,1-V0111./V0011,'b-' ...
    , gridbt,V1011./V0011,'r--s' ...
    ,gridbt,V0001./V0011,'b-s','LineWidth',2)
axis([0 1 0 0.5])
% title('learning from sellers','FontSize',11)
% legend('\alpha varying, incl. cov.' ...
%  ,'\alpha constant, incl. cov.' ...
%  ,'\alpha varying, excl. cov.' ...
% ,'\alpha constant, excl. cov.','Location','North')
% legend boxoff
temp=1-V0010./V0011;
text(gridbt(7)-.2,temp(7)+.025,'$\alpha$ varying, w/ cov.','Interpreter','LaTex')
temp=1-V0111./V0011;
text(gridbt(7)-.2,temp(7)+.035,'$\alpha$ fixed, w/ cov.','Interpreter','LaTex')
temp=V1011./V0011;
text(gridbt(7)-.2,temp(7)+.025,'$\alpha$ varying, w/o cov.','Interpreter','LaTex')
temp=V0001./V0011
text(gridbt(7)-.2,temp(7)-.04,'$\alpha$ fixed, w/o cov.','Interpreter','LaTex')


xlabel('$\beta$','Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
title('\textbf{Cross-Sectional Variance}','FontSize',14,'Interpreter','LaTex')

% set(gcf, 'PaperPosition', [0 0 7.5 4.5]); %Position plot at left hand corner with width 5 and height 5.
% set(gcf, 'PaperSize', [7.5 4.5]); %Set the paper to have width 5 and height 5.
set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.
set(gca,'FontSize',12)

% these are figures from the Online Appendix

% Figure OA.6 in the online appendix. This figure illustrates the role of 
% changes in trade exposure 

figure(7)
xlow=-2;
xhigh=2.502;
ylow=-1;
yhigh=1.501;


X=[ones(N,1) dTFP_all(:,1)];
[b_TFP_bt_00 b_TFP_int R_TFP]=regress(log(TFPT_al0(:,1) ./ TFP0_al0(:,1)),X);
temp=(R_TFP'*R_TFP)*inv(X'*X)/(N-2);
sb_TFP_bt_00=diag(temp).^.5;

X=dTFP_all(:,1);
Y=log(TFPT_al0(:,1) ./ TFP0_al0(:,1));

subplot(1,3,1),plot(X,Y,'.','MarkerSize',10)
axis([-1 1 -.1 .2])
% axis([-1 1 -.2 .6]/(T-1))
line([-1.1 1.1],[-1.1 1.1],'LineWidth',1,'LineStyle','--','Color','k')
line([-1 2],b_TFP_bt_00(1)+b_TFP_bt_00(2)*[-1 2],'LineWidth',2,'LineStyle','-','Color','r')
% ylabel('\Delta log TFP | \alpha_t=\alpha_0')
% ylabel('$\log [TFP(\alpha_0,\kappa_T)/TFP(\alpha_0,\kappa_0)]$','Interpreter','LaTex')
ylabel('$\log \frac{TFP(\lambda_{0},\Pi_t)}{TFP(\lambda_{0},\Pi_0)}$','Interpreter','LaTex')
% ylabel('$\Delta \log TFP$, model','Interpreter','LaTex')
% title('\beta = 0','FontSize',11)
% title({['$\beta = $ ' num2str(gridbt(1))]},'FontSize',12,'Interpreter','LaTex')
title({['Static']},'FontSize',12,'Interpreter','LaTex')
set(gca,'FontSize',12)
% text(-.8,.4,'\beta = 0.5')
% xlabel('\Delta log TFP, data')
xlabel('$\Delta \log TFP$, data','Interpreter','LaTex')
text(-.9,.5,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_TFP_bt_00(2))))},'Interpreter','LaTex','FontSize',10)
text(X(iCHN)-.1,Y(iCHN)+.01,'CHN')
text(X(iKOR)-.1,Y(iKOR)+.01,'KOR')
text(X(iTWN)-.1,Y(iTWN)+.01,'TWN')
text(X(iTHA)-.1,Y(iTHA)+.01,'THA')


ibt=6;

X=[ones(N,1) dTFP_all(:,1)];
[b_TFP_bt_00 b_TFP_int R_TFP]=regress(log(TFPT_exp_fixed_Z(:,ibt)./TFP0_exp_fixed_Z(:,ibt)) -log(TFPT_al0(:,1)./TFP0_al0(:,1)),X);
temp=(R_TFP'*R_TFP)*inv(X'*X)/(N-2);
sb_TFP_bt_00=diag(temp).^.5;

X=dTFP_all(:,1);
Y=log(TFPT_exp_fixed_Z(:,ibt)./TFP0_exp_fixed_Z(:,ibt)) -log(TFPT_al0(:,1)./TFP0_al0(:,1));

subplot(1,3,2),plot(X,Y,'.','MarkerSize',10)
axis([-1 1 -.1 .2])
% axis([-1 1 -.2 .6]/(T-1))
line([-1.1 1.1],[-1.1 1.1],'LineWidth',1,'LineStyle','--','Color','k')
line([-1 2],b_TFP_bt_00(1)+b_TFP_bt_00(2)*[-1 2],'LineWidth',2,'LineStyle','-','Color','r')
% ylabel('\Delta log TFP | \alpha_t=\alpha_0')
% ylabel('$\log [TFP(\alpha_0,\kappa_T)/TFP(\alpha_0,\kappa_0)]$','Interpreter','LaTex')
ylabel('$\log \frac{TFP(\lambda_{t}(\Pi_t^{FE},\alpha_{0}),\Pi_t)}{TFP(\lambda_{0},\Pi_t)}$','Interpreter','LaTex')
% ylabel('$\Delta \log TFP$, model','Interpreter','LaTex')
% title('\beta = 0','FontSize',11)
% title({['$\beta = $ ' num2str(gridbt(1))]},'FontSize',12,'Interpreter','LaTex')
title({['Dynamic, fixed exposure']},'FontSize',12,'Interpreter','LaTex')
set(gca,'FontSize',12)
% text(-.8,.4,'\beta = 0.5')
% xlabel('\Delta log TFP, data')
xlabel('$\Delta \log TFP$, data','Interpreter','LaTex')
text(-.9,.5,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_TFP_bt_00(2))))},'Interpreter','LaTex','FontSize',10)
text(X(iCHN)-.1,Y(iCHN)+.01,'CHN')
text(X(iKOR)-.1,Y(iKOR)+.01,'KOR')
text(X(iTWN)-.1,Y(iTWN)+.01,'TWN')
text(X(iTHA)-.1,Y(iTHA)+.01,'THA')


X=[ones(N,1) dTFP_all(:,1)];
[b_TFP_bt_00 b_TFP_int R_TFP]=regress(log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt))-log(TFPT_exp_fixed_Z(:,ibt)./TFP0_exp_fixed_Z(:,ibt)) ,X);
temp=(R_TFP'*R_TFP)*inv(X'*X)/(N-2);
sb_TFP_bt_00=diag(temp).^.5;

X=dTFP_all(:,1);
Y=log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt))-log(TFPT_exp_fixed_Z(:,ibt)./TFP0_exp_fixed_Z(:,ibt));

subplot(1,3,3),plot(X,Y,'.','MarkerSize',10)
axis([-1 1 -.1 .2])
% axis([-1 1 -.2 .6]/(T-1))
line([-1.1 1.1],[-1.1 1.1],'LineWidth',1,'LineStyle','--','Color','k')
line([-1 2],b_TFP_bt_00(1)+b_TFP_bt_00(2)*[-1 2],'LineWidth',2,'LineStyle','-','Color','r')
% ylabel('\Delta log TFP | \alpha_t=\alpha_0')
% ylabel('$\log [TFP(\alpha_0,\kappa_T)/TFP(\alpha_0,\kappa_0)]$','Interpreter','LaTex')
ylabel('$\log \frac{TFP(\lambda_{t}(\Pi_t,\alpha_{0}),\Pi_t)}{TFP(\lambda_{t}(\Pi_t^{FE},\alpha_{0}),\Pi_t)}$','Interpreter','LaTex')
% ylabel('$\Delta \log TFP$, model','Interpreter','LaTex')
% title('\beta = 0','FontSize',11)
% title({['$\beta = $ ' num2str(gridbt(1))]},'FontSize',12,'Interpreter','LaTex')
title({['Dynamic, variable exposure']},'FontSize',12,'Interpreter','LaTex')
set(gca,'FontSize',12)
% text(-.8,.4,'\beta = 0.5')
% xlabel('\Delta log TFP, data')
xlabel('$\Delta \log TFP$, data','Interpreter','LaTex')
text(-.9,.5,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_TFP_bt_00(2))))},'Interpreter','LaTex','FontSize',10)
text(X(iCHN)-.1,Y(iCHN)+.01,'CHN')
text(X(iKOR)-.1,Y(iKOR)+.01,'KOR')
text(X(iTWN)-.1,Y(iTWN)+.01,'TWN')
text(X(iTHA)-.1,Y(iTHA)+.01,'THA')

ibt=6; % beta=0.6

% Figure OA.13 in the online appendix,reduced form relationship between 
% openness and TFP growth in model generated data

figure(8)
rango=linspace(min(log(pi_ii_T_al0(:,ibt)./pi_ii_0_al0(:,ibt))) ...
    ,max(log(pi_ii_T_al0(:,ibt)./pi_ii_0_al0(:,ibt))),1000);
X=[ones(N,1) log(pi_ii_T_al0(:,ibt)./pi_ii_0_al0(:,ibt))];
[b_fig1b b_fig1b_int R_fig1b]=regress(log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)) ...
    ,X);
temp=(R_fig1b'*R_fig1b)*inv(X'*X)/(N-2);
sb_fig1b=diag(temp).^.5;
subplot(1,3,1),plot(log(pi_ii_T_al0(:,ibt)./pi_ii_0_al0(:,ibt)) ...
    ,log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),'.','MarkerSize',10)
xlabel('$\Delta \log \pi_{ii}$','FontSize',12,'Interpreter','LaTex')
ylabel('$\Delta \log TFP$','FontSize',12,'Interpreter','LaTex')
title({'Change in openness',' '},'FontSize',12)
set(gca,'FontSize',11)
line(rango,[b_fig1b(1)+b_fig1b(2)*rango],'LineWidth',2,'Color','r')
axis([-.3 .1 -.5 .5])
text(-.26,-.4,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_fig1b(2)))), ...
    [blanks(13) strcat('(',num2str(sprintf('%0.2f',sb_fig1b(2))),')')]},'FontSize',10,'Interpreter','LaTex')
set(gca,'TickLabelInterpreter','latex')

% piT_0_al0 piT_T_al0 piNT_0_al0 piNT_T_al0

piNT=piNT_0_al0(:,ibt);
piNTb=piNT_T_al0(:,ibt);
piT=reshape(piT_0_al0(:,ibt),N,N);
piTb=reshape(piT_T_al0(:,ibt),N,N);

rango=linspace(min(((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(TFP0_al0(:,ibt))) ...
    ,max(((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(TFP0_al0(:,ibt))),1000);
X=[ones(N,1) ((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(TFP0_al0(:,ibt))];
[b_fig2b b_fig2b_int R_fig2b]=regress(log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)) ...
    ,X);
temp=(R_fig2b'*R_fig2b)*inv(X'*X)/(N-2);
sb_fig2b=diag(temp).^.5;
subplot(1,3,2),plot(((diag(piNTb)+piTb)-(diag(piNT)+piT))*log(TFP0_al0(:,ibt)) ...
    ,log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),'.','MarkerSize',10)
xlabel('$(\Delta \Pi) \log TFP_0$','FontSize',12,'Interpreter','LaTex')
title({'Change in the','quality of trade'},'FontSize',12)
set(gca,'FontSize',11)
line(rango,[b_fig2b(1)+b_fig2b(2)*rango],'LineWidth',2,'Color','r')
axis([-.06 .06 -.5 .5])
text(-0.025,-.4,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_fig2b(2)))), ...
    [blanks(11) strcat('(',num2str(sprintf('%0.2f',sb_fig2b(2))),')')]},'FontSize',10,'Interpreter','LaTex')
set(gca,'TickLabelInterpreter','latex')

PIothers=diag(piNT)+piT-diag(diag(diag(piNT)+piT));
PIothers=PIothers./(sum(PIothers')'*ones(1,N));
PIothersb=diag(piNTb)+piTb-diag(diag(diag(piNTb)+piTb));
PIothersb=PIothersb./(sum(PIothersb')'*ones(1,N));


xmin=min((PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt)));
xmax=max((PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt)));

rango=linspace(xmin,xmax,1000);
% X=[ones(N,1) ...
%     (PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt))./(PIothers*TFP0_al0(:,ibt))];
% [b_fig3b b_fig3b_int R_fig3b]=regress(log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),X);    
% temp=(R_fig3b'*R_fig3b)*inv(X'*X)/(N-2);
% sb_fig3b=diag(temp).^.5;
% subplot(1,3,3),plot((PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt))./(PIothers*TFP0_al0(:,ibt)) ...
%     ,log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),'.','MarkerSize',10)
X=[ones(N,1) ...
    (PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt))];
[b_fig3b b_fig3b_int R_fig3b]=regress(log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),X);    
temp=(R_fig3b'*R_fig3b)*inv(X'*X)/(N-2);
sb_fig3b=diag(temp).^.5;
subplot(1,3,3),plot((PIothers)*(TFPT_al0(:,ibt)-TFP0_al0(:,ibt)) ...
    ,log(TFPT_al0(:,ibt)./TFP0_al0(:,ibt)),'.','MarkerSize',10)
line(rango,[b_fig3b(1)+b_fig3b(2)*rango],'LineWidth',2,'Color','r')
% xlabel(' $\Pi_0 \Delta \log TFP)/(\Pi_0 TFP_0)$','FontSize',12,'Interpreter','LaTex')
xlabel(' $\Pi_0 \Delta \log TFP $','FontSize',12,'Interpreter','LaTex')
title({'Change in','partners'' TFP'},'FontSize',12)
set(gca,'FontSize',11)
axis([0.02 .08 -.5 .5])
text(.05,-.4,{strcat('slope  =  ',num2str(sprintf('%0.2f',b_fig3b(2)))), ...
    [blanks(13) strcat('(',num2str(sprintf('%0.2f',sb_fig3b(2))),')')]},'FontSize',10,'Interpreter','LaTex')
set(gca,'TickLabelInterpreter','latex')

% set(gcf, 'PaperPosition', [0 0 7 7]); %Position plot at left hand corner with width 5 and height 5.
% set(gcf, 'PaperSize', [7 7]); %Set the paper to have width 5 and height 5.
set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.

load trans_k0_al0_s_02_non_tradables_3_2_2017


V0011=var(log(TFPT_all./TFP0_all));
V0001=var(log(TFPT_al0./TFP0_all));
V0111=var(log(TFPT_all./TFPT_al0));
V0010=var(log(TFPT_k0./TFP0_all));
V1011=var(log(TFPT_all./TFPT_k0));

% Figure OA.2 in the online appendix

figure(9)
subplot(1,2,1),plot(gridbt,mean(log(TFPT_all./TFPT_k0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt))),'r--', ...
    gridbt,mean(log(TFPT_al0./TFP0_al0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt))),'b','LineWidth',2)
axis([0 1 0 0.5])
xlabel('$\beta$','Interpreter','LaTex')
title('\textbf{World Growth}','FontSize',12,'Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
ylabel('Fraction explained by trade','Interpreter','LaTex')
% temp=mean(log(TFPT_all./TFPT_k0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt)));
% text(gridbt(8),temp(8)+.05,'$\alpha$ fixed','Interpreter','LaTex')
% temp=mean(log(TFPT_al0./TFP0_al0))./(mean(log(TFPT_all./TFP0_all))+(T-1)*ga_bt./(th.*(1-gridbt)));
% text(gridbt(8),temp(8)-.11,'$\alpha$ varying','Interpreter','LaTex')

LEG=legend('$\alpha$ varying','$\alpha$ constant','Location','NorthWest');
legend boxoff
set(LEG,'Interpreter','LaTex')

subplot(1,2,2),plot(gridbt,1-V0010./V0011,'r--' ...
    ,gridbt,1-V0111./V0011,'b-' ...
    , gridbt,V1011./V0011,'r--s' ...
    ,gridbt,V0001./V0011,'b-s','LineWidth',2)
axis([0 1 0 0.5])
% title('learning from sellers','FontSize',11)
LEG=legend('$\alpha$ varying, incl. cov.' ...
 ,'$\alpha$ constant, incl. cov.' ...
 ,'$\alpha$ varying, excl. cov.' ...
,'$\alpha$ constant, excl. cov.','Location','North');
legend boxoff
set(LEG,'Interpreter','LaTex')

% temp=1-V0010./V0011;
% text(gridbt(7)-.2,temp(7)+.025,'$\alpha$ varying, w/ cov.','Interpreter','LaTex')
% temp=1-V0111./V0011;
% text(gridbt(7)-.2,temp(7)+.035,'$\alpha$ fixed, w/ cov.','Interpreter','LaTex')
% temp=V1011./V0011;
% text(gridbt(7)-.2,temp(7)+.025,'$\alpha$ varying, w/o cov.','Interpreter','LaTex')
% temp=V0001./V0011
% text(gridbt(7)-.2,temp(7)-.02,'$\alpha$ fixed, w/o cov.','Interpreter','LaTex')


xlabel('$\beta$','Interpreter','LaTex')
set(gca,'FontSize',12)
set(gca,'TickLabelInterpreter','latex')
title('\textbf{Cross-Sectional Variance}','FontSize',14,'Interpreter','LaTex')

% set(gcf, 'PaperPosition', [0 0 7.5 4.5]); %Position plot at left hand corner with width 5 and height 5.
% set(gcf, 'PaperSize', [7.5 4.5]); %Set the paper to have width 5 and height 5.
set(gcf, 'PaperPosition', [0 0 7 3]); %Position plot at left hand corner with width 5 and height 5.
set(gcf, 'PaperSize', [7 3]); %Set the paper to have width 5 and height 5.
set(gca,'FontSize',12)

