clear all
set type double

//cd "C:/Users/g1bxi01/Documents/ProjectsMicro/paco_2014-10-19"
cd "C:\Users\g1asa01\Dropbox (Research)\Noisy Idea Flows, Trade\data\wtf_bilat"

/** prepare trade codes data **/
// import excel using "rawdata/trade codes.xlsx", firstrow clear
import excel using "trade codes 2.xlsx", firstrow clear
rename NBERUNtradedata country
rename B code

// get rid of weird formatting
replace code = "481560" if country=="China"
replace code = "532760" if country=="Germany"
replace code = "454580" if country=="Malaysia"
keep country code
destring country code, replace

// create new id variable
gen id = _n
order id code country

// create two merging datasets
keep id code country

preserve
rename id iid
rename code icode
rename country icty
tempfile mi
save `mi', replace
restore

rename id eid
rename code ecode
rename country ecty
tempfile me
save `me', replace

clear


/** load trade data **/
// use rawdata/wtf_bilat.dta, clear
use wtf_bilat.dta, clear




// complete imports for India for 2000 using data in comtrade_India_1998_2000.xlsx

preserve 
clear

//import data for 2000 from comtrade because missing in wtf_bilat

//name corrections
import excel using "comtrade_name_corrections.xlsx"
rename A Partner
rename B partner_corrected
save comtrade_name_corrections, replace


//import data from comtrade and make name corrections
import excel using "comtrade_India_1998_2000.xlsx", firstrow clear
keep if TradeFlow == "Import" & Year == 2000
merge m:1 Partner using comtrade_name_corrections
replace partner_corrected = Partner if missing(partner_corrected)
rename Reporter importer
rename partner_corrected exporter
rename _merge _correction_merge
gen icode = "453560"
keep icode importer exporter Year TradeFlow TradeValueUS _correction_merge
save comtrade_India_2000, replace
clear
restore

merge m:1 icode importer exporter using comtrade_India_2000
rename _merge _comtrade_merge
drop if _comtrade_merge == 2

replace TradeValueUS = TradeValueUS/1000
replace TradeValueUS = value00 if missing(TradeValueUS)
rename TradeValueUS value00_comtrade

drop value00
rename value00_comtrade value00

/**testing whether comtrade data seems accurate**/
/*
//98 test
preserve 
clear

import excel using "comtrade_India_1998_2000.xlsx", firstrow clear
keep if TradeFlow == "Import" & Year == 1998
merge m:1 Partner using comtrade_name_corrections
replace partner_corrected = Partner if missing(partner_corrected)
rename Reporter importer
rename partner_corrected exporter
rename _merge _correction_merge
gen icode = "453560"
keep icode importer exporter Year TradeFlow TradeValueUS _correction_merge
save comtrade_India_1998, replace
clear
restore

merge m:1 icode importer exporter using comtrade_India_1998
rename _merge _comtrade_merge98
drop if _comtrade_merge98 == 2

replace TradeValueUS = TradeValueUS/1000
replace TradeValueUS = value98 if missing(TradeValueUS)
rename TradeValueUS value98_comtrade



//99 test
preserve 
clear

import excel using "comtrade_India_1998_2000.xlsx", firstrow clear
keep if TradeFlow == "Import" & Year == 1999
merge m:1 Partner using comtrade_name_corrections
replace partner_corrected = Partner if missing(partner_corrected)
rename Reporter importer
rename partner_corrected exporter
rename _merge _correction_merge
gen icode = "453560"
keep icode importer exporter Year TradeFlow TradeValueUS _correction_merge
save comtrade_India_1999, replace
clear
restore

merge m:1 icode importer exporter using comtrade_India_1999
rename _merge _comtrade_merge99
drop if _comtrade_merge99 == 2

replace TradeValueUS = TradeValueUS/1000
replace TradeValueUS = value99 if missing(TradeValueUS)
rename TradeValueUS value99_comtrade


//scatter value98 value98_comtrade if importer == "India" & exporter != "World"

//scatter value99 value99_comtrade if importer == "India" & exporter != "World"
*/


destring icode ecode, replace

/** combine small countries into larger countries **/
// combine Chinese
// replace icode = 481560 if inlist(icode, 453440, 481561, 481562)
// replace ecode = 481560 if inlist(ecode, 453440, 481561, 481562)

// combine German
replace icode = 532760 if inlist(icode, 582780, 532800)
replace ecode = 532760 if inlist(ecode, 582780, 532800)

// combine Malaysia and Singapore
// replace icode = 454580 if inlist(icode, 457020)
// replace ecode = 454580 if inlist(ecode, 457020)

// collapse them
collapse (sum) value*, by(icode ecode)

/** keep only needed countries **/
joinby icode using `mi'
joinby ecode using `me'

order iid eid icode ecode icty ecty

/** enter all importer exporter cross products **/
fillin iid eid
rename _fillin _added_pair

joinby iid using `mi', update
joinby eid using `me', update

order iid eid icode ecode icty ecty _added_pair

/** save **/
la var iid "Importer ID Code"
la var eid "Exporter ID Code"
la var icode "Importer Code"
la var ecode "Exporter Code"
la var icty "Importer Country"
la var ecty "Exporter Country"
la var _added_pair "=1 if this importer-exporter pair was added by the code"
foreach v of varlist value* {
	la var `v' ""
}

la data "Dataset prepared, 2015-05-14"

quietly compress
save data_2015-05-14, replace

replace value62=0.00001 if value62==0 | value62==.
replace value63=0.00001 if value63==0 | value63==.
replace value64=0.00001 if value64==0 | value64==.
replace value65=0.00001 if value65==0 | value65==.
replace value66=0.00001 if value66==0 | value66==.
replace value67=0.00001 if value67==0 | value67==.
replace value68=0.00001 if value68==0 | value68==.
replace value69=0.00001 if value69==0 | value69==.
replace value70=0.00001 if value70==0 | value70==.
replace value71=0.00001 if value71==0 | value71==.
replace value72=0.00001 if value72==0 | value72==.
replace value73=0.00001 if value73==0 | value73==.
replace value74=0.00001 if value74==0 | value74==.
replace value75=0.00001 if value75==0 | value75==.
replace value76=0.00001 if value76==0 | value76==.
replace value77=0.00001 if value77==0 | value77==.
replace value78=0.00001 if value78==0 | value78==.
replace value79=0.00001 if value79==0 | value79==.
replace value80=0.00001 if value80==0 | value80==.
replace value81=0.00001 if value81==0 | value81==.
replace value82=0.00001 if value82==0 | value82==.
replace value83=0.00001 if value83==0 | value83==.
replace value84=0.00001 if value84==0 | value84==.
replace value85=0.00001 if value85==0 | value85==.
replace value86=0.00001 if value86==0 | value86==.
replace value87=0.00001 if value87==0 | value87==.
replace value88=0.00001 if value88==0 | value88==.
replace value89=0.00001 if value89==0 | value89==.
replace value90=0.00001 if value90==0 | value90==.
replace value91=0.00001 if value91==0 | value91==.
replace value92=0.00001 if value92==0 | value92==.
replace value93=0.00001 if value93==0 | value93==.
replace value94=0.00001 if value94==0 | value94==.
replace value95=0.00001 if value95==0 | value95==.
replace value96=0.00001 if value96==0 | value96==.
replace value97=0.00001 if value97==0 | value97==.
replace value98=0.00001 if value98==0 | value98==.
replace value99=0.00001 if value99==0 | value99==.
replace value00=0.00001 if value00==0 | value00==.

replace value62=0 if icode==ecode
replace value63=0 if icode==ecode
replace value64=0 if icode==ecode
replace value65=0 if icode==ecode
replace value66=0 if icode==ecode
replace value67=0 if icode==ecode
replace value68=0 if icode==ecode
replace value69=0 if icode==ecode
replace value70=0 if icode==ecode
replace value71=0 if icode==ecode
replace value72=0 if icode==ecode
replace value73=0 if icode==ecode
replace value74=0 if icode==ecode
replace value75=0 if icode==ecode
replace value76=0 if icode==ecode
replace value77=0 if icode==ecode
replace value78=0 if icode==ecode
replace value79=0 if icode==ecode
replace value80=0 if icode==ecode
replace value81=0 if icode==ecode
replace value82=0 if icode==ecode
replace value83=0 if icode==ecode
replace value84=0 if icode==ecode
replace value85=0 if icode==ecode
replace value86=0 if icode==ecode
replace value87=0 if icode==ecode
replace value88=0 if icode==ecode
replace value89=0 if icode==ecode
replace value90=0 if icode==ecode
replace value91=0 if icode==ecode
replace value92=0 if icode==ecode
replace value93=0 if icode==ecode
replace value94=0 if icode==ecode
replace value95=0 if icode==ecode
replace value96=0 if icode==ecode
replace value97=0 if icode==ecode
replace value98=0 if icode==ecode
replace value99=0 if icode==ecode
replace value00=0 if icode==ecode

drop icode ecode icty ecty _added_pair

outsheet using trade3.txt, nonames replace

copy "C:\Users\g1asa01\Dropbox (Research)\Noisy Idea Flows, Trade\data\wtf_bilat\trade3.txt" /*
*/ "C:\Users\g1asa01\Dropbox (Research)\Noisy Idea Flows, Trade\mfiles\quantitative\trade3.txt", replace

// outsheet using trade2.txt, nonames replace

// outfile using trade.dat, nolabel replace
